package net.sourceforge.jFuzzyLogic.demo.invertedPendulum.block;

import java.io.InputStream;
import java.util.List;

import net.sourceforge.jFuzzyLogic.FunctionBlock;
import net.sourceforge.jFuzzyLogic.demo.invertedPendulum.FuzzyController;
import net.sourceforge.jFuzzyLogic.rule.Variable;

/**
 *
 * @author pjl
 */
public class BlockFuzzyController extends FuzzyController {

	private Variable dxdt;
	private Variable force;
	private FunctionBlock functionBlock;
	private Variable x;

	public BlockFuzzyController(BlockModel model, InputStream file) {
		super(file, model);
	}

	@Override
	public void control() {
		if( functionBlock == null ) return;
		double X, DXDT;

		BlockModel model = (BlockModel) this.model;

		x.setValue(X = model.getX());
		dxdt.setValue(DXDT = model.getDxdt());

		functionBlock.evaluate();

		double dp = force.getLatestDefuzzifiedValue();
		if( Double.isNaN(dp) ) {
			dp = 0.0; //   double dp1=dpull.getValue();
			System.out.println("NaN" + X + "  " + "  " + DXDT + dp);
		}
		model.setForce(dp);
	}

	@Override
	public List<Variable> getVariables() {
		throw new UnsupportedOperationException("Not supported yet.");
	}

	@Override
	protected void init() {
		if( fis == null ) return;
		functionBlock = fis.getFunctionBlock(null);
		x = functionBlock.getVariable("x");
		dxdt = functionBlock.getVariable("dxdt");
		force = functionBlock.getVariable("force");
	}

	@Override
	public String showState() {
		String str = "x=" + x.getValue() + "  dxdt=" + dxdt.getValue() + "\n";
		return str + force.toString();
	}
//
//    private Variable x;
//    private Variable dxdt;
//    private Variable force;
//    private FunctionBlock functionBlock;
//    private double targetX=0.0;
//
//    public BlockFuzzyController(BlockModel model, InputStream file) {
//        super(file,model);
//    }
//
//
//    protected void init() {
//        if ( fis == null) return;
//        functionBlock=fis.getFunctionBlock(null);
//        variables.clear();
//        variables.add(x    = functionBlock.getVariable("x"));
//        variables.add(dxdt = functionBlock.getVariable("dxdt"));
//        variables.add(force = functionBlock.getVariable("force"));
//    }
//
//    public void control() {
//        if (functionBlock == null) return;
//        double X, DXDT;
//
//        BlockModel bmodel=(BlockModel)this.model;
//
//        x.setValue(X = bmodel.getX()-targetX);
//        dxdt.setValue(DXDT = bmodel.getDxdt());
//
//
//        functionBlock.evaluate();
//
//        double dp = force.getLatestDefuzzifiedValue();
//        if (Double.isNaN(dp)) {
//            dp = 0.0;        //   double dp1=dpull.getValue();
//            System.out.println("NaN" + X + "  " + "  "+  DXDT + dp);
//        }
//        bmodel.setForce(dp);
//
//
//    // Show output variable's chart
//    //	fuzzyRuleSet.getVariable("tip").chartDefuzzifier(true);
//
//    // Print ruleSet
//    //	System.out.println(fuzzyRuleSet);
//    }
//
//    @Override
//    public String  showState() {
//       String str= "x="+ x.getValue() +  "  dxdt="+    dxdt.getValue() + "\n";
//       return str+force.toString();
//    }
//
//
    public void setTargetPosition(double x) {
        ((BlockModel)model).setX(x); //targetX=x;
    }
    
//    @Override
//    public List<Variable> getVariables() {
//        throw new UnsupportedOperationException("Not supported yet.");
//    }
//   
    
}
