package org.eclipse.linuxtools.lttng.SYSHEALTHPRO.Prevention.Response;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.tm.tcf.protocol.IChannel;
import org.eclipse.tm.tcf.protocol.IToken;
import org.eclipse.tm.tcf.services.IProcesses;
import org.eclipse.tm.tcf.services.IProcesses.ProcessContext;

/**
 * Change the ownership of a file to root
 */

public class RMChangeFileOwnership implements IReactiveMeasures {
	static public String Name = "RM_CHANGE_FILE_OWNERSHIP";
	static public int Id = 10;
	static public double Risk_threshold = 0.6;
    
    private final IProcesses  processes;
    private final String filePath;


    public RMChangeFileOwnership(IChannel channel, String filePath) {
            
        processes = channel.getRemoteService(IProcesses.class);
        this.filePath = filePath; 
         
    }
    		
	private String[] toArgsArray(String file, String cmd) {
        // Create arguments list from a command line.
        int i = 0;
        int l = cmd.length();
        List<String> arr = new ArrayList<String>();
        arr.add(file);
        for (;;) {
            while (i < l && cmd.charAt(i) == ' ') i++;
            if (i >= l) break;
            String s = null;
            if (cmd.charAt(i) == '"') {
                i++;
                StringBuffer bf = new StringBuffer();
                while (i < l) {
                    char ch = cmd.charAt(i++);
                    if (ch == '"') break;
                    if (ch == '\\' && i < l) ch = cmd.charAt(i++);
                    bf.append(ch);
                }
                s = bf.toString();
            }
            else {
                int i0 = i;
                while (i < l && cmd.charAt(i) != ' ') i++;
                s = cmd.substring(i0, i);
            }
            arr.add(s);
        }
        return arr.toArray(new String[arr.size()]);
	}

	@Override
	public void start() {
		// TODO Auto-generated method stub
		final String dir = "/home/";
		final String file = "/bin/chown";
	    final String args = "root:users " + filePath;
	    
	    processes.start(dir, file, toArgsArray(file, args), null , false, new IProcesses.DoneStart() {      	  
				public void doneStart(IToken token, Exception error, ProcessContext process) {
					System.out.println(error.toString());
				}		
			});
		System.out.println(Name + " with " + Risk_threshold + " threshold was run");
		
	}
	
}
