package org.eclipse.linuxtools.lttng.SYSHEALTHPRO.Prevention;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.DecimalFormat;

import org.eclipse.linuxtools.lttng.SYSPRO.ui.Connect;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.ToolBar;
import org.eclipse.swt.widgets.ToolItem;
import org.eclipse.ui.part.ViewPart;


public class ResponseNegativeValueLevelView extends ViewPart {

	public static final String ID = "org.eclipse.ui.tutorials.rcp.part3.ResponseNegativeValueLevelView";
	int DM_No= 0;
	int RC_No=0;
	
	public void createPartControl(Composite parent) {
		Composite top = new Composite(parent, SWT.NONE | SWT.V_SCROLL);
        DecimalFormat df = new  DecimalFormat ("0.##");

		GridLayout layout = new GridLayout();
		layout.marginHeight = 0;
		layout.marginWidth = 0;
		top.setLayout(layout);
		// top banner
		Composite banner = new Composite(top, SWT.NONE);
		banner.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_FILL, GridData.VERTICAL_ALIGN_BEGINNING, true, false));
		layout = new GridLayout();
		layout.marginHeight = 0;
		layout.marginWidth = 0;
		layout.numColumns = 2;
		banner.setLayout(layout);

		// Create Toolbar
	    Image insert_icon = new Image(null, "/home/alireza/TCF/org.eclipse.linuxtools.lttng.SYSPRO/icons/insert_object.png");
	    Image edit_icon = new Image(null, "/home/alireza/TCF/org.eclipse.linuxtools.lttng.SYSPRO/icons/edit_object.png");
	    Image delete_icon = new Image(null, "/home/alireza/TCF/org.eclipse.linuxtools.lttng.SYSPRO/icons/delete_object.png");

	    
		ToolBar toolBar = new ToolBar (banner, SWT.FLAT | SWT.BORDER);
		ToolItem itemInsert = new ToolItem (toolBar, SWT.DROP_DOWN | SWT.PUSH);
		//itemInsert.setText("Insert");
		itemInsert.setImage(insert_icon);
		itemInsert.setToolTipText("Insert");
		ToolItem itemUpdate = new ToolItem (toolBar, SWT.PUSH);
		//itemUpdate.setText("Update");
		itemUpdate.setImage(edit_icon);
		itemUpdate.setToolTipText("Edit");
		ToolItem itemDelete = new ToolItem (toolBar, SWT.PUSH);
		//itemDelete.setText("Delete");
		itemDelete.setImage(delete_icon);
		itemDelete.setToolTipText("Delete");


		toolBar.pack (); 
		
		
		// The relative importance weights of the all criteria by all decision makers
		Label label_C = new Label(top, SWT.BORDER);
		label_C.setText("The relative importance weights of the all criteria by all decision makers");
		Table t_CW = new Table(top, SWT.BORDER);
		
		// Set Column Header
		Connect c = new Connect();
		TableColumn tc1 = new TableColumn(t_CW, SWT.CENTER);
		tc1.setWidth(250);


		ResultSet rs = null;
		int i=1;

		
		try {
			rs = c.Query("select * from DecisionMakers order by Id");
		} catch (SQLException e) {
			e.printStackTrace();
		}
		try {
			while (rs.next ())
			{
				String NameVal = rs.getString ("Name");
				
				TableColumn tc = new TableColumn(t_CW, SWT.CENTER);
				tc.setText("D" + i +" = " + NameVal);
				tc.setWidth(250);
				i++;

			}
		} catch (SQLException e) {
			e.printStackTrace();
		}

		TableColumn tc2 = new TableColumn(t_CW, SWT.CENTER);
		tc2.setText("Deffuzification of combined weights");
		tc2.setWidth(250);
		
		t_CW.setHeaderVisible(true);
		
		// Fetch Data
		
		rs = null;
		DM_No= i-1;
		int count= 0;
		i = 1;
		int j = 0;
		double value1 = 0, value2 = 0, value3 = 0, D_Value = 0;
		
		String CheckName = ""; 
		
		try {
			rs = c.Query("select ResponseCriteria.Name, DecisionMakers.Name, CriteriaLinguisticVariables.Name, " +
					"CriteriaLinguisticVariables.Value1, CriteriaLinguisticVariables.Value2, CriteriaLinguisticVariables.Value3 " +
					"from ResponseCriteriaWeight, ResponseCriteria, DecisionMakers, CriteriaLinguisticVariables where " +
					"ResponseCriteriaWeight.ResponseCriteria_Id = ResponseCriteria.Id and ResponseCriteriaWeight.DecisionMaker_Id = DecisionMakers.Id " +
					"and ResponseCriteriaWeight.Linguistic_Variable_Id = CriteriaLinguisticVariables.Id " +
					"and ResponseCriteria.negative = 1 " +
					"order by ResponseCriteriaWeight.ResponseCriteria_Id, ResponseCriteriaWeight.DecisionMaker_Id ");
		} catch (SQLException e) {
			e.printStackTrace();
		}
		try {
			while (rs.next ())
			{
				String CriteriaNameVal = rs.getString ("ResponseCriteria.Name");
				String CriteriaLinguisticVariablesVal = rs.getString ("CriteriaLinguisticVariables.Name");
				
				
				
				if (!CheckName.equals(CriteriaNameVal)) {
					TableItem item1 = new TableItem(t_CW, SWT.NONE);
					item1.setText(new String[] { "C" + i +" = " + CriteriaNameVal,CriteriaLinguisticVariablesVal});
					i++;
					j = 2;
					CheckName = CriteriaNameVal;
					value1 = Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value1"));
					value2 = Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value2"));
					value3 = Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value3"));
					D_Value = (value1 + value2 * 2 + value3)/4;
					count++;

				}
				else {
					TableItem item1 = t_CW.getItem(i-2);
					if (count == (DM_No-1)) {
				        value1 = Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value1"));
						value2 = Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value2"));
						value3 = Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value3"));
						D_Value += (value1 + value2 * 2 + value3)/4;
						D_Value = D_Value/DM_No;
						item1.setText(j, CriteriaLinguisticVariablesVal);
						item1.setText(j+1, df.format(D_Value));
						count= 0;
					}
					else {
						item1.setText(j, CriteriaLinguisticVariablesVal);
						value1 = Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value1"));
						value2 = Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value2"));
						value3 = Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value3"));
						D_Value += (value1 + value2 * 2 + value3)/4;

						count++;
					}
					j++;
				}
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		t_CW.pack();

		// Set the number of response criteria
		rs = null;
		try {
			rs = c.Query("SELECT COUNT(*) FROM ResponseCriteria WHERE Negative = 1");
			rs.next();
			RC_No = rs.getInt(1);
		} catch (SQLException e) {
			e.printStackTrace();
		}
		// The ratings of the all Responses by decision makers under all criteria
		Label label_RV = new Label(top, SWT.BORDER);
		label_RV.setText("The ratings of the all responses by decision makers under all criteria");
		Table t_R_DM = new Table(top, SWT.BORDER);
		
		// Set Column Header
		TableColumn tc1_RV = new TableColumn(t_R_DM, SWT.CENTER);
		TableColumn tc2_RV = new TableColumn(t_R_DM, SWT.CENTER);
		
		tc1_RV.setText("Criteria");
		tc2_RV.setText("Response Name");

		tc1_RV.setWidth(200);
		tc2_RV.setWidth(200);


		rs = null;
		i=1;
		DM_No= 0;
		
		try {
			rs = c.Query("select * from DecisionMakers order by Id");
		} catch (SQLException e) {
			e.printStackTrace();
		}
		try {
			while (rs.next ())
			{
				String NameVal = rs.getString ("Name");
				
				TableColumn tc = new TableColumn(t_R_DM, SWT.CENTER);
				tc.setText("D" + i +" = " + NameVal);
				tc.setWidth(200);
				i++;

			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		TableColumn tc3_RV = new TableColumn(t_R_DM, SWT.CENTER);
		tc3_RV.setText("Aggregated fuzzy number");
		tc3_RV.setWidth(250);
		
		t_R_DM.setHeaderVisible(true);

		// Fetch Data
		
		rs = null;
		DM_No= i-1;
		count= 0;

		i = 1;
		int ItemNo= 1;
		j = 0;
		CheckName = ""; 
		value1 = 0;
		value2 = 0;
		value3 = 0;

		
		try {
			rs = c.Query("select ResponseCriteria.Name as 'Criteria Name', Response.Name as 'Response Name', RatingsLinguisticVariables.Name as 'Value' " +
					", RatingsLinguisticVariables.Value1, RatingsLinguisticVariables.Value2, RatingsLinguisticVariables.Value3 " +
					"from ResponseNegativeValue, Response, DecisionMakers, ResponseCriteria, RatingsLinguisticVariables " +
					"where ResponseNegativeValue.DecisionMaker_Id = DecisionMakers.Id " +
					"and ResponseNegativeValue.Response_Id = Response.Id " +
					"and ResponseNegativeValue.ResponseCriteria_Id = ResponseCriteria.Id " +
					"and ResponseNegativeValue.Linguistic_Variable_Id = RatingsLinguisticVariables.Id " +
					"order by Response.Id, ResponseCriteria.Id, DecisionMakers.Id");
		} catch (SQLException e) {
			e.printStackTrace();
		}
		try {
			while (rs.next ())
			{
				String CriteriaNameVal = rs.getString ("Criteria Name");
				String ResponseNameVal = rs.getString ("Response Name");
				String ValueVal = rs.getString ("Value");

				if (!CheckName.equals(CriteriaNameVal)) {
					TableItem item1 = new TableItem(t_R_DM, SWT.NONE);
					if (i == (RC_No+1)) i= 1;
					item1.setText(new String[] { "C" + i +" = " + CriteriaNameVal, ResponseNameVal, ValueVal});
					i++;
					ItemNo++;
					j = 3;
					CheckName = CriteriaNameVal;
					value1 = Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value1"));
					value2 = Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value2"));
					value3 = Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value3"));
					count++;
				}
				else {
					TableItem item1 = t_R_DM.getItem(ItemNo-2);
				
					if (count == (DM_No-1)) {
				        value1 += Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value1"));
						value2 += Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value2"));
						value3 += Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value3"));
						value1 = value1/DM_No;
						value2 = value2/DM_No;
						value3 = value3/DM_No;
						item1.setText(j, ValueVal);
						item1.setText(j+1, "(" + df.format(value1) + ", " + df.format(value2) + ", " + df.format(value3) + ")");
						count= 0;
					}
					else {
						item1.setText(j, ValueVal);
						value1 += Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value1"));
						value2 += Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value2"));
						value3 += Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value3"));
						count++;
					}
					j++;
				}
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		t_R_DM.pack();
		
		// The fuzzy weighted normalized decision matrix
		Label label_FWN_DM = new Label(top, SWT.BORDER);
		label_FWN_DM.setText("The fuzzy weighted normalized decision matrix");
		final Table t1 = new Table(top, SWT.BORDER);
		
		TableColumn tc4 = new TableColumn(t1, SWT.CENTER);
		tc4.setWidth(250);

		rs = null;
		i=1;
		
		try {
			rs = c.Query("select * from ResponseCriteria where Negative = 1 order by Id");
		} catch (SQLException e) {
			e.printStackTrace();
		}
		try {
			while (rs.next ())
			{
				String NameVal = rs.getString ("Name");
				
				TableColumn tc = new TableColumn(t1, SWT.CENTER);
				tc.setText("C" + i +" = " + NameVal);
				tc.setWidth(250);
				i++;

			}
		} catch (SQLException e) {
			e.printStackTrace();
		}

		TableColumn item_FV = new TableColumn(t1, SWT.CENTER);
		item_FV.setText("Fuzzification values");
		item_FV.setWidth(150);

		TableColumn item_DV = new TableColumn(t1, SWT.CENTER);
		item_DV.setText("Defuzzification values");
		item_DV.setWidth(150);
					
		// 
		int criteria;
		int k;
		Double ThirdValue = 0.0;
		TableItem  criteria_Item;
		TableItem  response_criteria_Item;
		String  criteria_name, criteria_value;
		int counter;
		for (criteria = 0; criteria < t_CW.getItemCount(); criteria++) {
			
			criteria_Item = t_CW.getItem(criteria);
			criteria_name = criteria_Item.getText(0);
			criteria_value = criteria_Item.getText(4);
			
			counter = 0;
			Double max = 0.0;

			for (k = 0; k < t_R_DM.getItemCount(); k++) {
				response_criteria_Item = t_R_DM.getItem(k);
				if (response_criteria_Item.getText(0).contains(criteria_name)) {
					ThirdValue = getFuzzyValue(response_criteria_Item.getText(5),3);
					if (ThirdValue > max) max = ThirdValue;
				}
			}
			
			for (k = 0; k < t_R_DM.getItemCount(); k++) {
				response_criteria_Item = t_R_DM.getItem(k);
				if (response_criteria_Item.getText(0).contains(criteria_name)) {
					if (criteria == 0 ) {
						// create row
						TableItem item1 = new TableItem(t1, SWT.NONE);
						
						value1 = (getFuzzyValue(response_criteria_Item.getText(5),1)/max) * Double.parseDouble(criteria_value);
						value2 = (getFuzzyValue(response_criteria_Item.getText(5),2)/max) * Double.parseDouble(criteria_value);
						value3 = (getFuzzyValue(response_criteria_Item.getText(5),3)/max) * Double.parseDouble(criteria_value);
						
						item1.setText(new String[] { response_criteria_Item.getText(1),  "(" + df.format(value1) + ", " + df.format(value2) + ", " + df.format(value3) + ")"});
					} else {
						value1 = (getFuzzyValue(response_criteria_Item.getText(5),1)/max) * Double.parseDouble(criteria_value);
						value2 = (getFuzzyValue(response_criteria_Item.getText(5),2)/max) * Double.parseDouble(criteria_value);
						value3 = (getFuzzyValue(response_criteria_Item.getText(5),3)/max) * Double.parseDouble(criteria_value);
						TableItem item1 = t1.getItem(counter);
						counter++;
						item1.setText(criteria + 1, "(" + df.format(value1) + ", " + df.format(value2) + ", " + df.format(value3) + ")");
					}
				}
			}

		}
		
		
		t1.setHeaderVisible(true);
		t1.pack();
		
		
		// Calculate value level
		TableItem  response_Item;
		
		
		double DNmuber = 0;
		
		for (int r = 0; r < t1.getItemCount(); r++) {
			response_Item = t1.getItem(r);
			value1 = 0;
			value2 = 0;
			value3 = 0;		
			for (k = 0; k < t_CW.getItemCount(); k++) {
				value1 += getFuzzyValue(response_Item.getText(k+1),1);
				value2 += getFuzzyValue(response_Item.getText(k+1),2);
				value3 += getFuzzyValue(response_Item.getText(k+1),3);
			}

			response_Item.setText(k + 1, "(" + df.format(value1) + ", " + df.format(value2) + ", " + df.format(value3) + ")");
			DNmuber = (value1 + value2 * 2 + value3)/4;
			response_Item.setText(k + 2, df.format(DNmuber));
		}
		
			    
	 // Store results in Database
		final Button btn_store = new Button(top, SWT.PUSH);
		btn_store.setBounds(40, 50, 50, 20);
		btn_store.setText("Store Results");
		btn_store.addSelectionListener(new SelectionListener() {
			public void widgetSelected(SelectionEvent e) {
				String IdVal = null;
				
				TableItem  response_Item;
				
				// delete previous calculation
				Connect c_delete = new Connect();
				try {
					c_delete.Insert("delete from ResponseNegativeValueLevel");
				} catch (SQLException e2) {
					e2.printStackTrace();
				}
				
				for (int r = 0; r < t1.getItemCount(); r++) {
					Connect c = new Connect();
					ResultSet rs = null;

					response_Item = t1.getItem(r);
					// get response id
					try {
						rs = c.Query("select * from Response where name='"+ response_Item.getText(0) + "'");
					} catch (SQLException e1) {
						e1.printStackTrace();
					}
					try {
						while (rs.next ())
						{
							IdVal = rs.getString ("Id");
						}
					} catch (SQLException e1) {
						e1.printStackTrace();
					}
					// insert
					try {
						c.Insert("insert into ResponseNegativeValueLevel values(" + IdVal +"," + response_Item.getText(RC_No+2) + ")");
					} catch (SQLException e1) {
						e1.printStackTrace();
					}
				}	
			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				
			}
		 });
	    
		
	}

	public Double getFuzzyValue(String str, int index) {
		int frs_ch, trd_ch;
		
		

		if (index == 1) {
			
			frs_ch = str.indexOf(",");
			return Double.parseDouble(str.substring(1, frs_ch)); 
			
		} else if (index == 2) {
			
			str = str.replaceFirst(",", "-");
			frs_ch = str.indexOf("-");
			trd_ch = str.indexOf(",");
			return Double.parseDouble(str.substring(frs_ch + 1, trd_ch));
			
		} else {
			
			str = str.replaceFirst(",", "-");
			frs_ch = str.indexOf(",");
			trd_ch = str.indexOf(")");
			return Double.parseDouble(str.substring(frs_ch + 1, trd_ch)); 

		}
			
	}
	public void setFocus() {
	}
}
