package org.eclipse.linuxtools.lttng.SYSHEALTHPRO.Prevention;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.DecimalFormat;

import org.eclipse.linuxtools.lttng.SYSPRO.ui.Connect;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.ToolBar;
import org.eclipse.swt.widgets.ToolItem;
import org.eclipse.ui.part.ViewPart;


public class ResponsePositiveValueView extends ViewPart {

	public static final String ID = "org.eclipse.ui.tutorials.rcp.part3.ResponsePositiveValueView";
	ResultSet rs = null;
	Connect c = new Connect();

	public void createPartControl(Composite parent) {
		Composite top = new Composite(parent, SWT.NONE);
		GridLayout layout = new GridLayout();
		layout.marginHeight = 0;
		layout.marginWidth = 0;
		top.setLayout(layout);
		// top banner
		Composite banner = new Composite(top, SWT.NONE);
		banner.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_FILL, GridData.VERTICAL_ALIGN_BEGINNING, true, false));
		layout = new GridLayout();
		layout.marginHeight = 0;
		layout.marginWidth = 0;
		layout.numColumns = 2;
		banner.setLayout(layout);

		// Create Toolbar
	    Image insert_icon = new Image(null, "/home/alireza/TCF/org.eclipse.linuxtools.lttng.SYSPRO/icons/insert_object.png");
	    Image edit_icon = new Image(null, "/home/alireza/TCF/org.eclipse.linuxtools.lttng.SYSPRO/icons/edit_object.png");
	    Image delete_icon = new Image(null, "/home/alireza/TCF/org.eclipse.linuxtools.lttng.SYSPRO/icons/delete_object.png");

	    
		ToolBar toolBar = new ToolBar (banner, SWT.FLAT | SWT.BORDER);
		ToolItem itemInsert = new ToolItem (toolBar, SWT.DROP_DOWN | SWT.PUSH);
		//itemInsert.setText("Insert");
		itemInsert.setImage(insert_icon);
		itemInsert.setToolTipText("Insert");
		ToolItem itemUpdate = new ToolItem (toolBar, SWT.PUSH);
		//itemUpdate.setText("Update");
		itemUpdate.setImage(edit_icon);
		itemUpdate.setToolTipText("Edit");
		ToolItem itemDelete = new ToolItem (toolBar, SWT.PUSH);
		//itemDelete.setText("Delete");
		itemDelete.setImage(delete_icon);
		itemDelete.setToolTipText("Delete");


		toolBar.pack ();
		
		// Set the number of Vulnerability criteria
		int RC_No= 0; 
		rs = null;
		try {
			rs = c.Query("SELECT COUNT(*) FROM ResponseCriteria WHERE Positive = 1");
			rs.next();
			RC_No = rs.getInt(1);
		} catch (SQLException e) {
			e.printStackTrace();
		}
		// Create table
		Table t = new Table(top, SWT.BORDER);
		
		// Set Column Header
		TableColumn tc1 = new TableColumn(t, SWT.CENTER);
		TableColumn tc2 = new TableColumn(t, SWT.CENTER);
		
		tc1.setText("Criteria");
		tc2.setText("Response Name");

		tc1.setWidth(200);
		tc2.setWidth(200);


		rs = null;
		int i=1;
		int DM_No= 0;
		
		try {
			rs = c.Query("select * from DecisionMakers order by Id");
		} catch (SQLException e) {
			e.printStackTrace();
		}
		try {
			while (rs.next ())
			{
				String NameVal = rs.getString ("Name");
				
				TableColumn tc = new TableColumn(t, SWT.CENTER);
				tc.setText("D" + i +" = " + NameVal);
				tc.setWidth(200);
				i++;

			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		TableColumn tc3 = new TableColumn(t, SWT.CENTER);
		tc3.setText("Aggregated fuzzy number");
		tc3.setWidth(250);
		
		t.setHeaderVisible(true);

		// Fetch Data
		
		rs = null;
		DM_No= i-1;
		int count= 0;

		i = 1;
		int ItemNo= 1;
		int j = 0;
		String CheckName = ""; 
		double value1 = 0, value2 = 0, value3 = 0;

		
		try {
			rs = c.Query("select ResponseCriteria.Name as 'Criteria Name', Response.Name as 'Response Name', RatingsLinguisticVariables.Name as 'Value' " +
					", RatingsLinguisticVariables.Value1, RatingsLinguisticVariables.Value2, RatingsLinguisticVariables.Value3 " +
					"from ResponsePositiveValue, Response, DecisionMakers, ResponseCriteria, RatingsLinguisticVariables " +
					"where ResponsePositiveValue.DecisionMaker_Id = DecisionMakers.Id " +
					"and ResponsePositiveValue.Response_Id = Response.Id " +
					"and ResponsePositiveValue.ResponseCriteria_Id = ResponseCriteria.Id " +
					"and ResponsePositiveValue.Linguistic_Variable_Id = RatingsLinguisticVariables.Id " +
					"order by Response.Id, ResponseCriteria.Id, DecisionMakers.Id");
		} catch (SQLException e) {
			e.printStackTrace();
		}
		try {
			while (rs.next ())
			{
				String CriteriaNameVal = rs.getString ("Criteria Name");
				String ResponseNameVal = rs.getString ("Response Name");
				String ValueVal = rs.getString ("Value");

				if (!CheckName.equals(CriteriaNameVal)) {
					TableItem item1 = new TableItem(t, SWT.NONE);
					if (i == (RC_No+1)) i= 1;
					item1.setText(new String[] { "C" + i +" = " + CriteriaNameVal, ResponseNameVal, ValueVal});
					i++;
					ItemNo++;
					j = 3;
					CheckName = CriteriaNameVal;
					value1 = Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value1"));
					value2 = Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value2"));
					value3 = Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value3"));
					count++;
				}
				else {
					TableItem item1 = t.getItem(ItemNo-2);
				
					if (count == (DM_No-1)) {
				        DecimalFormat df = new  DecimalFormat ("0.##");
				        value1 += Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value1"));
						value2 += Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value2"));
						value3 += Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value3"));
						value1 = value1/DM_No;
						value2 = value2/DM_No;
						value3 = value3/DM_No;
						item1.setText(j, ValueVal);
						item1.setText(j+1, "(" + df.format(value1) + ", " + df.format(value2) + ", " + df.format(value3) + ")");
						count= 0;
					}
					else {
						item1.setText(j, ValueVal);
						value1 += Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value1"));
						value2 += Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value2"));
						value3 += Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value3"));
						count++;
					}
					j++;
				}
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		t.pack();

	}

	public void setFocus() {
	}
}
