package org.eclipse.linuxtools.lttng.SYSPRO.AlertOptimization;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.DecimalFormat;

import org.eclipse.linuxtools.lttng.SYSPRO.ui.Connect;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.ToolBar;
import org.eclipse.swt.widgets.ToolItem;
import org.eclipse.ui.part.ViewPart;


public class AlertCorrelationView extends ViewPart {

	public static final String ID = "org.eclipse.ui.tutorials.rcp.part3.AlertCorrelation2View";
	Connect c = new Connect();
	int Alert_NO = 0;

	public void createPartControl(Composite parent) {
		Composite top = new Composite(parent, SWT.NONE);
        DecimalFormat df2 = new  DecimalFormat ("0.##");
        DecimalFormat df3 = new  DecimalFormat ("0.###");

		GridLayout layout = new GridLayout();
		layout.marginHeight = 0;
		layout.marginWidth = 0;
		top.setLayout(layout);
		// top banner
		Composite banner = new Composite(top, SWT.NONE);
		banner.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_FILL, GridData.VERTICAL_ALIGN_BEGINNING, true, false));
		layout = new GridLayout();
		layout.marginHeight = 0;
		layout.marginWidth = 0;
		layout.numColumns = 2;
		banner.setLayout(layout);

		// Create Toolbar
	    Image insert_icon = new Image(null, "/home/alireza/TCF/org.eclipse.linuxtools.lttng.SYSPRO/icons/insert_object.png");
	    Image edit_icon = new Image(null, "/home/alireza/TCF/org.eclipse.linuxtools.lttng.SYSPRO/icons/edit_object.png");
	    Image delete_icon = new Image(null, "/home/alireza/TCF/org.eclipse.linuxtools.lttng.SYSPRO/icons/delete_object.png");

	    
		ToolBar toolBar = new ToolBar (banner, SWT.FLAT | SWT.BORDER);
		ToolItem itemInsert = new ToolItem (toolBar, SWT.DROP_DOWN | SWT.PUSH);
		//itemInsert.setText("Insert");
		itemInsert.setImage(insert_icon);
		itemInsert.setToolTipText("Insert");
		ToolItem itemUpdate = new ToolItem (toolBar, SWT.PUSH);
		//itemUpdate.setText("Update");
		itemUpdate.setImage(edit_icon);
		itemUpdate.setToolTipText("Edit");
		ToolItem itemDelete = new ToolItem (toolBar, SWT.PUSH);
		//itemDelete.setText("Delete");
		itemDelete.setImage(delete_icon);
		itemDelete.setToolTipText("Delete");


		toolBar.pack ();
		
		// Create table
		final Table t = new Table(top, SWT.BORDER);
		
		// Set Column Header
		//Connect c = new Connect();
		TableColumn tc1 = new TableColumn(t, SWT.LEFT);
		tc1.setWidth(250);

		ResultSet rs = null;
		
		try {
			rs = c.Query("select * from AlertClassification order by Id");
		} catch (SQLException e) {
			e.printStackTrace();
		}
		try {
			while (rs.next ())
			{
				String idVal = rs.getString ("Id");
				
				TableColumn tc = new TableColumn(t, SWT.CENTER);
				tc.setText(idVal);
				tc.setWidth(55);
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}

		TableColumn tc2 = new TableColumn(t, SWT.CENTER);
		tc2.setText("Effect");
		tc2.setWidth(80);
		
		TableColumn tc3 = new TableColumn(t, SWT.CENTER);
		tc3.setText("Normalize");
		tc3.setWidth(80);
		
		t.setHeaderVisible(true);

		// Set Alert count
		rs = null;
		
		int rowCount_AlertClassification = -1;

		try {
			rs = c.Query("SELECT COUNT(*) FROM AlertClassification");
			rs.next();
			Alert_NO = rs.getInt(1);
		} catch (SQLException e) {
			e.printStackTrace();
		}
			
		// Fetch Data
		
		rs = null;
		int i;
		int row = 0;
		int which = 0;
		TableItem  resource_Item = null;

		for (i=1; i<= Alert_NO; i++) {
			try {
				row = 0;
				rs = c.Query("select AlertCorrelation.*, AC1.Name as Name1, AC2.Name as Name2 from AlertCorrelation, AlertClassification as AC1, AlertClassification as AC2 " +
						"where AlertCorrelation.AlertId1 = AC1.Id and AlertCorrelation.AlertId2 = AC2.Id and AlertCorrelation.AlertId1=" + i +
						" order by AlertId1, AlertId2");
				
				which = 1;
				
			} catch (SQLException e) {
				e.printStackTrace();
			}
			try {
				while (rs.next ())
				{
					
					String name1Val = rs.getString ("Name1");
					String valueVal = rs.getString ("Value");

					if (row == 0) {
						TableItem item1 = new TableItem(t, SWT.NONE);
						item1.setText(new String[] { i + ") " + name1Val});
						row = 1;
						resource_Item = t.getItem(i-1);
					} 
					
					resource_Item.setText(which,valueVal);
					which++;
					
				}
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		
		// PHASE I
		//********************************************************************************
		double sumRow = 0;
		double sum = 0;
		double normalize = 0;

		for (i= 1; i <= Alert_NO; i++) {
			sumRow = 0.0;
			resource_Item = t.getItem(i-1);

			for (int j= 1; j <= Alert_NO; j++) {
				sumRow += Double.parseDouble(resource_Item.getText(j)) * getSeverity(j);
			}
			resource_Item.setText(Alert_NO+1, df2.format(sumRow));
			sum += sumRow;
		}

		for (i= 1; i <= Alert_NO; i++) {
			resource_Item = t.getItem(i-1);
			normalize = (Double.parseDouble(resource_Item.getText(Alert_NO+1))/sum) * 100;
			resource_Item.setText(Alert_NO+2, df3.format(normalize)); 
		}
		
		t.pack();
		
		// Store results in Database
		final Button btn_store = new Button(top, SWT.PUSH);
		btn_store.setBounds(40, 50, 50, 20);
		btn_store.setText("Store Results");
		btn_store.addSelectionListener(new SelectionListener() {
			public void widgetSelected(SelectionEvent e) {
				
				TableItem  resource_Item;
				
				for (int r = 0; r < t.getItemCount(); r++) {
					Connect ci = new Connect();

					resource_Item = t.getItem(r);
					
					try {
						ci.Insert("Update AlertClassification Set NormalizedValue = " + resource_Item.getText(Alert_NO+2) + " where Id = " + (r+1));
					} catch (SQLException e1) {
						e1.printStackTrace();
					}
				}
			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				
			}
		 });

	}

	public void setFocus() {
	}
	private double getSeverity(int Id) {
		String severity = null;
		Double result = null;
		//Connect c = new Connect();
		ResultSet rs = null;
		
		try {
			rs = c.Query("select * from AlertClassification where Id =" + Id);
		} catch (SQLException e) {
			e.printStackTrace();
		}
		try {
			while (rs.next ())
			{
				severity = rs.getString ("Severity");
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		if (severity.toString().contains("Low")) {
			result = 1.0;
		} 
		if (severity.toString().contains("Medium")) {
			result =  2.0;
		} 
		if (severity.toString().contains("High")) {
			result =  3.0;
		}
		return result;
		
		
	}
}
