package org.eclipse.linuxtools.lttng.SYSPRO.AttackGraph;

import java.io.File;
import java.util.HashMap;
import java.util.TreeMap;


import org.eclipse.linuxtools.lttng.SYSPRO.RiskAssessment.RiskAssessment;
import org.eclipse.linuxtools.lttng.SYSPRO.cpu.TraceEventHandlerProcess;
import org.eclipse.linuxtools.lttng.SYSPRO.cpu.TraceEventHandlerStats;
import org.eclipse.linuxtools.lttng.SYSPRO.file.TraceEventHandlerFile;
import org.eclipse.linuxtools.lttng.SYSPRO.io.TraceReader;
import org.eclipse.linuxtools.lttng.jni.exception.JniException;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.part.ViewPart;
import org.eclipse.zest.core.widgets.Graph;
import org.eclipse.zest.core.widgets.GraphConnection;
import org.eclipse.zest.core.widgets.GraphNode;
import org.eclipse.zest.core.widgets.ZestStyles;
import org.eclipse.zest.layouts.LayoutStyles;
import org.eclipse.zest.layouts.algorithms.SpringLayoutAlgorithm;
import org.eclipse.zest.layouts.algorithms.TreeLayoutAlgorithm;


public class AttackGraphView extends ViewPart {

	public static final String ID = "org.eclipse.ui.tutorials.rcp.part3.AttackGraphView";
	private File traceDir;
	String filteredProcess;
	String filteredSyscall;
	Shell shell;


	private Graph graph;
	private int layout = 1;

	public void createPartControl(Composite parent) {
		
		ReadTrace(parent);
		
	}

	public void setLayoutManager() {
		switch (layout) {
		case 1:
			graph.setLayoutAlgorithm(new TreeLayoutAlgorithm(LayoutStyles.NO_LAYOUT_NODE_RESIZING), true);
			layout++;
			break;
		case 2:
			graph.setLayoutAlgorithm(new SpringLayoutAlgorithm(LayoutStyles.NO_LAYOUT_NODE_RESIZING), true);
			layout = 1;
			break;

		}

	}


	/**
	 * Passing the focus request to the viewer's control.
	 */

	public void setFocus() {
		
	}

		
	public void ReadTrace(Composite parent) {
		//this.traceDir = traceDir;
		//shell.setText(shell.getText() + " (" + traceDir + ")");
		
		//TraceReader reader = new TraceReader(this.traceDir.toString());
		TraceReader reader = new TraceReader("/home/alireza/Desktop/multiStepAttack/attack2/alltrace");

		TraceEventHandlerStats cpu_handler = new TraceEventHandlerStats();
		TraceEventHandlerProcess proc_handler = new TraceEventHandlerProcess();
		TraceEventHandlerFile file_handler = new TraceEventHandlerFile();
		
		
		reader.register(cpu_handler);
		reader.register(proc_handler);
		reader.register(file_handler);
		

			try {
				reader.process();
			} catch (JniException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
		DynamicAttackGraph DAC = new DynamicAttackGraph(parent);
		
		String[][] stateList = new String[10][10]; 
			
		stateList= file_handler.getStateList();
		for(int i= 0; i < 10; i++) {
			DAC.run(parent, stateList[i][0], stateList[i][1]);
		}
	}	
}
