package org.eclipse.linuxtools.lttng.SYSPRO.AttackGraph;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Set;
import java.util.TreeMap;

import org.eclipse.linuxtools.lttng.jni.JniEvent;
import org.eclipse.linuxtools.lttng.SYSPRO.dynamicfsm.State;


import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.part.ViewPart;


public class DetectionRules{
	String[][] stateList;
	int indexGraph= 0;

	AttackGraph attackGraph;
	HashMap ProcessHashMap;
	Long[][] processArray= new Long[100][2];
	int index=0;
	//private Graph graph = new Graph(parent, SWT.NONE);
    

	
	public DetectionRules () {
		attackGraph = new AttackGraph();
		ProcessHashMap= new HashMap();
		stateList = new String[10][10];

	}
	
	private boolean CheckParent(Long ProcessID, String ParentName) {
		boolean visit= false;
		int i;
		String Name;
		
		Long ProcessCheck;
		ProcessCheck= ProcessID;
		
		for (i=index-1; i> 0; i--){
			int result= processArray[i][1].compareTo(ProcessCheck);
			
			if(result== 0) {

				Name= (String) ProcessHashMap.get(processArray[i][0]);

				if(Name.contains(ParentName)) {
					visit= true;
					break;
				}
				else
					ProcessCheck= processArray[i][0];
			}
			else {
				result= processArray[i][0].compareTo(ProcessCheck);
				Name= (String) ProcessHashMap.get(processArray[i][0]);

				if(Name.contains(ParentName)) {
					visit= true;
					break;
				}
				else
					ProcessCheck= processArray[i][0];
			}
		}
		
		return visit;
	}
	
	private void RenameProcessName(Long ProcessID, String Name) {
		int i;
		
		Long ProcessCheck;
		ProcessCheck= ProcessID;
		
		/*for (i=index-1; i> 0; i--){
			int result= processArray[i][1].compareTo(ProcessCheck);
			
			if(result== 0) {

				ProcessHashMap.put(processArray[i][0], Name);
				System.out.println("Rename --> parent(" + Name +"): "+ processArray[i][0] + " child: "+ ProcessID);

			}
		}*/
		
		ProcessHashMap.put(ProcessID, Name);
		//System.out.println("Rename --> " + ProcessID + " is " + Name);
	}
	
	public void Analysis (String eventName, Long currentProcessID,Long eventTs,String filename,String currentProcessName, Long child_pid) {
		State currentState;
		
		currentState= attackGraph.getState();
		
		
	
		if (eventName.contains("kernel.process_fork")) {
			if (!ProcessHashMap.containsKey(currentProcessID)) {
				ProcessHashMap.put(currentProcessID, currentProcessName);
				//System.out.println("Create --> " + currentProcessID + " is " + currentProcessName);
			}
			
			processArray[index][0]= currentProcessID;
			processArray[index][1]= child_pid;
			index++;
			//System.out.println("ADD(parent:"+ currentProcessID + ", child: "+ child_pid + ")");
			//System.out.println();

		}
		if (currentProcessName.contains("apache")) {
			attackGraph.serviceApache();
		}
		else if (eventName.contains("fs.exec") && filename.contentEquals("/bin/sh") && currentState.equals(attackGraph.START0)) {
			if (CheckParent(currentProcessID,"apache")) {
				attackGraph.executeApacheShell();
				stateList[indexGraph][0]= "Apache";
				stateList[indexGraph++][1]= "Apache shell";
			}
		}
		else if (eventName.contains("fs.exec") && filename.contentEquals("/usr/bin/ncat")) {
			RenameProcessName(currentProcessID,"ncat");
			if (CheckParent(currentProcessID,"apache"))
				attackGraph.executeShellNcat();
		}
		else if (eventName.contains("net.socket_connect") && currentProcessName.contentEquals("/usr/bin/ncat")) {
			if (CheckParent(currentProcessID,"apache")) {
				attackGraph.connectNcatRemote();
				stateList[1][0]= "Apache shell";
				stateList[1][1]= "ncat";
			}
		}
		else if (eventName.contains("fs.exec") && filename.contentEquals("/usr/bin/wget")) {
			RenameProcessName(currentProcessID,"wget");
			if (CheckParent(currentProcessID,"ncat")) {
				attackGraph.executeNcatWget();
				stateList[2][0]= "ncat";
				stateList[2][1]= "wget";
				attackGraph.backtoNcat();
				stateList[3][0]= "wget";
				stateList[3][1]= "ncat";
			}
		}
		else if (eventName.contains("fs.exec") && filename.contentEquals("/usr/bin/wget")) {
			RenameProcessName(currentProcessID,"wget");
			if (CheckParent(currentProcessID,"apache"))
				attackGraph.executeShellWget();
		}
		else if (eventName.contains("fs.exec") && filename.contentEquals("/usr/bin/cc")) {
			RenameProcessName(currentProcessID,"cc");
			if (CheckParent(currentProcessID,"ncat")) {
				attackGraph.executeNcatcc();
				stateList[4][0]= "ncat";
				stateList[4][1]= "compile";
				attackGraph.backtoNcat();
				stateList[5][0]= "compile";
				stateList[5][1]= "ncat";
			}
		}
		else if (eventName.contains("fs.exec") && filename.contentEquals("/usr/bin/cc")) {
			RenameProcessName(currentProcessID,"cc");
			if (CheckParent(currentProcessID,"apache"))
				attackGraph.executeShellcc();
				attackGraph.backtoShell();
		}
		else if (eventName.contains("fs.exec") && filename.contentEquals("./LPE")) {
			RenameProcessName(currentProcessID,"exploit");
			if (CheckParent(currentProcessID,"ncat")) {
				attackGraph.executeNcatExploit();
				stateList[6][0]= "ncat";
				stateList[6][1]= "exploit";
			}
		}
		else if (eventName.contains("fs.exec") && filename.contentEquals("/bin/sh")) {
			if (CheckParent(currentProcessID,"exploit")) {
				attackGraph.executeExploitShell();
				stateList[7][0]= "exploit";
				stateList[7][1]= "exploit shell";
			}
		}
		else if (eventName.contains("fs.exec") && filename.contentEquals("/usr/sbin/adduser")) {
			if (CheckParent(currentProcessID,"exploit")) {
				attackGraph.executeShellUser();
				stateList[8][0]= "exploit shell";
				stateList[8][1]= "root permission";
			}
		}
	}
	
	public String[][] getStateList(){
		return stateList;
	}
	
}

