package org.eclipse.linuxtools.lttng.SYSPRO.RiskAssessment;

import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Time;
import java.text.DateFormat;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

import net.sourceforge.jFuzzyLogic.FIS;
import net.sourceforge.jFuzzyLogic.rule.Rule;

import org.eclipse.core.runtime.Platform;
import org.eclipse.linuxtools.lttng.SYSPRO.ui.Application;
import org.eclipse.linuxtools.lttng.SYSPRO.ui.Connect;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.ToolBar;
import org.eclipse.swt.widgets.ToolItem;
import org.eclipse.ui.internal.util.BundleUtility;
import org.eclipse.ui.part.ViewPart;
import org.osgi.framework.Bundle;
import org.swtchart.Chart;
import org.swtchart.IAxis;
import org.swtchart.IAxisSet;
import org.swtchart.ILineSeries;
import org.swtchart.LineStyle;
import org.swtchart.ILineSeries.PlotSymbolType;
import org.swtchart.ISeries.SeriesType;


public class MonitoringOfflineRiskIndexWithFuzzyView extends ViewPart {

	public static final String ID = "org.eclipse.ui.tutorials.rcp.part3.MonitoringOfflineRiskIndexWithFuzzyView";
	Connect c = new Connect();
	double[] AcceptableArray;
	int AcceptableFlag = 0;
	int k;
	double TotalRiskImpact = 0;
	double OldTotalRiskImpact = 0;
	double T_under= 0.5;
	double risk_initialize= 0;


	public void createPartControl(Composite parent) {
		Composite top = new Composite(parent, SWT.NONE);
		GridLayout layout = new GridLayout();
		layout.marginHeight = 0;
		layout.marginWidth = 0;
		top.setLayout(layout); 

		// banner
		Composite banner = new Composite(top, SWT.NONE);
		banner.setLayoutData(new GridData(GridData.BEGINNING, GridData.BEGINNING, true, true));
		banner.setSize(1500, 250);

		Composite bannerTime = new Composite(top, SWT.NONE);
		bannerTime.setLayoutData(new GridData(GridData.BEGINNING, GridData.BEGINNING, true, true));
		bannerTime.setSize(1500, 250);

		// Create chart for Raw Alert
		Chart chart = new Chart(banner, SWT.COLOR_CYAN);
		chart.setSize(1500, 250);
		chart.getTitle().setText("Risk Index with Fuzzy Model");
		chart.getAxisSet().getXAxis(0).getTitle().setText("Alert");
		chart.getAxisSet().getYAxis(0).getTitle().setText("Risk Index");


		IAxisSet axisSet = chart.getAxisSet();
		IAxis xAxis = axisSet.getXAxis(0);

		Chart chartTime = new Chart(bannerTime, SWT.COLOR_CYAN);
		chartTime.setSize(1500, 400);
		chartTime.getTitle().setText("Risk Index with Fuzzy Model");
		chartTime.getAxisSet().getXAxis(0).getTitle().setText("Time(s)");
		chartTime.getAxisSet().getYAxis(0).getTitle().setText("Risk Index");
		IAxisSet axisSetTime = chartTime.getAxisSet();
		IAxis xAxisTime = axisSetTime.getXAxis(0);


		// Load from 'FCL' file
		Bundle bundle = Platform.getBundle(Application.PLUGIN_ID);
		URL fullPathString = BundleUtility.find(bundle, "fcl/RiskIndex.fcl");

		InputStream istream = null;
		try {
			istream = fullPathString.openStream();
		} catch (IOException e) {
			e.printStackTrace();
		}
		FIS fis_RiskIndex = FIS.load(istream,true);
		// Error while loading?
		if( fis_RiskIndex == null ) { 
			System.err.println("Can't load file: '" 
					+ fullPathString + "'");
			// return;
		}

		fullPathString = BundleUtility.find(bundle, "fcl/Threat.fcl");

		istream = null;
		try {
			istream = fullPathString.openStream();
		} catch (IOException e) {
			e.printStackTrace();
		}
		FIS fis_threat = FIS.load(istream,true);
		// Error while loading?
		if( fis_RiskIndex == null ) { 
			System.err.println("Can't load file: '" 
					+ fullPathString + "'");
			// return;
		}

		// Set Resource Array
		ResultSet rs = null;
		
		int resourceNO = -1;

		try {
			rs = c.Query("SELECT COUNT(*) FROM Resource");
			rs.next();
			resourceNO = rs.getInt(1);
		} catch (SQLException e) {
			e.printStackTrace();
		}

		double[] resourceArray = new double[resourceNO+1];
		double[] resourceMappingArray = new double[resourceNO+1];

		for (int i=1; i <= resourceNO; i++) {
			resourceArray[i] = 0;
		}

		int count = 1;
		try {
			rs = c.Query("select * from Resource");
		} catch (SQLException e) {
			e.printStackTrace();
		}
		try {
			while (rs.next ())
			{
				String idVal = rs.getString ("Resource.Id");
				resourceMappingArray[count++] = Integer.parseInt(idVal);
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}

		// Set Alert Classification Array
		rs = null;
		int alertClassificationNO = -1;

		try {
			rs = c.Query("SELECT COUNT(*) FROM AlertClassification");
			rs.next();
			alertClassificationNO = rs.getInt(1);
		} catch (SQLException e) {
			e.printStackTrace();
		}
				
		double[] alertNumArray = new double[alertClassificationNO+1];
		double[] alertRiskImpactArray = new double[alertClassificationNO+1];

		AcceptableArray = new double[alertClassificationNO+1];

		for (int i=1; i <= alertClassificationNO; i++) {
			alertNumArray[i] = 0;
			alertRiskImpactArray[i] = 0;
		}
		
		// Calculate alert No.
		int counter = 0;
		rs = null;

		int rowCount = -1;

		try {
			rs = c.Query("SELECT COUNT(*) FROM Alert");
			rs.next();
			rowCount = rs.getInt(1);
		} catch (SQLException e) {
			e.printStackTrace();
		}

		String[] cateValues = new String[rowCount];
		double[] YValues = new double[rowCount];

		String[] cateValuesTime = new String[700];
		double[] YValuesTime = new double[700];

		double riskIdex, threatEffect;
		double freq_per_alert;

		DateFormat sdf = new SimpleDateFormat("hh:mm:ss");
		Date date;
		double starTime = 0;
		double setTime = 0;
		double oldsetTime = 0;

		int timeFlag = 0;

		for (int i=1; i < rowCount; i++) {
			cateValuesTime[i] = "";
			YValuesTime[i] = 0; 
		}

		try {
			rs = c.Query("Select Alert.Id, Alert.DetectDate, Alert.DetectTime, Alert.Confidence, AlertClassification.Severity, AlertClassification.Id as 'AlertClassificationId', Alert_Resource.ResourceId, ResourceValueLevel.Value as 'ResourceValue', VulnerabilityEffectLevel.Value as 'VulnerabilityValue', AlertClassification.Name " +
					"from Alert, AlertClassification, ResourceValueLevel, Alert_Resource, VulnerabilityEffectLevel " +
					"where Alert.AlertClassificationId= AlertClassification.Id " +
					"and AlertClassification.Id= Alert_Resource.AlertClassificationId " +
					"and Alert_Resource.ResourceId = ResourceValueLevel.Resource_Id " +
					"and ResourceValueLevel.Resource_Id = VulnerabilityEffectLevel.Resource_Id " +
					"and  DetectDate >= '" + "2012-01-02" + "' " +
					"and  DetectTime >= '" + "12:06:29" + "' " +
			"ORDER BY DetectDate, DetectTime, Alert.Id ASC");

			while (rs.next ())
			{
				
				DateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss.SSS");
				Date date1 = new Date();
				Date startProcessingTime1 = date1;
				System.out.println("Get alert: " + dateFormat.format(date1));

				// Offline values
				double resourceValueVal = Double.parseDouble(rs.getString ("ResourceValue"));
				double vulnerabilityValueVal = Double.parseDouble(rs.getString ("VulnerabilityValue"));
				// Online values

				String detectDateVal = rs.getString ("DetectDate"); // motaghayere zir gerefte shode vali kari royash anjam nashode (Future)
				String detectTimeVal = rs.getString ("DetectTime");
				double confidenceVal = Double.parseDouble(rs.getString ("Confidence"));

				try {

					date = sdf.parse(detectTimeVal); 
					if (timeFlag == 0) {
						starTime = date.getHours()* 3600 + date.getMinutes() * 60 + date.getSeconds();
						setTime = 0;
						timeFlag = 1;
					} else {
						setTime = (date.getHours()* 3600 + date.getMinutes() * 60 + date.getSeconds()) - starTime;
					}

				} catch (Exception e) {
					e.printStackTrace();
				}

				//if (rs.getString ("AlertClassification.Name").contains("Email_Almail_Overflow")) {


				double severityVal = 0;

				if (rs.getString ("Severity").toString().contains("Low")) {
					severityVal = 1;
				} 
				if (rs.getString ("Severity").contains("Medium")) {
					severityVal = 2;
				} 
				if (rs.getString ("Severity").contains("High")) {
					severityVal = 3;
				}

				int alertClassificationIdVal = Integer.parseInt(rs.getString ("AlertClassificationId"));

				//freq_per_alert = CalculateFreq_Per_Alert(alertClassificationIdVal, alertNumArray[alertClassificationIdVal]); 
				confidenceVal= 100;
				freq_per_alert = CalculateFreq_Per_Alert(alertClassificationIdVal, confidenceVal);
				alertNumArray[alertClassificationIdVal] += freq_per_alert;

				int resourceIdVal = Integer.parseInt(rs.getString ("ResourceId"));
				int k;
				for (k=1; k <= resourceNO+1; k++) {
					if (resourceMappingArray[k] == resourceIdVal) {
						resourceArray[k] += freq_per_alert;
						break;
					}
				}

				// Calculate Threat Effect
				fis_threat.setVariable("severity", severityVal);
				fis_threat.setVariable("freq_per_resource", resourceArray[k]);
				fis_threat.setVariable("freq_per_alert", alertNumArray[alertClassificationIdVal]);
				fis_threat.evaluate();
				threatEffect = fis_threat.getVariable("threat").getLatestDefuzzifiedValue();
				
				// Show each rule (and degree of support)
	            //for( Rule r : fis_threat.getFunctionBlock("ThreatEffect").getFuzzyRuleBlock("No1").getRules() )
	            //           System.out.println(r);

				// Calculate Risk Index
				fis_RiskIndex.setVariable("resource", resourceValueVal);
				fis_RiskIndex.setVariable("vulnerability", vulnerabilityValueVal);
				fis_RiskIndex.setVariable("threat",threatEffect);
				fis_RiskIndex.evaluate();
				riskIdex = fis_RiskIndex.getVariable("risk_index").getLatestDefuzzifiedValue();
				alertRiskImpactArray[alertClassificationIdVal]= riskIdex;
				
				TotalRiskImpact= risk_initialize;
				int l;
				for (l=1; l <= alertClassificationNO; l++) {
					TotalRiskImpact+= alertRiskImpactArray[l];
				}
				
				
				
				DecimalFormat df = new  DecimalFormat ("0.##");

				System.out.println("T: " + df.format(threatEffect) + "(S:" + df.format(severityVal) + ", FPR:" + df.format(resourceArray[k]) + ", FPA:" + df.format(alertNumArray[alertClassificationIdVal]) + ")");
				System.out.println("Alert " + alertClassificationIdVal + ", T: " + df.format(threatEffect) + " V: " +  df.format(vulnerabilityValueVal) +" R: " + df.format(resourceValueVal) + " --> RI: " + df.format(riskIdex));
				System.out.println("setTime:"+ setTime + " TotalRiskImpact: " + TotalRiskImpact);
				T_under= 0.25;
				/*if (TotalRiskImpact >= 1) {
					//apply response
					Date date2 = new Date();
					Date startProcessingTime2 = date1;
					System.out.println("Apply response: " + dateFormat.format(date2));
					System.out.println("Difference: " + (startProcessingTime2.getTime() - startProcessingTime1.getTime()));

					//
					risk_initialize= T_under;
					for (k=1; k <= alertClassificationNO; k++) {
						alertRiskImpactArray[k]= 0;
					}
					System.out.println("Real Attack");
				}*/
				System.out.println("----------------------------------------------------------------");

				// Set Chart values -step1
				for (k=(int) (oldsetTime+1); k <= (int) (setTime-1); k++) {
					YValues[counter-1] = OldTotalRiskImpact;
					YValuesTime[k] = OldTotalRiskImpact;
				}
				// Set Chart values -step2

				cateValues[counter] = Integer.toString(counter);
				YValues[counter] = TotalRiskImpact;

				cateValuesTime[(int) setTime] =  Double.toString(setTime);
				YValuesTime[(int) setTime] = TotalRiskImpact;
				oldsetTime= setTime;
				OldTotalRiskImpact= TotalRiskImpact;
				counter++;
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}

		xAxis.setCategorySeries(cateValues);
		ILineSeries series = (ILineSeries) chart.getSeriesSet().createSeries(SeriesType.LINE, "Severity");
		series.setLineColor(parent.getDisplay().getSystemColor(SWT.COLOR_RED));
		series.setLineStyle(LineStyle.SOLID);
		series.setYSeries(YValues);
		IAxis yAxis = axisSet.getYAxis(0);
		yAxis.adjustRange();
		xAxis.adjustRange();
		yAxis.zoomIn();
		yAxis.zoomOut();
		series.setSymbolType(PlotSymbolType.NONE);	


		xAxisTime.setCategorySeries(cateValuesTime);
		ILineSeries seriesTime = (ILineSeries) chartTime.getSeriesSet().createSeries(SeriesType.LINE, "Severity");
		seriesTime.setLineColor(parent.getDisplay().getSystemColor(SWT.COLOR_RED));
		seriesTime.setLineStyle(LineStyle.SOLID);
		seriesTime.setYSeries(YValuesTime);
		IAxis yAxisTime = axisSetTime.getYAxis(0);
		yAxisTime.adjustRange();
		xAxisTime.adjustRange();
		yAxisTime.zoomIn();
		yAxisTime.zoomOut();
		seriesTime.setSymbolType(PlotSymbolType.NONE);	

	}

	private double CalculateFreq_Per_Alert(int index, double confidence) {

		int Rowcount = 1;
		ResultSet rs = null;
		double freq = 0;

		if (AcceptableFlag == 0) {
			AcceptableFlag = 1;
			try {
				rs = c.Query("Select * from AlertClassification ORDER BY Id ASC");
			} catch (SQLException e) {
				e.printStackTrace();
			}
			try {
				while (rs.next ())
				{
					int AcceptableVal = Integer.parseInt(rs.getString ("Acceptable"));

					AcceptableArray[Rowcount++]= AcceptableVal;

				}
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		freq = (1/AcceptableArray[index]) * (confidence/100);
		return freq;	
	}

	public void setFocus() {
	}
}
