package org.eclipse.linuxtools.lttng.SYSPRO.RiskAssessment;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.DecimalFormat;

import org.eclipse.linuxtools.lttng.SYSPRO.ui.Connect;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.ToolBar;
import org.eclipse.swt.widgets.ToolItem;
import org.eclipse.ui.part.ViewPart;


public class ResourceCriteriaWeightView extends ViewPart {

	public static final String ID = "org.eclipse.ui.tutorials.rcp.part3.ResourceCriteriaWeightView";

	public void createPartControl(Composite parent) {
		Composite top = new Composite(parent, SWT.NONE);
		GridLayout layout = new GridLayout();
		layout.marginHeight = 0;
		layout.marginWidth = 0;
		top.setLayout(layout);
		// top banner
		Composite banner = new Composite(top, SWT.NONE);
		banner.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_FILL, GridData.VERTICAL_ALIGN_BEGINNING, true, false));
		layout = new GridLayout();
		layout.marginHeight = 0;
		layout.marginWidth = 0;
		layout.numColumns = 2;
		banner.setLayout(layout);

		// Create Toolbar
	    Image insert_icon = new Image(null, "/home/alireza/TCF/org.eclipse.linuxtools.lttng.SYSPRO/icons/insert_object.png");
	    Image edit_icon = new Image(null, "/home/alireza/TCF/org.eclipse.linuxtools.lttng.SYSPRO/icons/edit_object.png");
	    Image delete_icon = new Image(null, "/home/alireza/TCF/org.eclipse.linuxtools.lttng.SYSPRO/icons/delete_object.png");

	    
		ToolBar toolBar = new ToolBar (banner, SWT.FLAT | SWT.BORDER);
		ToolItem itemInsert = new ToolItem (toolBar, SWT.DROP_DOWN | SWT.PUSH);
		//itemInsert.setText("Insert");
		itemInsert.setImage(insert_icon);
		itemInsert.setToolTipText("Insert");
		ToolItem itemUpdate = new ToolItem (toolBar, SWT.PUSH);
		//itemUpdate.setText("Update");
		itemUpdate.setImage(edit_icon);
		itemUpdate.setToolTipText("Edit");
		ToolItem itemDelete = new ToolItem (toolBar, SWT.PUSH);
		//itemDelete.setText("Delete");
		itemDelete.setImage(delete_icon);
		itemDelete.setToolTipText("Delete");


		toolBar.pack ();
		
		// Create table
		Table t = new Table(top, SWT.BORDER);
		
		// Set Column Header
		Connect c = new Connect();
		TableColumn tc1 = new TableColumn(t, SWT.CENTER);
		tc1.setWidth(250);


		ResultSet rs = null;
		int i=1;
		int DM_No= 0;

		
		try {
			rs = c.Query("select * from DecisionMakers order by Id");
		} catch (SQLException e) {
			e.printStackTrace();
		}
		try {
			while (rs.next ())
			{
				String NameVal = rs.getString ("Name");
				
				TableColumn tc = new TableColumn(t, SWT.CENTER);
				tc.setText("D" + i +" = " + NameVal);
				tc.setWidth(250);
				i++;

			}
		} catch (SQLException e) {
			e.printStackTrace();
		}

		TableColumn tc2 = new TableColumn(t, SWT.CENTER);
		tc2.setText("Aggregated fuzzy number");
		tc2.setWidth(250);
		
		t.setHeaderVisible(true);
		
		// Fetch Data
		
		rs = null;
		DM_No= i-1;
		int count= 0;
		i = 1;
		int j = 0;
		double value1 = 0, value2 = 0, value3 = 0;
		
		String CheckName = ""; 
		
		try {
			rs = c.Query("select ResourceCriteria.Name, DecisionMakers.Name, CriteriaLinguisticVariables.Name, " +
					"CriteriaLinguisticVariables.Value1, CriteriaLinguisticVariables.Value2, CriteriaLinguisticVariables.Value3 " +
					"from ResourceCriteriaWeight, ResourceCriteria, DecisionMakers, CriteriaLinguisticVariables where " +
					"ResourceCriteriaWeight.ResourceCriteria_Id = ResourceCriteria.Id and ResourceCriteriaWeight.DecisionMaker_Id = DecisionMakers.Id " +
					"and ResourceCriteriaWeight.Linguistic_Variable_Id = CriteriaLinguisticVariables.Id " +
					"order by ResourceCriteriaWeight.ResourceCriteria_Id, ResourceCriteriaWeight.DecisionMaker_Id ");
		} catch (SQLException e) {
			e.printStackTrace();
		}
		try {
			while (rs.next ())
			{
				String CriteriaNameVal = rs.getString ("ResourceCriteria.Name");
				String CriteriaLinguisticVariablesVal = rs.getString ("CriteriaLinguisticVariables.Name");
				
				
				
				if (!CheckName.equals(CriteriaNameVal)) {
					TableItem item1 = new TableItem(t, SWT.NONE);
					item1.setText(new String[] { "C" + i +" = " + CriteriaNameVal,CriteriaLinguisticVariablesVal});
					i++;
					j = 2;
					CheckName = CriteriaNameVal;
					value1 = Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value1"));
					value2 = Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value2"));
					value3 = Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value3"));
					count++;

				}
				else {
					TableItem item1 = t.getItem(i-2);
					if (count == (DM_No-1)) {
				        DecimalFormat df = new  DecimalFormat ("0.##");
				        value1 += Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value1"));
						value2 += Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value2"));
						value3 += Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value3"));
						value1 = value1/DM_No;
						value2 = value2/DM_No;
						value3 = value3/DM_No;
						item1.setText(j, CriteriaLinguisticVariablesVal);
						item1.setText(j+1, "(" + df.format(value1) + ", " + df.format(value2) + ", " + df.format(value3) + ")");
						count= 0;
					}
					else {
						item1.setText(j, CriteriaLinguisticVariablesVal);
						value1 += Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value1"));
						value2 += Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value2"));
						value3 += Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value3"));
						count++;
					}
					j++;
				}
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		t.pack();

	}

	public void setFocus() {
	}
}
