package org.eclipse.linuxtools.lttng.SYSPRO.RiskAssessment;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.DecimalFormat;

import org.eclipse.linuxtools.lttng.SYSPRO.ui.Connect;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.ToolBar;
import org.eclipse.swt.widgets.ToolItem;
import org.eclipse.ui.part.ViewPart;


public class ResourceRankingView extends ViewPart {

	public static final String ID = "org.eclipse.ui.tutorials.rcp.part3.ResourceRankingView";
	int DM_No= 0;
	int RC_No=0;
	
	public void createPartControl(Composite parent) {
		Composite top = new Composite(parent, SWT.NONE);
        DecimalFormat df = new  DecimalFormat ("0.##");

		GridLayout layout = new GridLayout();
		layout.marginHeight = 0;
		layout.marginWidth = 0;
		top.setLayout(layout);
		// top banner
		Composite banner = new Composite(top, SWT.NONE);
		banner.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_FILL, GridData.VERTICAL_ALIGN_BEGINNING, true, false));
		layout = new GridLayout();
		layout.marginHeight = 0;
		layout.marginWidth = 0;
		layout.numColumns = 2;
		banner.setLayout(layout);

		// Create Toolbar
	    Image insert_icon = new Image(null, "/home/alireza/TCF/org.eclipse.linuxtools.lttng.SYSPRO/icons/insert_object.png");
	    Image edit_icon = new Image(null, "/home/alireza/TCF/org.eclipse.linuxtools.lttng.SYSPRO/icons/edit_object.png");
	    Image delete_icon = new Image(null, "/home/alireza/TCF/org.eclipse.linuxtools.lttng.SYSPRO/icons/delete_object.png");

	    
		ToolBar toolBar = new ToolBar (banner, SWT.FLAT | SWT.BORDER);
		ToolItem itemInsert = new ToolItem (toolBar, SWT.DROP_DOWN | SWT.PUSH);
		//itemInsert.setText("Insert");
		itemInsert.setImage(insert_icon);
		itemInsert.setToolTipText("Insert");
		ToolItem itemUpdate = new ToolItem (toolBar, SWT.PUSH);
		//itemUpdate.setText("Update");
		itemUpdate.setImage(edit_icon);
		itemUpdate.setToolTipText("Edit");
		ToolItem itemDelete = new ToolItem (toolBar, SWT.PUSH);
		//itemDelete.setText("Delete");
		itemDelete.setImage(delete_icon);
		itemDelete.setToolTipText("Delete");


		toolBar.pack (); 
		
		
		// The relative importance weights of the all criteria by all decision makers
		Label label_C = new Label(top, SWT.BORDER);
		label_C.setText("The relative importance weights of the all criteria by all decision makers");
		Table t_CW = new Table(top, SWT.BORDER);
		
		// Set Column Header
		Connect c = new Connect();
		TableColumn tc1 = new TableColumn(t_CW, SWT.CENTER);
		tc1.setWidth(250);


		ResultSet rs = null;
		int i=1;

		
		try {
			rs = c.Query("select * from DecisionMakers order by Id");
		} catch (SQLException e) {
			e.printStackTrace();
		}
		try {
			while (rs.next ())
			{
				String NameVal = rs.getString ("Name");
				
				TableColumn tc = new TableColumn(t_CW, SWT.CENTER);
				tc.setText("D" + i +" = " + NameVal);
				tc.setWidth(250);
				i++;

			}
		} catch (SQLException e) {
			e.printStackTrace();
		}

		TableColumn tc2 = new TableColumn(t_CW, SWT.CENTER);
		tc2.setText("Aggregated fuzzy number");
		tc2.setWidth(250);
		
		t_CW.setHeaderVisible(true);
		
		// Fetch Data
		
		rs = null;
		DM_No= i-1;
		int count= 0;
		i = 1;
		int j = 0;
		double value1 = 0, value2 = 0, value3 = 0;
		
		String CheckName = ""; 
		
		try {
			rs = c.Query("select ResourceCriteria.Name, DecisionMakers.Name, CriteriaLinguisticVariables.Name, " +
					"CriteriaLinguisticVariables.Value1, CriteriaLinguisticVariables.Value2, CriteriaLinguisticVariables.Value3 " +
					"from ResourceCriteriaWeight, ResourceCriteria, DecisionMakers, CriteriaLinguisticVariables where " +
					"ResourceCriteriaWeight.ResourceCriteria_Id = ResourceCriteria.Id and ResourceCriteriaWeight.DecisionMaker_Id = DecisionMakers.Id " +
					"and ResourceCriteriaWeight.Linguistic_Variable_Id = CriteriaLinguisticVariables.Id " +
					"order by ResourceCriteriaWeight.ResourceCriteria_Id, ResourceCriteriaWeight.DecisionMaker_Id ");
		} catch (SQLException e) {
			e.printStackTrace();
		}
		try {
			while (rs.next ())
			{
				String CriteriaNameVal = rs.getString ("ResourceCriteria.Name");
				String CriteriaLinguisticVariablesVal = rs.getString ("CriteriaLinguisticVariables.Name");
				
				
				
				if (!CheckName.equals(CriteriaNameVal)) {
					TableItem item1 = new TableItem(t_CW, SWT.NONE);
					item1.setText(new String[] { "C" + i +" = " + CriteriaNameVal,CriteriaLinguisticVariablesVal});
					i++;
					j = 2;
					CheckName = CriteriaNameVal;
					value1 = Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value1"));
					value2 = Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value2"));
					value3 = Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value3"));
					count++;

				}
				else {
					TableItem item1 = t_CW.getItem(i-2);
					if (count == (DM_No-1)) {
				        value1 += Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value1"));
						value2 += Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value2"));
						value3 += Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value3"));
						value1 = value1/DM_No;
						value2 = value2/DM_No;
						value3 = value3/DM_No;
						item1.setText(j, CriteriaLinguisticVariablesVal);
						item1.setText(j+1, "(" + df.format(value1) + ", " + df.format(value2) + ", " + df.format(value3) + ")");
						count= 0;
					}
					else {
						item1.setText(j, CriteriaLinguisticVariablesVal);
						value1 += Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value1"));
						value2 += Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value2"));
						value3 += Double.parseDouble(rs.getString ("CriteriaLinguisticVariables.Value3"));
						count++;
					}
					j++;
				}
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		t_CW.pack();

		// Set the number of Vulnerability criteria
		RC_No= 3; 
		// The ratings of the all resources by decision makers under all criteria
		Label label_RV = new Label(top, SWT.BORDER);
		label_RV.setText("The ratings of the all resources by decision makers under all criteria");
		Table t_R_DM = new Table(top, SWT.BORDER);
		
		// Set Column Header
		TableColumn tc1_RV = new TableColumn(t_R_DM, SWT.CENTER);
		TableColumn tc2_RV = new TableColumn(t_R_DM, SWT.CENTER);
		
		tc1_RV.setText("Criteria");
		tc2_RV.setText("Resource Name");

		tc1_RV.setWidth(200);
		tc2_RV.setWidth(200);


		rs = null;
		i=1;
		DM_No= 0;
		
		try {
			rs = c.Query("select * from DecisionMakers order by Id");
		} catch (SQLException e) {
			e.printStackTrace();
		}
		try {
			while (rs.next ())
			{
				String NameVal = rs.getString ("Name");
				
				TableColumn tc = new TableColumn(t_R_DM, SWT.CENTER);
				tc.setText("D" + i +" = " + NameVal);
				tc.setWidth(200);
				i++;

			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		TableColumn tc3_RV = new TableColumn(t_R_DM, SWT.CENTER);
		tc3_RV.setText("Aggregated fuzzy number");
		tc3_RV.setWidth(250);
		
		t_R_DM.setHeaderVisible(true);

		// Fetch Data
		
		rs = null;
		DM_No= i-1;
		count= 0;

		i = 1;
		int ItemNo= 1;
		j = 0;
		CheckName = ""; 
		value1 = 0;
		value2 = 0;
		value3 = 0;

		
		try {
			rs = c.Query("select ResourceCriteria.Name as 'Criteria Name', Resource.Name as 'Resource Name', RatingsLinguisticVariables.Name as 'Value' " +
					", RatingsLinguisticVariables.Value1, RatingsLinguisticVariables.Value2, RatingsLinguisticVariables.Value3 " +
					"from ResourceValue, Resource, DecisionMakers, ResourceCriteria, RatingsLinguisticVariables " +
					"where ResourceValue.DecisionMaker_Id = DecisionMakers.Id " +
					"and ResourceValue.Resource_Id = Resource.Id " +
					"and ResourceValue.ResourceCriteria_Id = ResourceCriteria.Id " +
					"and ResourceValue.Linguistic_Variable_Id = RatingsLinguisticVariables.Id " +
					"order by Resource.Id, ResourceCriteria.Id, DecisionMakers.Id");
		} catch (SQLException e) {
			e.printStackTrace();
		}
		try {
			while (rs.next ())
			{
				String CriteriaNameVal = rs.getString ("Criteria Name");
				String ResourceNameVal = rs.getString ("Resource Name");
				String ValueVal = rs.getString ("Value");

				if (!CheckName.equals(CriteriaNameVal)) {
					TableItem item1 = new TableItem(t_R_DM, SWT.NONE);
					if (i == (RC_No+1)) i= 1;
					item1.setText(new String[] { "C" + i +" = " + CriteriaNameVal, ResourceNameVal, ValueVal});
					i++;
					ItemNo++;
					j = 3;
					CheckName = CriteriaNameVal;
					value1 = Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value1"));
					value2 = Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value2"));
					value3 = Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value3"));
					count++;
				}
				else {
					TableItem item1 = t_R_DM.getItem(ItemNo-2);
				
					if (count == (DM_No-1)) {
				        value1 += Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value1"));
						value2 += Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value2"));
						value3 += Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value3"));
						value1 = value1/DM_No;
						value2 = value2/DM_No;
						value3 = value3/DM_No;
						item1.setText(j, ValueVal);
						item1.setText(j+1, "(" + df.format(value1) + ", " + df.format(value2) + ", " + df.format(value3) + ")");
						count= 0;
					}
					else {
						item1.setText(j, ValueVal);
						value1 += Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value1"));
						value2 += Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value2"));
						value3 += Double.parseDouble(rs.getString ("RatingsLinguisticVariables.Value3"));
						count++;
					}
					j++;
				}
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		t_R_DM.pack();
		
		// The fuzzy weighted normalized decision matrix
		Label label_FWN_DM = new Label(top, SWT.BORDER);
		label_FWN_DM.setText("The fuzzy weighted normalized decision matrix");
		Label label_d1 = new Label(top, SWT.BORDER);
		label_d1.setText("d* = distance of each resource from (1,1,1)");
		Label label_d2 = new Label(top, SWT.BORDER);
		label_d2.setText("d- = distance of each resource from (0,0,0)");
		final Table t1 = new Table(top, SWT.BORDER);
		
		TableColumn tc4 = new TableColumn(t1, SWT.CENTER);
		tc4.setWidth(250);

		rs = null;
		i=1;
		
		try {
			rs = c.Query("select * from ResourceCriteria order by Id");
		} catch (SQLException e) {
			e.printStackTrace();
		}
		try {
			while (rs.next ())
			{
				String NameVal = rs.getString ("Name");
				
				TableColumn tc = new TableColumn(t1, SWT.CENTER);
				tc.setText("C" + i +" = " + NameVal);
				tc.setWidth(250);
				i++;

			}
		} catch (SQLException e) {
			e.printStackTrace();
		}

		TableColumn item_d1 = new TableColumn(t1, SWT.CENTER);
		item_d1.setText("d*");
		item_d1.setWidth(70);

		TableColumn item_d2 = new TableColumn(t1, SWT.CENTER);
		item_d2.setText("d-");
		item_d2.setWidth(70);
		
		TableColumn item_cc = new TableColumn(t1, SWT.CENTER);
		item_cc.setText("Closeness coefficient");
		item_cc.setWidth(150);
		
		TableColumn item_rank = new TableColumn(t1, SWT.CENTER);
		item_rank.setText("Rank");
		item_rank.setWidth(50);

	
		// 
		int criteria;
		int k;
		Double ThirdValue = 0.0;
		TableItem  criteria_Item;
		TableItem  resource_criteria_Item;
		String  criteria_name, criteria_value;
		int counter;
		for (criteria = 0; criteria < t_CW.getItemCount(); criteria++) {
			
			criteria_Item = t_CW.getItem(criteria);
			criteria_name = criteria_Item.getText(0);
			criteria_value = criteria_Item.getText(4);
			counter = 0;
			Double max = 0.0;

			for (k = 0; k < t_R_DM.getItemCount(); k++) {
				resource_criteria_Item = t_R_DM.getItem(k);
				if (resource_criteria_Item.getText(0).contains(criteria_name)) {
					ThirdValue = getFuzzyValue(resource_criteria_Item.getText(5),3);
					if (ThirdValue > max) max = ThirdValue;
				}
			}
			for (k = 0; k < t_R_DM.getItemCount(); k++) {
				resource_criteria_Item = t_R_DM.getItem(k);
				if (resource_criteria_Item.getText(0).contains(criteria_name)) {
					if (criteria == 0 ) {
						// create row
						TableItem item1 = new TableItem(t1, SWT.NONE);
						
						value1 = (getFuzzyValue(resource_criteria_Item.getText(5),1)/max) * getFuzzyValue(criteria_value,1);
						value2 = (getFuzzyValue(resource_criteria_Item.getText(5),2)/max) * getFuzzyValue(criteria_value,2);
						value3 = (getFuzzyValue(resource_criteria_Item.getText(5),3)/max) * getFuzzyValue(criteria_value,3);
						
						item1.setText(new String[] { resource_criteria_Item.getText(1),  "(" + df.format(value1) + ", " + df.format(value2) + ", " + df.format(value3) + ")"});
					} else {
						value1 = (getFuzzyValue(resource_criteria_Item.getText(5),1)/max) * getFuzzyValue(criteria_value,1);
						value2 = (getFuzzyValue(resource_criteria_Item.getText(5),2)/max) * getFuzzyValue(criteria_value,2);
						value3 = (getFuzzyValue(resource_criteria_Item.getText(5),3)/max) * getFuzzyValue(criteria_value,3);
						TableItem item1 = t1.getItem(counter);
						counter++;
						item1.setText(criteria + 1, "(" + df.format(value1) + ", " + df.format(value2) + ", " + df.format(value3) + ")");
					}
				}
			}

		}
		
		
		t1.setHeaderVisible(true);
		t1.pack();
		
		
		// Calculate d* and d- and closeness coefficient
		TableItem  resource_Item;
		Double d_star, d_minus, cc;

		for (int r = 0; r < t1.getItemCount(); r++) {
			resource_Item = t1.getItem(r);
			d_star = 0.0;
			d_minus = 0.0;
			cc = 0.0;
			
			for (k = 0; k < t_CW.getItemCount(); k++) {
				value1 = getFuzzyValue(resource_Item.getText(k+1),1);
				value2 = getFuzzyValue(resource_Item.getText(k+1),2);
				value3 = getFuzzyValue(resource_Item.getText(k+1),3);
				d_star += Math.sqrt((0.33) * ((Math.pow((1-value1),2) + Math.pow((1-value2),2) + Math.pow((1-value3),2))));
				d_minus += Math.sqrt((0.33) * ((Math.pow((value1),2) + Math.pow((value2),2) + Math.pow((value3),2))));

			}
			
			cc = d_minus/(d_minus + d_star);

			resource_Item.setText(k + 1, df.format(d_star));
			resource_Item.setText(k + 2, df.format(d_minus));
			resource_Item.setText(k + 3, df.format(cc));

		}
		
		// Calculate Rank
		Double x , nx;
		int Rank;
		
	    for (k = 0; k < t1.getItemCount(); k++) {  
	    	Rank = 1;
	    	resource_Item = t1.getItem(k);
			x = Double.parseDouble(resource_Item.getText(t_CW.getItemCount() + 3));
			// check equal
			for (i = 0; i < t1.getItemCount(); i++) {
				resource_Item = t1.getItem(i);
				nx = Double.parseDouble(resource_Item.getText(t_CW.getItemCount() + 3));

	            if (nx == x && i < k) Rank++;
	        }
			// check greater
	        for (i = 0; i < t1.getItemCount(); i++) {
				resource_Item = t1.getItem(i);
				nx = Double.parseDouble(resource_Item.getText(t_CW.getItemCount() + 3));

	            if (nx > x) Rank++;
	        }
	    	resource_Item = t1.getItem(k);
	    	resource_Item.setText(t_CW.getItemCount() + 4, Integer.toString(Rank));
	    }
	    
	    
	 // Store results in Database
		final Button btn_store = new Button(top, SWT.PUSH);
		btn_store.setBounds(40, 50, 50, 20);
		btn_store.setText("Store Results");
		btn_store.addSelectionListener(new SelectionListener() {
			public void widgetSelected(SelectionEvent e) {
				String IdVal = null;
				
				TableItem  resource_Item;
				
				// delete previous calculation
				Connect c_delete = new Connect();
				try {
					c_delete.Insert("delete from ResourceRanking");
				} catch (SQLException e2) {
					e2.printStackTrace();
				}
				
				for (int r = 0; r < t1.getItemCount(); r++) {
					Connect c = new Connect();
					ResultSet rs = null;

					resource_Item = t1.getItem(r);
					// get resource id
					try {
						rs = c.Query("select * from Resource where name='"+ resource_Item.getText(0) + "'");
					} catch (SQLException e1) {
						e1.printStackTrace();
					}
					try {
						while (rs.next ())
						{
							IdVal = rs.getString ("Id");
						}
					} catch (SQLException e1) {
						e1.printStackTrace();
					}
					// insert
					try {
						c.Insert("insert into ResourceRanking values(" + IdVal +"," + resource_Item.getText(3+RC_No+1) + "," + resource_Item.getText(3+RC_No) + ")");
					} catch (SQLException e1) {
						e1.printStackTrace();
					}
				}	
			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				
			}
		 });
	    
		
	}

	public Double getFuzzyValue(String str, int index) {
		int frs_ch, trd_ch;
		
		

		if (index == 1) {
			
			frs_ch = str.indexOf(",");
			return Double.parseDouble(str.substring(1, frs_ch)); 
			
		} else if (index == 2) {
			
			str = str.replaceFirst(",", "-");
			frs_ch = str.indexOf("-");
			trd_ch = str.indexOf(",");
			return Double.parseDouble(str.substring(frs_ch + 1, trd_ch));
			
		} else {
			
			str = str.replaceFirst(",", "-");
			frs_ch = str.indexOf(",");
			trd_ch = str.indexOf(")");
			return Double.parseDouble(str.substring(frs_ch + 1, trd_ch)); 

		}
			
	}
	public void setFocus() {
	}
}
