package org.eclipse.linuxtools.lttng.SYSPRO.file;
import java.awt.Color;

   /* This class will be filled from a XML file */

   public class EventtoStateMapper implements Comparable {
		private static final Integer LOWSET_LEVEL_NO = 3;
		private static final Color DEFAULT_COLOR = Color.RED;
		Long number; //3 for sys_open;0 for sys_read
		Long type;  //kernel type: systemcall =0, interrupt =1, ...
		String name;   //sys_open,sys_write,sys_fork , ...
		String operationType;//File, Net, Process, System , ...
		Long operationTypeNo;//File = 0, Network = 1, Process = 2, System = 3 , ...
		String operationName;//File open, File write, Process Fork , ...
		String category;//Create, Setuo, Read-Write, Close, ...
		Long categoryNo;
		Color color;
		Integer level; 
		
	public EventtoStateMapper() {
	}
	
	public EventtoStateMapper(Long number, String name, String operationType, Long operationTypeNo, String operationName, String category) {
		this.number = number;
		this.type = 0L;
		this.name = name;
		this.operationType = operationType;
		this.operationTypeNo = operationTypeNo;
		this.operationName = operationName;
		this.category = category;
		this.level = LOWSET_LEVEL_NO;
		this.color = DEFAULT_COLOR;
	}
	
	public EventtoStateMapper(Long number, String name, String operationType, Long operationTypeNo, String operationName, Long categoryNo, Long type) {
		this.number = number;
		this.type = type;
		this.name = name;
		this.operationType = operationType;
		this.operationTypeNo = operationTypeNo;
		this.operationName = operationName;
		this.categoryNo = categoryNo;
		this.category = "";
		this.color = DEFAULT_COLOR;
		this.level = LOWSET_LEVEL_NO;
		
	}
	
	public EventtoStateMapper(Long number, String name, String operationType, Long operationTypeNo, String operationName, String category, Long type) {
		this.number = number;
		this.type = type;
		this.name = name;
		this.operationType = operationType;
		this.operationTypeNo = operationTypeNo;
		this.operationName = operationName;
		this.category = category;
		this.color = DEFAULT_COLOR;
		this.level = LOWSET_LEVEL_NO;
		
	}
	public EventtoStateMapper(Long number, String name, String operationType, Long operationTypeNo, String operationName, Long categoryNo, Color color) {
		this.number = number;
		this.type = 0L;
		this.name = name;
		this.operationType = operationType;
		this.operationTypeNo = operationTypeNo;
		this.operationName = operationName;
		this.categoryNo = categoryNo;
		this.category = "";
		this.color = color;
		this.level = LOWSET_LEVEL_NO;
	}
	
	public EventtoStateMapper(Long number, String name, String operationType, Long operationTypeNo, String operationName, String category, Color color) {
		this.number = number;
		this.type = 0L;
		this.name = name;
		this.operationType = operationType;
		this.operationTypeNo = operationTypeNo;
		this.operationName = operationName;
		this.category = category;
		this.color = color;
		this.level = LOWSET_LEVEL_NO;
	}
	
	public EventtoStateMapper(Long number, String name, String operationType, Long operationTypeNo, String operationName, Long categoryNo, Color color, Integer level) {
		this.number = number;
		this.type = 0L;
		this.name = name;
		this.operationType = operationType;
		this.operationTypeNo = operationTypeNo;
		this.operationName = operationName;
		this.categoryNo = categoryNo;
		this.category = "";
		this.color = color;
		this.level = level;
	}
	
	public EventtoStateMapper(Long number, String name, String operationType, Long operationTypeNo, String operationName, String category, Color color, Integer level) {
		this.number = number;
		this.type = 0L;
		this.name = name;
		this.operationType = operationType;
		this.operationTypeNo = operationTypeNo;
		this.operationName = operationName;
		this.category = category;
		this.color = color;
		this.level = level;
	}
	
	public Long getNumber() {
		return this.number;
	}
	
	public Long getType() {
		return this.type;
	}
	
	public String getName() {
		return this.name;
	}
	
	public String getOperationType() {
		return this.operationType + " Ops";
	}
	
	public Long getOperationTypeNo() {
		return this.operationTypeNo;
	}
	
	public String getOperationName() {
		return this.operationName;
	}
	
	public String getCategory() {
		return this.category;
	}
	
	public Long getCategoryNo() {
		return this.categoryNo;
	}
	
	public Color getColor() {
		return this.color;
	}
	
	public Color getOPTypeColor() {
			if (this.operationTypeNo == 0) //File
				return Color.green;
			if (this.operationTypeNo == 1) //Network
				return Color.blue;
			if (this.operationTypeNo == 2)//Process
				return Color.orange;
			if (this.operationTypeNo == 3)//
				return Color.cyan;
			else
				return Color.white;     //System
	}
	public Color getColor(int opNo, int level) {
		/*if (level == 0){
			if (opNo == 0)
				return Color.green;
			if (opNo == 1) //Network
				return Color.orange;
			if (opNo == 2)//Process
				return Color.blue;
			else
				return Color.white;
		}
		else*/
			return this.color;
	}
	
	public void setCategory(String category) {
		this.category =category;
	}
	
	public void addcategory(String category) {
		this.category +="; "+category;
	}
	
	public boolean equals(Object other) {
		if (other instanceof EventtoStateMapper) {
			EventtoStateMapper p = (EventtoStateMapper) other;
			if (p.number == this.number) {
				return true;
			}
		}
		return false;
	}
	
	public int hashCode() {
		return this.number.hashCode();
	}
	
	public int compareTo(Object other) {
		if (other instanceof EventtoStateMapper) {
			EventtoStateMapper p = (EventtoStateMapper) other;
			return this.number.compareTo(p.number);
		}
		return -1;
	}

	public String toString() {
		return  name;
	}
}
