/*
 * @(#)StateEngineFactory.java	1.9 06/08/06
 *
 * Copyright 2002 Sun Microsystems, Inc. All rights reserved.
 * SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package org.eclipse.linuxtools.lttng.SYSPRO.file;

import java.io.FileDescriptor;

/**
 * Factory for creating the standard state machine implementation.
 *
 * @version @(#)StateEngineFactory.java	1.9 06/08/06
 * @author Ken Cavanaugh
 */
public class SyntheticEvent {
	private String name;
	private String description;	
	private String filename;
	private Long starttime;
	private Long endtime;
	private Long pid;
	private String cmd;
	private String stat;
	private String channelname;
	
	
	public SyntheticEvent() {}
	
    public SyntheticEvent(String name, String description, String filename, Long pid, Long starttime, Long endtime,String cmd, String stat, String channelname) {
    	this.name = name;
    	this.description = description;
    	this.filename = filename;
    	this.pid = pid;
    	this.starttime = starttime;
    	this.endtime = endtime;
    	this.pid = pid;
    	this.cmd = cmd;
    	this.stat = stat;
    	this.channelname = channelname;
    	//System.out.println(this.toString());
    }
    
    public void Add(String name, String description, String filename, Long pid, Long starttime, Long endtime,String cmd, String stat, String channelname) {
    	this.name = name;
    	this.description = description;
    	this.filename = filename;
    	this.pid = pid;
    	this.starttime = starttime;
    	this.endtime = endtime;
    	this.pid = pid;
    	this.cmd = cmd;
    	this.stat = stat;
    	this.channelname = channelname;
    }
    public String toString(){
    	return "process " + this.cmd + " (pid: "+ this.pid+"), Filename: "+this.filename +", "+this.name+", "+this.description +", start time:"+this.starttime.toString()+", end time:"+this.endtime.toString()+".";//",stat:"+this.stat+".";    
    	}
    public SyntheticEvent getSyntheticEvent(){
    	return this;
    }
    public String getName(){
    	return this.name;
    }
    public String getDescription (){
    	return this.description;
    }
    public String getFilename (){
    	return this.filename;
    }
    public String getCmd(){
    	return this.cmd;
    }
    public String getStat (){
    	return this.stat;
    }
    public String getChannelname (){
    	return this.channelname;
    }
    public Long getPid (){
    	return this.pid;
    }
    public Long getStarttime (){
    	return this.starttime;
    }
    public Long getEndtime (){
    	return this.endtime;
    }
}