package org.eclipse.linuxtools.lttng.SYSPRO.file;

import java.awt.Color;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.Set;
import java.util.TreeMap;
import java.util.TreeSet;

import org.eclipse.linuxtools.lttng.SYSPRO.AttackGraph.DetectionRules;
import org.eclipse.linuxtools.lttng.SYSPRO.cpu.KernelProcess;
import org.eclipse.linuxtools.lttng.SYSPRO.cpu.TraceEventHandlerProcess;
import org.eclipse.linuxtools.lttng.SYSPRO.io.Requester;
import org.eclipse.linuxtools.lttng.SYSPRO.io.TraceEventHandlerBase;
import org.eclipse.linuxtools.lttng.SYSPRO.io.TraceHook;
import org.eclipse.linuxtools.lttng.SYSPRO.io.TraceReader;
import org.eclipse.linuxtools.lttng.SYSPRO.model.StateInfoFactory;
import org.eclipse.linuxtools.lttng.SYSPRO.model.Task.TaskState;
import org.eclipse.linuxtools.lttng.SYSPRO.model.state.StateInfo;
import org.eclipse.linuxtools.lttng.SYSPRO.model.state.StateInfo.Field;
import org.eclipse.linuxtools.lttng.SYSPRO.model.state.SyscallInfo;
import org.eclipse.linuxtools.lttng.SYSPRO.net.NetworkOperationList;
import org.eclipse.linuxtools.lttng.jni.JniEvent;
import org.eclipse.linuxtools.lttng.jni.JniTrace;
import org.eclipse.swt.widgets.Composite;

import statehistory.stateSystem.HistoryProvider;
import statehistory.stateSystem.StateHistorySystem;
import statehistory.tree.HistoryTreeProvider;

public class TraceEventHandlerFile extends TraceEventHandlerBase {
	private long start;
	private long end;
	private long duration;
	
	Date startProcessingTime;
	Date endProcessingTime;
	
	String filterTerm;
	String filteredSyscalls;
	ArrayList<Long> filterArray;
	ArrayList<Long> filterSyscallsArray;
	Requester SHMAlerter;
	HashMap<Long, ArrayList<Long>> tgidPids;
	private StateHistorySystem shs;
	private HistoryProvider hp;
	private int attributeId;
	private int syntheticEventID;
	private int quark, currentCPUNode, currentThreadNode, statNode, argNode, level1Quark, level2Quark;
	private int pidNodeLevel0 = -1, pidNodeLevel1 = -1, pidNodeLevel2 = -1;
	static final String OUTPUT_SHT_DIR = "/home/naser/tmp/state-files/";
	HashMap<Long, StateInfo> currentTask;
	Snode snode;
	HashMap<Integer, HashMap<Long, Snode>> snodeList; //<quark, <time, snode>>;
	HashMap<Long, Snode> snodeTime;
	FileOperationList fileOpList; 
	NetworkOperationList netOpList; 
	DetectionRules detection; 
	int count;
	JniTrace trace;
	TreeMap<Long, EventtoStateMapper> eventMapper;
	HashMap<Long, Set<SyntheticEvent>> syntheticevent;
	HashMap<Long, FileOperation> pidFileop;
	HashMap <Long, HashMap <Long, String>> OpenFiles; // (pid, (fd,filename))
	
	HashMap<String, FileOperationList> FilenameFileoperation; //<pid,FileOperationList>
	HashMap<Long,Long> parent; //parent of a pid, <pid, its parent>
	
	HashMap<Integer, TreeMap <String, ArrayList<TreeSet<Integer>>>> fileNetSymLinkQuarks;
	
	TreeMap<String, HashMap<Long, FileOperationList>> FilenamePidFileoperation;// <filename,FileOperationList>
	TreeMap<Long, HashMap<String, FileOperationList>> PidFilenameFileoperation;// <filename,FileOperationList>
	TreeMap<Long, HashMap<String, Set<FileOperationList>>> PidFilenameFileoperationSet;// <filename,FileOperationList>
	
	TreeMap<Long, HashMap<Long, FileOperationList>> PidFdFsm;
	TreeMap<Long, HashMap<Long, NetworkOperationList>> PidFdNetFsm;
	HashMap<Long, FileOperationList> fileOperations;
	HashMap<Long, NetworkOperationList> netOperations;
	
	ArrayList<Long> sortedDurations = new ArrayList<Long>();
	
	HashMap<String, FileOperationList> fileInfo;// <filename,FileOperationList>
	private static final Long PRE_DEFINED_FORK_MAX_ALLOWED_VALUE1= 10L;
	private static final Long PRE_DEFINED_FORK_MAX_ALLOWED_VALUE2= 15L;
	private static final Long PRE_DEFINED_FORK_MAX_ALLOWED_VALUE3= 20L;
	private static final Long PRE_DEFINED_FORK_MAX_ALLOWED_VALUE4= 25L;
	private static final Long PRE_DEFINED_FORK_MAX_ALLOWED_VALUE5= 30L;
	private static final long IPPROTO_TCP = 6;
	private static final long IPPROTO_UDP = 17;
	private static final int FILEFD = 1;
	private static final int NETWORKFD = 2;
	private static final int PIPEFD = 3;
	private static final int NUMBER_OF_LEVELS = 3;	
	
	private TraceReader traceReader;
	
	private static BufferedWriter level0Out,fLevel0Out;
	private static BufferedWriter level1Out,fLevel1Out;
	private static BufferedWriter level2Out,fLevel2Out;
	
	private static BufferedWriter sortedArrayOut;
	
	public TraceEventHandlerFile() {
		super();
		//hooks.add(new TraceHook());

		hooks.add(new TraceHook("kernel", "sched_schedule"));
		hooks.add(new TraceHook("fs", "exec"));
		hooks.add(new TraceHook("kernel", "process_fork"));
		hooks.add(new TraceHook("net", "socket_connect"));

		
		
		/*hooks.add(new TraceHook("fs", "open"));
		hooks.add(new TraceHook("fs", "close"));
		hooks.add(new TraceHook("fs", "read"));
		hooks.add(new TraceHook("fs", "readv"));
		hooks.add(new TraceHook("fs", "write"));
		hooks.add(new TraceHook("fs", "writev"));
		hooks.add(new TraceHook("fs", "lseek"));
		hooks.add(new TraceHook("fs", "llseek"));
		hooks.add(new TraceHook("fs", "pipe"));
		
		hooks.add(new TraceHook("fd_state", "file_descriptor"));
		hooks.add(new TraceHook("task_state", "process_state"));
		
		hooks.add(new TraceHook("kernel", "syscall_entry"));
		hooks.add(new TraceHook("kernel", "syscall_exit"));
		hooks.add(new TraceHook("kernel", "process_fork"));
		hooks.add(new TraceHook("kernel", "process_wait"));
		hooks.add(new TraceHook("kernel", "process_exit"));
		
		hooks.add(new TraceHook("net", "socket_create"));
		hooks.add(new TraceHook("net", "socket_socketpair"));
		hooks.add(new TraceHook("net", "socket_bind"));
		hooks.add(new TraceHook("net", "socket_connect"));
		hooks.add(new TraceHook("net", "socket_connect_inet"));
		hooks.add(new TraceHook("net", "socket_listen"));
		hooks.add(new TraceHook("net", "socket_accept"));
		hooks.add(new TraceHook("net", "socket_recvmsg"));
		hooks.add(new TraceHook("net", "socket_sendmsg"));
		hooks.add(new TraceHook("net", "tcpv4_rcv"));
		hooks.add(new TraceHook("net", "udpv4_rcv"));	
		hooks.add(new TraceHook("net", "dev_receive"));
		hooks.add(new TraceHook("net", "dev_xmit"));
		hooks.add(new TraceHook("net", "dev_xmit_extended"));
		hooks.add(new TraceHook("net", "tcpv4_rcv_extended"));
		hooks.add(new TraceHook("net", "udpv4_rcv_extended"));
	*/	//hooks.add(new TraceHook("fs", "select"));
		//hooks.add(new TraceHook("fs", "pollfd"));
	}
	public void setFilteredTerms(String ProcessName, String Syscalls){
		filterTerm = ProcessName;
		filteredSyscalls = Syscalls;
		filterArray = new ArrayList<Long>();
		filterSyscallsArray= new ArrayList<Long>();
		String[] syscallArray = null;
		syscallArray = Syscalls.split(",");
		if (syscallArray.length > 0) {
			for (int i = 0;i < syscallArray.length; i++ ){
				filterSyscallsArray.add(Long.valueOf(syscallArray[i]));
			}
		}
			
	}
	@Override
	public void handleInit(TraceReader reader, JniTrace trace) {		
		count = 0;
		pidFileop = new HashMap<Long, FileOperation>();
		currentTask = new HashMap<Long, StateInfo>();
		syntheticevent = new HashMap<Long,Set<SyntheticEvent>>();
		tgidPids = new HashMap<Long, ArrayList<Long>>();
		
		//filterTerm = "apache";
		
		setFilteredTerms("hgkjhgk","8686868");
		
		
		File stateFile = null;
		//stateFile = new File("history2.shs");
		stateFile = new File("/tmp/history.shs");
		//temp = File.createTempFile("history11",".shs1");	
		if (stateFile == null)
			return;
		try {
			hp = new HistoryTreeProvider(stateFile.toString(), trace.getStartTime().getTime());
			shs = new StateHistorySystem(hp, true);
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		parent = new HashMap<Long, Long>();
		
		snodeList = new HashMap<Integer, HashMap<Long,Snode>>();
		snodeTime = new HashMap<Long, Snode>();
		
		//filenameQuarks = new TreeMap<String, ArrayList<TreeSet<Integer>>>();
		fileNetSymLinkQuarks = new HashMap<Integer, TreeMap<String,ArrayList<TreeSet<Integer>>>>(); //0 for file, 1 for net, //FIXME: this struct is temporary, after implementing this in attribute tree, we will remove this struct.
		
		//FileDescriptor = new HashMap<Long,String>();
		//SHMAlerter= new Requester("132.207.72.12",2011);
		initEventMapper();
		fileInfo = new HashMap<String, FileOperationList>();
		FilenameFileoperation = new HashMap<String,FileOperationList>(); 
		PidFilenameFileoperation = new TreeMap<Long,HashMap<String,FileOperationList>>();
		
		PidFdFsm = new TreeMap<Long, HashMap<Long, FileOperationList>>();
		PidFdNetFsm = new TreeMap<Long, HashMap<Long, NetworkOperationList>>();
		
		fileOperations = new HashMap<Long, FileOperationList>();
		netOperations = new HashMap<Long, NetworkOperationList>();
		
		fileOpList = new FileOperationList();
		netOpList = new NetworkOperationList(start);
		detection = new DetectionRules();

		
		OpenFiles=  new HashMap <Long, HashMap <Long, String>>();
		start = trace.getStartTime().getTime();
		end = trace.getEndTime().getTime();
		duration = end - start;
		
		FileWriter fstream0,ffstream0;
		FileWriter fstream1,ffstream1;
		FileWriter fstream2,ffstream2;
		
		try {
			sortedArrayOut = new BufferedWriter( new FileWriter("sortedArray.txt")); //for level 0);
			
			fstream0 = new FileWriter("level0_highest_abstract.txt"); //for level 0
			level0Out = new BufferedWriter(fstream0);
			
			fstream1 = new FileWriter("level1_middle_abstract.txt"); //for level 0
			level1Out = new BufferedWriter(fstream1);
			
			fstream2 = new FileWriter("level2_lowest_abstract.txt"); //for level 2
			level2Out = new BufferedWriter(fstream2);			
			
			ffstream0 = new FileWriter("level0_filtered_highest_abstract.txt"); //for level 0
			fLevel0Out = new BufferedWriter(ffstream0);
			
			ffstream1 = new FileWriter("level1_filtered_middle_abstract.txt"); //for level 0
			fLevel1Out = new BufferedWriter(ffstream1);
			
			ffstream2 = new FileWriter("level2_filtered_lowest_abstract.txt"); //for level 2
			fLevel2Out = new BufferedWriter(ffstream2);	
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
		startProcessingTime = null;
		
		if (startProcessingTime == null){
			DateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
			Date date = new Date();
			startProcessingTime = date;
			//System.out.println("Start Time: " + dateFormat.format(date));
		}
	}
	
	private void initEventMapper() {
		eventMapper = new TreeMap<Long, EventtoStateMapper>();
		//Here We will read an input xml file to fill the eventMapper.
		ArrayList<EventtoStateMapper> esm = new ArrayList<EventtoStateMapper>(); 
		esm.add(0, new EventtoStateMapper(0L, "sys_read", "File", 0l, "Read", 1002l, Color.blue));
		eventMapper.put(0L, esm.get(0));
		esm.add(1, new EventtoStateMapper(1L, "sys_write", "File", 0l, "Write", 1002l, Color.red));
		eventMapper.put(1L, esm.get(1));
		esm.add(2, new EventtoStateMapper(2L, "sys_open", "File", 0l, "Open",  1001l, Color.white));
		eventMapper.put(2L, esm.get(2));
		esm.add(3, new EventtoStateMapper(3L, "sys_close", "File", 0l, "Close", 1004l, Color.black));
		eventMapper.put(3L, esm.get(3));
		esm.add(4, new EventtoStateMapper(4L, "sys_newstat", "File", 0l, "Get File Status", 1003l, Color.cyan));
		eventMapper.put(4L, esm.get(4));
		esm.add(5, new EventtoStateMapper(5L, "sys_newfstat", "File", 0l, "Get File Status", 1003l, Color.cyan));
		eventMapper.put(5L, esm.get(5));
		esm.add(6, new EventtoStateMapper(6L, "sys_newlstat", "File", 0l, "Get File Status", 1003l, Color.cyan));
		eventMapper.put(6L, esm.get(6));
		esm.add(7, new EventtoStateMapper(8L, "sys_lseek", "File", 5l, "Move File Possition", 1005l, Color.DARK_GRAY));
		eventMapper.put(8L, esm.get(7));
		esm.add(8, new EventtoStateMapper(17L, "sys_pread64", "File", 0l, "Read", 1002l, Color.blue));
		eventMapper.put(17L, esm.get(8));
		esm.add(9, new EventtoStateMapper(19L, "sys_readv", "File", 0l, "Read", 1002l, Color.blue));
		eventMapper.put(19L, esm.get(9));
		esm.add(10, new EventtoStateMapper(18L, "sys_pwrite64", "File", 0l, "Write", 1002l, Color.red));
		eventMapper.put(18L, esm.get(10));
		esm.add(11, new EventtoStateMapper(20L, "sys_writev", "File", 0l, "Write", 1002l, Color.red));
		eventMapper.put(20L, esm.get(11));
		esm.add(12, new EventtoStateMapper(21L, "sys_access", "File", 0l, "Check User's Permissions for File", 1003l, Color.cyan));
		eventMapper.put(21L, esm.get(12));
		
		esm.add(13, new EventtoStateMapper(40L, "sys_sendfile64", "Net", 1l, "Send File", 1013l, Color.red));
		eventMapper.put(40L, esm.get(13));
		esm.add(14, new EventtoStateMapper(41L, "sys_socket", "Net", 1l, "Socket Create", 1006l, Color.white));
		eventMapper.put(41L, esm.get(14));
		esm.add(15, new EventtoStateMapper(42L, "sys_connect", "Net", 1l, "Socket Connect", 1012l, Color.gray));
		eventMapper.put(42L, esm.get(15));
		esm.add(16, new EventtoStateMapper(43L, "sys_accept", "Net", 1l, "Socket Accept", 1014l, Color.green));
		eventMapper.put(43L, esm.get(16));
		esm.add(17, new EventtoStateMapper(44L, "sys_sendto", "Net", 1l, "Send Data", 1013l, Color.red));
		eventMapper.put(44L, esm.get(17));
		esm.add(18, new EventtoStateMapper(45L, "sys_recvfrom", "Net", 1l, "Recieve Data", 1013l, Color.blue));
		eventMapper.put(45L, esm.get(18));
		esm.add(19, new EventtoStateMapper(46L, "sys_sendmsg", "Net", 1l, "Send Data", 1013l, Color.red));
		eventMapper.put(46L, esm.get(19));
		esm.add(20, new EventtoStateMapper(47L, "sys_recvmsg", "Net", 1l, "Receive Data", 1013l, Color.blue));
		eventMapper.put(47L, esm.get(20));
		esm.add(21, new EventtoStateMapper(48L, "sys_shutdown", "Net", 1l, "Socke Close", 1015l, Color.black));
		eventMapper.put(48L, esm.get(21));
		esm.add(22, new EventtoStateMapper(49L, "sys_bind", "Net", 1l, "Socket Bind", 1014l, Color.green));
		eventMapper.put(49L, esm.get(22));
		esm.add(23, new EventtoStateMapper(50L, "sys_listen", "Net", 1l, "Socket Listen", 1014l, Color.DARK_GRAY));
		eventMapper.put(50L, esm.get(23));
		esm.add(24, new EventtoStateMapper(51L, "sys_getsockname", "Net", 1l, "Get Socket Name", 1014l, Color.cyan));
		eventMapper.put(51L, esm.get(24));
		esm.add(25, new EventtoStateMapper(52L, "sys_getpeername", "Net", 1l, "Get Peer Name", 1014l, Color.cyan));
		eventMapper.put(52L, esm.get(25));
		esm.add(26, new EventtoStateMapper(53L, "sys_socketpair", "Net", 1l, "Create Pair Socket", 1006l, Color.cyan));
		eventMapper.put(53L, esm.get(26));
		esm.add(27, new EventtoStateMapper(54L, "sys_setsockopt", "Net", 1l, "Set Socket Options", 1014l, Color.cyan));
		eventMapper.put(54L, esm.get(27));
		esm.add(28, new EventtoStateMapper(55L, "sys_getsockopt", "Net", 1l, "Set Socket Options", 1014l, Color.cyan));
		
		eventMapper.put(55L, esm.get(28));
		esm.add(29, new EventtoStateMapper(56L, "stub_clone", "Process", 2l, "Create a Child Process", 1016l, Color.white));
		eventMapper.put(56L, esm.get(29));
		esm.add(30, new EventtoStateMapper(57L, "stub_fork", "Process", 2l, "Create a Child Process", 1016l, Color.white));
		eventMapper.put(57L, esm.get(30));
		esm.add(31, new EventtoStateMapper(58L, "stub_vfork", "Process", 2l, "Create a Child Process and Block Parrent", 1016l, Color.white));
		eventMapper.put(58L, esm.get(31));
		esm.add(32, new EventtoStateMapper(59L, "stub_execve", "Process", 2l, "Execute Program", 1016l, Color.green));
		eventMapper.put(59L, esm.get(32));
		esm.add(33, new EventtoStateMapper(60L, "sys_exit", "Process", 2l, "Exit Process", 1016l, Color.black));
		eventMapper.put(60L, esm.get(33));
		esm.add(34, new EventtoStateMapper(61L, "sys_wait4", "Process", 2l, "Wait for Process to Change State", 1017l, Color.red));
		eventMapper.put(61L, esm.get(34));
		esm.add(35, new EventtoStateMapper(62L, "sys_kill", "Process", 2l, "Kill Process", 1019l, Color.black));
		eventMapper.put(62L, esm.get(35));
		esm.add(36, new EventtoStateMapper(34L, "sys_pause", "Process", 2l, "Wait for Signal", 1017l, Color.red));
		eventMapper.put(34L, esm.get(36));
		
		esm.add(37, new EventtoStateMapper(32L, "sys_dup", "File", 0l, "Duplicate a FD", 1001l, Color.white));
		eventMapper.put(32L, esm.get(37));
		esm.add(38, new EventtoStateMapper(33L, "sys_dup2", "File", 0l, "Duplicate a FD", 1001l, Color.white));
		eventMapper.put(33L, esm.get(38));
		
		esm.add(39, new EventtoStateMapper(35L, "sys_nanosleep", "Time", 3l, "Pause Execution", 1021l, Color.red));
		eventMapper.put(35L, esm.get(39));
		esm.add(40, new EventtoStateMapper(36L, "sys_getitimer", "Time", 3L, "Get Value of an Interval Timer", 1020l, Color.blue));
		eventMapper.put(36L, esm.get(40));
		esm.add(41, new EventtoStateMapper(37L, "sys_alarm", "Time", 3L, "Set an Alarm Clock for Delivery of a Signal", 1020l, Color.blue));
		eventMapper.put(37L, esm.get(41));
		esm.add(42, new EventtoStateMapper(38L, "sys_setitimer", "Time", 3l, "Set Value of an Interval Timer", 1020l, Color.blue));
		eventMapper.put(38L, esm.get(42));

		esm.add(43, new EventtoStateMapper(39L, "sys_getpid", "Process", 2l, "Get Current Process ID", 1018l, Color.cyan));
		eventMapper.put(39L, esm.get(43));
		
		esm.add(44, new EventtoStateMapper(96L, "sys_gettimeofday", "Time", 3l, "Get Time", 1020l, Color.blue));
		eventMapper.put(96L, esm.get(44));
		esm.add(45, new EventtoStateMapper(164L, "sys_settimeofday", "Time", 3l, "Set Time", 1020l, Color.blue));
		eventMapper.put(164L, esm.get(45));
		esm.add(46, new EventtoStateMapper(100L, "sys_times", "Time", 3l, "Get Process Times", 1020l, Color.blue));
		eventMapper.put(100L, esm.get(46));
		esm.add(47, new EventtoStateMapper(201L, "sys_time", "Time", 3l, "Get Time in seconds", 1020l, Color.blue));
		eventMapper.put(201L, esm.get(47));
		
		esm.add(48, new EventtoStateMapper(1001L, "Create", "File", 0l, "File Create ", "", Color.white, 1));
		eventMapper.put(1001L, esm.get(48));
		esm.add(49, new EventtoStateMapper(1002L, "Read-Write", "File", 0l, "Read Write Operation", "", Color.green, 1));
		eventMapper.put(1002L, esm.get(49));
		esm.add(50, new EventtoStateMapper(1003L, "Setup", "File", 0l, "Setup and Control Operation", "", Color.cyan, 1));
		eventMapper.put(1003L, esm.get(50));
		esm.add(51, new EventtoStateMapper(1004L, "Close", "File", 0l, "Close Or Remove", "", Color.black, 1));
		eventMapper.put(1004L, esm.get(51));
		esm.add(52, new EventtoStateMapper(1005L, "Move File Position", "File", 1l, "Move File Position", "", Color.lightGray, 1));
		eventMapper.put(1005L, esm.get(52));
		
		esm.add(53, new EventtoStateMapper(1006L, "Create", "Net", 1l, "Create Socket", "", Color.white, 1));
		eventMapper.put(1006L, esm.get(53));
		esm.add(54, new EventtoStateMapper(1007L, "HTTP Connect", "Net", 1l, "Http Connection", "", Color.gray, 1));
		eventMapper.put(1007L, esm.get(54));
		esm.add(55, new EventtoStateMapper(1008L, "FTP Connect", "Net", 1l, "FTP Connection", "", Color.gray, 1));
		eventMapper.put(1008L, esm.get(55));
		esm.add(56, new EventtoStateMapper(1009L, "DNS Connect", "Net", 1l, "DNS Connection", "", Color.gray, 1));
		eventMapper.put(1009L, esm.get(56));
		esm.add(57, new EventtoStateMapper(1010L, "TCP Connect", "Net", 1l, "TCP Connection", "", Color.gray, 1));
		eventMapper.put(1010L, esm.get(57));
		esm.add(58, new EventtoStateMapper(1011L, "UDP Connect", "Net", 1l, "UDP Connection", "", Color.gray, 1));
		eventMapper.put(1011L, esm.get(58));
		esm.add(59, new EventtoStateMapper(1012L, "Connection", "Net", 1l, "Unknown Connection", "", Color.lightGray, 1));
		eventMapper.put(1012L, esm.get(59));
		esm.add(60, new EventtoStateMapper(1013L, "Read-Write", "Net", 1l, "Read Write Network Operation", "", Color.green, 1));
		eventMapper.put(1013L, esm.get(60));
		esm.add(61, new EventtoStateMapper(1014L, "Setup", "Net", 1l, "Setup and Control Operation", "", Color.cyan, 1));
		eventMapper.put(1014L, esm.get(61));
		esm.add(62, new EventtoStateMapper(1015L, "Close", "Net", 1l, "Close Or Remove Socket", "", Color.black, 1));
		eventMapper.put(1015L, esm.get(62));
		
		esm.add(63, new EventtoStateMapper(1016L, "Create", "Process", 2l, "Create Process", "", Color.white, 1));
		eventMapper.put(1016L, esm.get(63));
		esm.add(64, new EventtoStateMapper(1017L, "Wait", "Process", 2l, "Wait For", "", Color.red, 1));
		eventMapper.put(1017L, esm.get(64));
		esm.add(65, new EventtoStateMapper(1018L, "Setup", "Process", 2l, "Setup", "", Color.cyan, 1));
		eventMapper.put(1018L, esm.get(65));
		esm.add(66, new EventtoStateMapper(1019L, "Close", "Process", 2l, "Close Process", "", Color.black, 1));
		eventMapper.put(1019L, esm.get(66));
		
		esm.add(67, new EventtoStateMapper(1020L, "Setup", "Time", 3l, "Setup", "", Color.cyan, 1));
		eventMapper.put(1020L, esm.get(67));
		esm.add(68, new EventtoStateMapper(1021L, "Close", "Time", 3l, "Close", "", Color.black, 1));
		eventMapper.put(1021L, esm.get(68));

		esm.add(69, new EventtoStateMapper(2001L, "Open.Close File Operation", "File", 0l, "Open.Close File Operation", "", Color.CYAN, 0));
		eventMapper.put(2001L, esm.get(69));
		esm.add(70, new EventtoStateMapper(2002L, "Sequential File Read", "File", 0l, "Sequential File Read", "", Color.blue, 0));
		eventMapper.put(2002L, esm.get(70));
		esm.add(71, new EventtoStateMapper(2003L, "Nonsequential File Read", "File", 0l, "Nonsequential File Read", "", Color.BLUE, 0));
		eventMapper.put(2003L, esm.get(71));
		esm.add(72, new EventtoStateMapper(2004L, "Sequential File Write", "File", 0l, "Sequential File Write", "", Color.red, 0));
		eventMapper.put(2004L, esm.get(72));
		esm.add(73, new EventtoStateMapper(2005L, "Nonsequential File Write", "File", 0l, "Nonsequential File Write", "", Color.RED, 0));
		eventMapper.put(2005L, esm.get(73));
		esm.add(74, new EventtoStateMapper(2006L, "Read.Write File Operation", "File", 0l, "Read.Write File Operation", "", Color.MAGENTA, 0));
		eventMapper.put(2006L, esm.get(74));
		
		esm.add(75, new EventtoStateMapper(999L, "cpu_scheule", "SYSTEM", 4l, "Schedule", 1999l, Color.lightGray));
		eventMapper.put(999L, esm.get(75));
		esm.add(76, new EventtoStateMapper(1999L, "cpu_scheule", "SYSTEM", 4l, "Schedule", "", Color.lightGray, 1));
		eventMapper.put(1999L, esm.get(76));
		esm.add(77, new EventtoStateMapper(2999L, "cpu_scheule", "SYSTEM", 4l, "Schedule", "", Color.lightGray, 0));
		eventMapper.put(2999L, esm.get(77));
		
		esm.add(78, new EventtoStateMapper(22L, "sys_pipe", "File", 0l, "Open",  1001l, Color.white));
		eventMapper.put(22L, esm.get(78));
		
		esm.add(79, new EventtoStateMapper(2007L, "Connection", "Net", 1l, "Netowrk Connection", "", Color.CYAN, 0));
		eventMapper.put(2007L, esm.get(79));
		esm.add(80, new EventtoStateMapper(2008L, "TCP Connection", "Net", 1l, "TCP Connection", "", Color.BLUE, 0));
		eventMapper.put(2008L, esm.get(80));
		esm.add(81, new EventtoStateMapper(2009L, "UDP Connection", "Net", 1l, "UDP Connection", "", Color.RED, 0));
		eventMapper.put(2009L, esm.get(81));
		esm.add(82, new EventtoStateMapper(2010L, "HTTP Connection", "Net", 1l, "HTTP Connection", "", Color.BLUE, 0));
		eventMapper.put(2010L, esm.get(82));
		esm.add(83, new EventtoStateMapper(2011L, "DNS Connection", "Net", 1l, "DNS Connection", "", Color.RED, 0));
		eventMapper.put(2011L, esm.get(83));
		esm.add(84, new EventtoStateMapper(2012L, "FTP Connection", "Net", 1l, "FTP Connection", "", Color.BLUE, 0));
		eventMapper.put(2012L, esm.get(84));
		esm.add(85, new EventtoStateMapper(2013L, "Forked by", "Process", 2l, "Forked by", "", Color.white, 0));
		eventMapper.put(2013L, esm.get(85));
		esm.add(86, new EventtoStateMapper(2014L, "Create a Process", "Process", 2l, "Create a Process", "", Color.white, 0));
		eventMapper.put(2014L, esm.get(86));
		
	}
	
	public void handle_all_event(TraceReader reader, JniEvent event) {
		Long currentProcessID = 0l;
		String currentProcessName = "";
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc != null){
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}
		Long eventTs = event.getEventTime().getTime();
		
		System.out.println(eventTs);
		
	}
	
	public void handle_kernel_sched_schedule(TraceReader reader, JniEvent event) {
		Long currentProcessID = 0l;
		String currentProcessName = "";
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc != null){
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}
		Long eventTs = event.getEventTime().getTime();
		Long prev_pid = (Long) event.parseFieldByName("prev_pid");
		Long next_pid = (Long) event.parseFieldByName("next_pid");
		
		if (currentProcessName.contains("apache"))
			//System.out.println("kernel_sched_schedule --> pid:" + currentProcessID + " TS:" + eventTs + " processName:" + currentProcessName);

			detection.Analysis("kernel.sched_schedule",currentProcessID, eventTs, "", currentProcessName,null);

//		shs.modifyAttribute(eventTs, 999 /*sched_schedule*/, shs.getQuarkAbsolutePath(true,  "Level2", "Threads", prev_pid.toString(), "Ops", "Time"));
//		shs.modifyAttribute(eventTs, 1999 /*sched_schedule*/, shs.getQuarkAbsolutePath(true,  "Level1", "Threads", prev_pid.toString(), "Ops", "Time"));
//		shs.modifyAttribute(eventTs, 2999 /*sched_schedule*/, shs.getQuarkAbsolutePath(true,  "Level0", "Threads", prev_pid.toString(), "Ops", "Time"));
		
//		int val = shs.getCurrentStateValueInt(shs.getQuarkAbsolutePath(true,  "Level2", "Threads", next_pid.toString(), "Ops", "Time"));
//		if (val != -1) {
//			shs.removeAttribute(eventTs, shs.getQuarkAbsolutePath(false,  "Level2", "Threads", next_pid.toString(), "Ops", "Time"));
//			shs.removeAttribute(eventTs, shs.getQuarkAbsolutePath(false,  "Level1", "Threads", next_pid.toString(), "Ops", "Time"));
//			shs.removeAttribute(eventTs, shs.getQuarkAbsolutePath(false,  "Level0", "Threads", next_pid.toString(), "Ops", "Time"));		
//		}
	}
	
	public void handle_task_state_process_state(TraceReader reader, JniEvent event) {
		Long pid = (Long) event.parseFieldByName("pid");
		Long tgid = (Long) event.parseFieldByName("tgid");
		
		String processName = (String) event.parseFieldByName("name");
		if ((!filterTerm.isEmpty()) && processName.contains(filterTerm))
			filterArray.add(pid);
		
		if (!tgidPids.containsKey(tgid))
			tgidPids.put(tgid, new ArrayList<Long>());
		tgidPids.get(tgid).add(pid);
	}
	
	public void handle_fs_open(TraceReader reader, JniEvent event) {
		Long currentProcessID = 0l;
		String currentProcessName = "";
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc != null){
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}
		String eventName = event.getMarkersMap().get(event.getEventMarkerId()).getName();
		Long eventTs = event.getEventTime().getTime();
		
		Long fd = (Long) event.parseFieldByName("fd");
		String filename = (String) event.parseFieldByName("filename");
		
		long startTs = eventTs;
		if (currentTask.containsKey(currentProcessID)) {
			currentTask.get(currentProcessID).setField(Field.FILENAME, filename);
			currentTask.get(currentProcessID).setField(Field.FD, fd);
			startTs = currentTask.get(currentProcessID).getStartTime();
		}
		else
			;//System.out.println(eventTs+":File open without syscall_entry");
		if (fd >= 0) {
			if (PidFdFsm.containsKey(currentProcessID))
				fileOperations = PidFdFsm.get(currentProcessID);
			else
				fileOperations = new HashMap<Long, FileOperationList>();
			
			if (fileOperations.containsKey(fd))
				fileOpList = fileOperations.get(fd);
			else
				fileOpList = new FileOperationList();
			
			fileOpList.getFSM().open(eventTs, filename);
			//fileOpList.getFSM().open(startTs, filename);
			
			fileOperations.put(fd, fileOpList);
			PidFdFsm.put(currentProcessID, fileOperations);
		}	
	}
	public void handle_fs_exec(TraceReader reader, JniEvent event) {
		Long currentProcessID = 0l;
		String currentProcessName = "";
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc != null){
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}
		String filename = (String) event.parseFieldByName("filename");

		if (currentTask.containsKey(currentProcessID))
			currentTask.get(currentProcessID).setField(Field.FILENAME, filename);
		
		
		if ((!filterTerm.isEmpty()) && filename.contains(filterTerm))
			filterArray.add(currentProcessID);
		
		Long eventTs = event.getEventTime().getTime();
		Long pid = (Long) event.parseFieldByName("id");

		//System.out.println("pid:" + currentProcessID + " TS:" + eventTs + " filename:" + filename);
		
		DateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
		Date date = new Date();
		endProcessingTime = date;
		
		detection.Analysis("fs.exec",currentProcessID, eventTs, filename, currentProcessName,null);

		//System.out.println("Fs_Exec: " + dateFormat.format(date));
		//System.out.println("Difference: " + (endProcessingTime.getTime() - startProcessingTime.getTime()));
	}
	
	public void handle_net_socket_create(TraceReader reader, JniEvent event) {
		Long currentProcessID = 0l;
		String currentProcessName = "";
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc != null) {
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}
		String eventName = event.getMarkersMap().get(event.getEventMarkerId()).getName();
		Long eventTs = event.getEventTime().getTime();
		Long family = (Long) event.parseFieldByName("family");
		Long type = (Long) event.parseFieldByName("type");
		Long protocol = (Long) event.parseFieldByName("protocol");
		Object sock = event.parseFieldByName("sock").toString();
		Long fd = (Long) event.parseFieldByName("ret");
		
		if (currentTask.containsKey(currentProcessID)) {
			currentTask.get(currentProcessID).setField(Field.TYPE, type);
			currentTask.get(currentProcessID).setField(Field.FAMILY, family);
			currentTask.get(currentProcessID).setField(Field.PROTOCOL, protocol);
			currentTask.get(currentProcessID).setField(Field.FD, fd);
			currentTask.get(currentProcessID).setField(Field.SOCK, sock);
			eventTs = currentTask.get(currentProcessID).getStartTime();
		}
		else
			;//System.out.println(eventTs+":File open without syscall_entry");
		
		if (fd >= 0) {
			if (PidFdNetFsm.containsKey(currentProcessID))
				netOperations = PidFdNetFsm.get(currentProcessID);
			else
				netOperations = new HashMap<Long, NetworkOperationList>();
			
			if (netOperations.containsKey(fd))
				netOpList = netOperations.get(fd);
			else
				netOpList = new NetworkOperationList(eventTs);
			
			//netOpList.getFSM().create(eventTs, fd);
			netOperations.put(fd, netOpList);
			
			PidFdNetFsm.put(currentProcessID, netOperations);
		}

	}
	
	
	public void handle_net_socket_socketpair(TraceReader reader, JniEvent event) {
		Long currentProcessID = 0l;
		String currentProcessName = "";
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc != null) {
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}
		String eventName = event.getMarkersMap().get(event.getEventMarkerId()).getName();
		Long eventTs = event.getEventTime().getTime();
		Long family = (Long) event.parseFieldByName("family");
		Long type = (Long) event.parseFieldByName("type");
		Long protocol = (Long) event.parseFieldByName("protocol");
		Object sock = event.parseFieldByName("usockvec").toString();
		Long fd1 = (Long) event.parseFieldByName("fd1");
		Long fd2 = (Long) event.parseFieldByName("fd2");
		
		if (currentTask.containsKey(currentProcessID)) {
			currentTask.get(currentProcessID).setField(Field.TYPE, type);
			currentTask.get(currentProcessID).setField(Field.FAMILY, family);
			currentTask.get(currentProcessID).setField(Field.PROTOCOL, protocol);
			currentTask.get(currentProcessID).setField(Field.FD, fd1);
			currentTask.get(currentProcessID).setField(Field.WRITE_FD, fd2);
			currentTask.get(currentProcessID).setField(Field.SOCK, sock);
			eventTs = currentTask.get(currentProcessID).getStartTime();
		}
		else
			;//System.out.println(eventTs+":File open without syscall_entry");
		if (fd1 >= 0) {
			if (PidFdNetFsm.containsKey(currentProcessID))
				netOperations = PidFdNetFsm.get(currentProcessID);
			else
				netOperations = new HashMap<Long, NetworkOperationList>();
			
			if (netOperations.containsKey(fd1))
				netOpList = netOperations.get(fd1);
			else
				netOpList = new NetworkOperationList(eventTs);
			
			//netOpList.getFSM().create(eventTs, fd);
			netOperations.put(fd1, netOpList);
			
			PidFdNetFsm.put(currentProcessID, netOperations);
		}
		if (fd2 >= 0) {
			if (PidFdNetFsm.containsKey(currentProcessID))
				netOperations = PidFdNetFsm.get(currentProcessID);
			else
				netOperations = new HashMap<Long, NetworkOperationList>();
			
			if (netOperations.containsKey(fd2))
				netOpList = netOperations.get(fd2);
			else
				netOpList = new NetworkOperationList(eventTs);
			
			//netOpList.getFSM().create(eventTs, fd);
			netOperations.put(fd2, netOpList);
			PidFdNetFsm.put(currentProcessID, netOperations);
		}
	}
	public void handle_fs_close(TraceReader reader, JniEvent event) {
		Long currentProcessID = 0l;
		int fdType = 0; //0 : file, 1: network, 2: pipe.
		String currentProcessName = "";
		long startTs = 0l;
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc != null){
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}
		Long fd = (Long) event.parseFieldByName("fd");
		Long eventTs = event.getEventTime().getTime();
		if (currentTask.containsKey(currentProcessID)) {
			//Read the filename from the current open files. then update the currentTask
			//currentTask.get(currentProcessID).setField(Field.FILENAME, filename);
			currentTask.get(currentProcessID).setField(Field.FD, fd);
			startTs = currentTask.get(currentProcessID).getStartTime();
		}
		else
			;//System.out.println(eventTs+", File close without syscall_entry");
		/*System.out.println("close fd,at "+eventTs+": fd= "+fd+", currentProcessID= "+currentProcessID);
		fdType = shs.getCurrentStateValueInt(shs.getQuarkAbsolutePath(true, "Threads", currentProcessID.toString(), "FDs", fd.toString(), "type"));
		if (fdType == -1 || fd < 0) {
			System.out.print("SHOULDN'T REACH HERE! unknown fd in fs.close, fd= "+fd+", currentProcessID= "+currentProcessID);
			return;
		}*/

		//FilenameFileoperation.put(filename, fileOpList);
		//PidFilenameFileoperation.put(currentProcessID, FilenameFileoperation);
	}
	public void handle_fs_read(TraceReader reader, JniEvent event) {
		Long currentProcessID = 0l;
		String currentProcessName = "";
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc != null){
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}
		String eventName = event.getMarkersMap().get(event.getEventMarkerId()).getName();
		Long fd = (Long) event.parseFieldByName("fd");
		Long bytesRead = (Long)event.parseFieldByName("count");
		Long eventTs = event.getEventTime().getTime();
		
		if (currentTask.containsKey(currentProcessID)){
			//Read the filename from the current open files. then update the currentTask
			//currentTask.get(currentProcessID).setField(Field.FILENAME, filename);
			currentTask.get(currentProcessID).setField(Field.FD, fd);
			if (fd == 0l)
				currentTask.get(currentProcessID).setField(Field.FILENAME, "STDIN");
			if (fd == 1l)
				currentTask.get(currentProcessID).setField(Field.FILENAME, "STDOUT");
			if (fd == 2l)
				currentTask.get(currentProcessID).setField(Field.FILENAME, "STDERR");
				
		}
		else
			;//System.out.println(eventTs+":File read without syscall_entry");
		if (fd >= 0) {
			if (PidFdFsm.containsKey(currentProcessID))
				fileOperations = PidFdFsm.get(currentProcessID);
			else
				fileOperations = new HashMap<Long, FileOperationList>();
			
			if (fileOperations.containsKey(fd))
				fileOpList = fileOperations.get(fd);
			else
				fileOpList = new FileOperationList();

			fileOperations.put(fd, fileOpList);
			PidFdFsm.put(currentProcessID, fileOperations);
		}
	}
	public void handle_fs_readv(TraceReader reader, JniEvent event) {
		Long currentProcessID = 0l;
		String currentProcessName = "";
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc != null){
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}
		String eventName = event.getMarkersMap().get(event.getEventMarkerId()).getName();
		Long fd = (Long) event.parseFieldByName("fd");
		Long bytesRead = (Long)event.parseFieldByName("count");
		Long eventTs = event.getEventTime().getTime();
		if (currentTask.containsKey(currentProcessID)){
			//Read the filename from the current open files. then update the currentTask
			//currentTask.get(currentProcessID).setField(Field.FILENAME, filename);
			currentTask.get(currentProcessID).setField(Field.FD, fd);
			if (fd == 0l)
				currentTask.get(currentProcessID).setField(Field.FILENAME, "STDIN");
			if (fd == 1l)
				currentTask.get(currentProcessID).setField(Field.FILENAME, "STDOUT");
			if (fd == 2l)
				currentTask.get(currentProcessID).setField(Field.FILENAME, "STDERR");
		}
		else
			System.out.println(eventTs+":File readv without syscall_entry");	
		if (fd >= 0) {
			if (PidFdFsm.containsKey(currentProcessID))
				fileOperations = PidFdFsm.get(currentProcessID);
			else
				fileOperations = new HashMap<Long, FileOperationList>();
			
			if (fileOperations.containsKey(fd))
				fileOpList = fileOperations.get(fd);
			else
				fileOpList = new FileOperationList();

			fileOperations.put(fd, fileOpList);
			PidFdFsm.put(currentProcessID, fileOperations);
		}
	}
	public void handle_fs_write(TraceReader reader, JniEvent event) {
		Long currentProcessID = 0l;
		String currentProcessName = "";
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc != null){
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}
		String eventName = event.getMarkersMap().get(event.getEventMarkerId()).getName();
		Long fd = (Long) event.parseFieldByName("fd");
		Long bytesWrite = (Long)event.parseFieldByName("count");
		Long eventTs = event.getEventTime().getTime();
		if (currentTask.containsKey(currentProcessID)){
			//Read the filename from the current open files. then update the currentTask
			//currentTask.get(currentProcessID).setField(Field.FILENAME, filename);
			currentTask.get(currentProcessID).setField(Field.FD, fd);
			if (fd == 0l)
				currentTask.get(currentProcessID).setField(Field.FILENAME, "STDIN");
			if (fd == 1l)
				currentTask.get(currentProcessID).setField(Field.FILENAME, "STDOUT");
			if (fd == 2l)
				currentTask.get(currentProcessID).setField(Field.FILENAME, "STDERR");
		}
		else
			;//System.out.println(eventTs+":File write without syscall_entry");
		if (fd >= 0) {
			if (PidFdFsm.containsKey(currentProcessID))
				fileOperations = PidFdFsm.get(currentProcessID);
			else
				fileOperations = new HashMap<Long, FileOperationList>();
			
			if (fileOperations.containsKey(fd))
				fileOpList = fileOperations.get(fd);
			else
				fileOpList = new FileOperationList();

			fileOperations.put(fd, fileOpList);
			PidFdFsm.put(currentProcessID, fileOperations);
		}
	}
	public void handle_fs_writev(TraceReader reader, JniEvent event) {
		Long currentProcessID = 0l;
		String currentProcessName = "";
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc != null){
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}
		String eventName = event.getMarkersMap().get(event.getEventMarkerId()).getName();
		Long fd = (Long) event.parseFieldByName("fd");
		Long bytesWrite = (Long)event.parseFieldByName("vlen");
		Long eventTs = event.getEventTime().getTime();
		
		if (currentTask.containsKey(currentProcessID)){
			//Read the filename from the current open files. then update the currentTask
			//currentTask.get(currentProcessID).setField(Field.FILENAME, filename);
			currentTask.get(currentProcessID).setField(Field.FD, fd);
			if (fd == 0l)
				currentTask.get(currentProcessID).setField(Field.FILENAME, "STDIN");
			if (fd == 1l)
				currentTask.get(currentProcessID).setField(Field.FILENAME, "STDOUT");
			if (fd == 2l)
				currentTask.get(currentProcessID).setField(Field.FILENAME, "STDERR");
		}
		else
			;//System.out.println(eventTs+":File writev without syscall_entry");
		if (fd >= 0) {
			if (PidFdFsm.containsKey(currentProcessID))
				fileOperations = PidFdFsm.get(currentProcessID);
			else
				fileOperations = new HashMap<Long, FileOperationList>();
			
			if (fileOperations.containsKey(fd))
				fileOpList = fileOperations.get(fd);
			else
				fileOpList = new FileOperationList();

			fileOperations.put(fd, fileOpList);
			PidFdFsm.put(currentProcessID, fileOperations);
		}
	}
	public void handle_kernel_syscall_entry(TraceReader reader, JniEvent event) {
		Long currentProcessID;
		String eventOperationName = "unknown";
		String currentProcessName="";
		String eventOperationType="unknown";
		Long eventTs = event.getEventTime().getTime();
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		currentProcessID =0l;
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc != null){
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}
		Long syscallId = (Long) event.parseFieldByName("syscall_id");
		
		SyscallInfo info = (SyscallInfo) StateInfoFactory.makeStateInfo(TaskState.SYSCALL);
		info.setStartTime(eventTs);
		info.setSyscallId(syscallId.intValue());
		currentTask.put(currentProcessID, info);
			
	}
	long countl = 0l;
	public void handle_kernel_syscall_exit(TraceReader reader, JniEvent event) {
		Long currentProcessID;
		String currentProcessName = "Unknown";
		String resourceName = "";
		int fd = -1;
		int fdType = -1;
		int resourceNameInt = -1;
		Object obj = null;
		boolean addingNeeded = false;
		boolean netaddingNeeded = false;
		SyscallInfo currentInfo = null;
		Long eventTs = event.getEventTime().getTime();
		currentProcessID =0l;
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc != null) {
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}
		if (currentProcessID == 0)
			currentProcessName = "swapper";
		currentProcessName = currentProcessName.replace("/", "\\");
		int processNameId = shs.getQuarkAbsolutePath(true, "Processes",currentProcessName);
		Long syscallRet = (Long) event.parseFieldByName("ret");
		
		if (currentTask.containsKey(currentProcessID)) {
			currentTask.get(currentProcessID).setEndTime(eventTs);
			((SyscallInfo) currentTask.get(currentProcessID)).setRetCode(syscallRet.intValue());
			currentInfo = (SyscallInfo) currentTask.get(currentProcessID);
			String eventOperationType="System Operations";
			if  (eventMapper.containsKey((long)currentInfo.getSyscallId())) {
				String eventOperationName = eventMapper.get((long)currentInfo.getSyscallId()).getOperationName();
				eventOperationType = eventMapper.get((long)currentInfo.getSyscallId()).getOperationType();
				Long eventOperationTypeNo = eventMapper.get((long)currentInfo.getSyscallId()).getOperationTypeNo();
				long levelOperationNo = eventMapper.get((long)currentInfo.getSyscallId()).getCategoryNo();
				
				/*level1Quark = shs.getQuarkAbsolutePath(true, "L1");
				level2Quark = shs.getQuarkAbsolutePath(true, "L2");*/

				//System.out.println(eventTs+ ":      pid: "+currentProcessID+", name:"+eventOperationName+", operation type: "+eventOperationTypeNo +", current info: " + currentInfo);

				if (currentInfo.getField(Field.FD) != null) {
						obj  = currentInfo.getField(Field.FD);
						if (obj != null)
							fd = Integer.valueOf(obj.toString());
						
						if (eventOperationName == "Read") {
							if (syscallRet >= 0) {
								fdType = shs.getCurrentStateValueInt(shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", obj.toString(), "type"));
								//Object sock = currentInfo.getField(Field.SOCK);
								if (fdType == NETWORKFD) { // it is a network read
									
									eventOperationType = "Net Ops";
									//System.out.println("READ: pid: "+ currentProcessID +", fd: "+fd+", ts: "+ eventTs+", ret: " + syscallRet);
									HashMap<Long, NetworkOperationList> netOperations = PidFdNetFsm.get(currentProcessID);
									NetworkOperationList netOpList = null;
									if (netOperations == null) {
										netOperations = new HashMap<Long, NetworkOperationList>();
									}
									netOpList = netOperations.get((long) (fd));
									if (netOpList != null) {
										netaddingNeeded = true;
										netOpList.getFSM().rcv(syscallRet);
									}
									else {
										//fdType = shs.getCurrentStateValueInt(shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", obj.toString(), "type"));
										if (fdType == -1) { /* this is the first time we visit this fd*/
											System.out.println(eventTs + ": First Time Visit!");
											shs.modifyAttribute(currentInfo.getStartTime(), NETWORKFD, shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", obj.toString(), "type"));
											shs.modifyAttribute(currentInfo.getStartTime(), fd, shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", obj.toString(), "fd"));
											//shs.modifyAttribute(currentInfo.getStartTime(), sock.toString(), shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", obj.toString(), "sock"));
											
											int socketQuark = shs.getQuarkAbsolutePath(true, "Resources","Network","unknown"); 
											shs.modifyAttribute(currentInfo.getStartTime(), socketQuark, shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", obj.toString(), "socket"));	
										}
										netOpList = new NetworkOperationList(currentInfo.getStartTime()); 
										netaddingNeeded = true;
										netOpList.getFSM().rcv(syscallRet);
										netOperations.put((long)fd, netOpList);
										PidFdNetFsm.put(currentProcessID, netOperations);
									}
									//PidFdNetFsm.get(currentProcessID).get((long)fd).getFSM().rcv(eventTs, syscallRet);
								}
								else { //FIXME: here we should check that the fd is a network fd or socket fd.
									PidFdFsm.get(currentProcessID).get((long)fd).getFSM().read(eventTs, syscallRet);
									addingNeeded = true;
								}
							}
						}
						if (eventOperationName == "Write" && (syscallRet >= 0)) {
							fdType = shs.getCurrentStateValueInt(shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", obj.toString(), "type"));
							
							
							//Object sock = currentInfo.getField(Field.SOCK);
							//if (sock != null){ // it is a network read
							if (fdType == NETWORKFD) { // it is a network write
								eventOperationType = "Net Ops";
								//System.out.println("WRITE: pid: "+ currentProcessID +", fd: "+fd+", ts: "+ eventTs+", ret: " + syscallRet);
								HashMap<Long, NetworkOperationList> netOperations = PidFdNetFsm.get(currentProcessID);
								NetworkOperationList netOpList = null;
								if (netOperations == null) {
									netOperations = new HashMap<Long, NetworkOperationList>();
								}
								netOpList = netOperations.get((long) (fd));
								if (netOpList != null) {
									netaddingNeeded = true;
									netOpList.getFSM().send(syscallRet);
								}
								else {
									fdType = shs.getCurrentStateValueInt(shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", obj.toString(), "type"));
									if (fdType == -1) { /* this is the first time we wisit this fd*/
										shs.modifyAttribute(currentInfo.getStartTime(), NETWORKFD, shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", obj.toString(), "type"));
										shs.modifyAttribute(currentInfo.getStartTime(), fd, shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", obj.toString(), "fd"));
										//shs.modifyAttribute(currentInfo.getStartTime(), sock.toString(), shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", obj.toString(), "sock"));
										int socketQuark = shs.getQuarkAbsolutePath(true, "Resources","Network","unknown");
										shs.modifyAttribute(currentInfo.getStartTime(), socketQuark, shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", obj.toString(), "socket"));	
									}
									netOpList = new NetworkOperationList(currentInfo.getStartTime()); 
									netaddingNeeded = true;
									netOpList.getFSM().send(syscallRet);
									netOperations.put((long)fd, netOpList);
									PidFdNetFsm.put(currentProcessID, netOperations);
								}
							}
							else {
								PidFdFsm.get(currentProcessID).get((long)fd).getFSM().write(eventTs, syscallRet);
								addingNeeded = true;
							}
						}
						if (eventOperationName == "Move File Possition") {
							PidFdFsm.get(currentProcessID).get((long)fd).getFSM().seek(eventTs, syscallRet, (Long) currentInfo.getField(Field.ORIGIN));
							addingNeeded = true;
						}
					
						if ((eventOperationName == "Open") && (syscallRet >= 0)) { /* for file and pipe*/
					
							Object writeFdObj  = currentInfo.getField(Field.WRITE_FD);
							if (writeFdObj !=null) { // a pipe operation
								/* for readfd*/ 
								shs.modifyAttribute(currentInfo.getStartTime(), fd, shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", obj.toString(), "fd"));
								shs.modifyAttribute(currentInfo.getStartTime(), PIPEFD , shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", obj.toString(), "type"));
								int fileQuark = shs.getQuarkAbsolutePath(true, "Resources","Pipe","pipe");
								shs.modifyAttribute(currentInfo.getStartTime(), fileQuark, shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs",  obj.toString(), "pipe"));
								/* for writefd*/	
								shs.modifyAttribute(currentInfo.getStartTime(), Integer.valueOf(writeFdObj.toString()), shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", writeFdObj.toString(), "fd"));
								shs.modifyAttribute(currentInfo.getStartTime(), PIPEFD , shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", writeFdObj.toString(), "type"));
								shs.modifyAttribute(currentInfo.getStartTime(), fileQuark, shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", writeFdObj.toString(), "pipe"));
							}
							else { //a file operation
								shs.modifyAttribute(currentInfo.getStartTime(), fd, shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", obj.toString(), "fd"));
								shs.modifyAttribute(currentInfo.getStartTime(), FILEFD , shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", obj.toString(), "type"));
								//System.out.println("pid: "+currentProcessID+", "+currentInfo);
								int fileQuark = shs.getQuarkAbsolutePath(true, "Resources","File",currentInfo.getField(Field.FILENAME).toString().replace("/", "\\"));
								shs.modifyAttribute(currentInfo.getStartTime(), fileQuark , shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", obj.toString(), "filename"));
								addingNeeded = true;
							}
						}
						
						//if ((eventOperationName == "Close" || eventOperationName == "Get File Status") && (syscallRet == 0)) {
						if ((eventOperationName == "Close") && (syscallRet == 0)) {
							fdType = shs.getCurrentStateValueInt(shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", obj.toString(), "type"));
							if (fdType == FILEFD || fdType == PIPEFD) {
								if (PidFdFsm.containsKey(currentProcessID))
									fileOperations = PidFdFsm.get(currentProcessID);
								else
									fileOperations = new HashMap<Long, FileOperationList>();
								
								if (fileOperations.containsKey((long)fd))
									fileOpList = fileOperations.get((long)fd);
								else
	 								fileOpList = new FileOperationList();
	
								addingNeeded = true;
								
								fileOpList.getFSM().close();
								fileOpList.getFSM().afterClose();
								addingNeeded = false;
								fileOpList.addAMember(pidNodeLevel1, currentInfo.getStartTime());
								fileOperations.put((long)fd, fileOpList);
								PidFdFsm.put(currentProcessID, fileOperations);
								if (fdType == FILEFD) {
									eventOperationType = "File Ops";
									resourceName = fileOpList.getFSM().getFilename();
									if (resourceName == null) {
										if (currentInfo.containField(Field.FILENAME)){
											resourceName = currentInfo.getField(Field.FILENAME).toString();	
											resourceName = resourceName.replace("/", "\\");
											if (!resourceName.isEmpty())
												resourceNameInt = shs.getQuarkAbsolutePath(true, "Resources","File", resourceName);
										}
										else {
											//resourceName = shs.getCurrentStateValueStr(shs.getQuarkAbsolutePath(false, "OpenFDs", currentProcessID.toString(), "FDs", obj.toString(), "filename"));
											resourceNameInt = shs.getCurrentStateValueInt(shs.getQuarkAbsolutePath(false, "OpenFDs", currentProcessID.toString(), "FDs", obj.toString(), "filename"));
											if (resourceNameInt < 0)
												resourceName = "unknown-1";
											else {
												resourceName = shs.getAttributeName(resourceNameInt);
												//resourceName = resourceName.substring(resourceName.lastIndexOf("/" +1));
											}
										}
									}
									else {
										if (!resourceName.isEmpty())
											resourceNameInt = shs.getQuarkAbsolutePath(true, "Resources","File", resourceName.replace("/", "\\"));
									}
									if (resourceName == null){
										resourceName = "pipe";
										resourceNameInt = shs.getQuarkAbsolutePath(true, "Resources","File", resourceName);
									}
									if (resourceName.isEmpty()){
										resourceName = "pipe";
										resourceNameInt = shs.getQuarkAbsolutePath(true, "Resources","File", resourceName);
									}
								
								resourceName = resourceName.replace("/", "\\");
								
								
								
								//pidNodeLevel0 = shs.getQuarkAbsolutePath(true, "L0",  currentProcessID.toString(), "Ops", "File Ops", "FDs", obj.toString(), resourceName);
								//pidNodeLevel0 = shs.getQuarkAbsolutePath(true, "L0", currentProcessName, currentProcessID.toString());
								pidNodeLevel0 = shs.getQuarkAbsolutePath(true, "Processes", currentProcessName, currentProcessID.toString(),"$L0");
								long startingTime = fileOpList.getFSM().getStartingTs();
								shs.modifyAttribute(startingTime, fileOpList.getFSM().getSyntheticeventName(), pidNodeLevel0);
								shs.removeAttribute(eventTs, pidNodeLevel0);
								
								if (snodeList.containsKey(pidNodeLevel0))
									snodeTime = snodeList.get(pidNodeLevel0);
								else
									snodeTime = new HashMap<Long, Snode>();
								
								//if (snodeTime.containsKey(currentInfo.getStartTime()))
								//	snode  = snodeTime.get(currentInfo.getStartTime());
								if (snodeTime.containsKey(startingTime))
									snode  = snodeTime.get(startingTime);
								else
									snode = new Snode(currentProcessID, processNameId, currentInfo.getSyscallId(), resourceNameInt);
								
								ArrayList<SnodeLink> children = PidFdFsm.get(currentProcessID).get((long)fd).getMembers();
								snode.setChildren(children);
								PidFdFsm.get(currentProcessID).get((long)fd).clearMembers();
								
								snodeTime.put(startingTime, snode);
								snodeList.put(pidNodeLevel0, snodeTime);
								
								//System.out.println(eventMapper.get((long)fileOpList.getFSM().getSyntheticeventName()).getOperationName()+" - " +resourceName +" - "+ fileOpList.getFSM().getStartingTs()+" --> " + eventTs+" - : level0");
								/*
								try {
									level0Out.write(currentProcessName + " (" + currentProcessID.toString() + "): " +eventMapper.get((long)fileOpList.getFSM().getSyntheticeventName()).getOperationName()+" - " +resourceName + fileOpList.getFSM().getSyntheticEventInformation()+" ("+ String.valueOf(fileOpList.getFSM().getStartingTs()) +" - " + eventTs.toString() + ")");
									level0Out.newLine();
									
									sortedDurations.add(eventTs - fileOpList.getFSM().getStartingTs());
									
									
									if (filterArray.contains(currentProcessID) && !filterSyscallsArray.contains((long)currentInfo.getSyscallId())){
										fLevel0Out.write(currentProcessName + " (" + currentProcessID.toString() + "): " +eventMapper.get((long)fileOpList.getFSM().getSyntheticeventName()).getOperationName()+" - " +resourceName + fileOpList.getFSM().getSyntheticEventInformation()+" ("+ String.valueOf(fileOpList.getFSM().getStartingTs()) +" - " + eventTs.toString() + ")");
										fLevel0Out.newLine();
									}
									
								} catch (IOException e) {
									// TODO Auto-generated catch block
									e.printStackTrace();
								}
								*/
								//System.out.println("file: pid: " + currentProcessID + ", start= " + fileOpList.getFSM().getStartingTs()+",end= " + eventTs + ", event no= " + fileOpList.getFSM().getSyntheticeventName() + ", fd= " + fd);				
								//shs.incrementAttribute(eventTs, shs.getQuarkAbsolutePath(true, "Level0", "Threads", currentProcessID.toString(), "Statistics"));
								//shs.incrementAttribute(eventTs, shs.getQuarkAbsolutePath(true, "Level0", "Threads", currentProcessID.toString(), "Statistics", String.valueOf(fileOpList.getFSM().getSyntheticeventName())));
								//shs.removeAttribute(eventTs, shs.getQuarkAbsolutePath(true, "Threads", currentProcessID.toString(), "FDs", currentInfo.getField(Field.FD).toString(), "filename"));
								fileOpList.getFSM().resetStat();
								}
								else {
									resourceName = "pipe";
									resourceNameInt = shs.getQuarkAbsolutePath(true, "Resources","Pipe", resourceName);
								}
							} else if (fdType == NETWORKFD) {
								eventOperationType = "Net Ops";
								//pidNode = shs.getQuarkAbsolutePath(false, "OpenFDs", currentProcessID.toString(), "FDs",  obj.toString(), "socket");
								netaddingNeeded = false;
								if (PidFdNetFsm.containsKey(currentProcessID))
									netOperations = PidFdNetFsm.get(currentProcessID);
								else
									netOperations = new HashMap<Long, NetworkOperationList>();
									
								if (netOperations.containsKey((long)fd))
									netOpList = netOperations.get((long)fd);
								else
									netOpList = new NetworkOperationList(currentInfo.getStartTime());
								netOpList.getFSM().close();
								netOpList.addAMember(pidNodeLevel1,currentInfo.getStartTime());
								netOperations.put((long)fd, netOpList);
								PidFdNetFsm.put(currentProcessID, netOperations);
								
								resourceName = netOpList.getFSM().getSyntheticEventInformation();
								if (resourceName == null) {
									if (currentInfo.containField(Field.SRC_ADDR)){
										resourceName = currentInfo.getField(Field.SRC_ADDR) + ":" + currentInfo.getField(Field.SRC_PORT) + " --> " + currentInfo.getField(Field.DST_ADDR) + ":" + currentInfo.getField(Field.DST_PORT);
										resourceNameInt = shs.getQuarkAbsolutePath(true, "Resources","Network", resourceName);
									}
									else if (currentInfo.containField(Field.PROTOCOL)){
										resourceName =  "protocol " + currentInfo.getField(Field.PROTOCOL);
										resourceNameInt = shs.getQuarkAbsolutePath(true, "Resources","Network", resourceName);
									}
									
								}
								else {
									resourceNameInt = shs.getQuarkAbsolutePath(true, "Resources","Network", resourceName);
								}
								
								//pidNodeLevel0 = shs.getQuarkAbsolutePath(true, "L0",  currentProcessID.toString(), "Ops", "Net Ops", "FDs",  obj.toString(), resourceName);
								//pidNodeLevel0 = shs.getQuarkAbsolutePath(true, "L0", currentProcessName, currentProcessID.toString());
								pidNodeLevel0 = shs.getQuarkAbsolutePath(true, "Processes", currentProcessName, currentProcessID.toString(),"$L0");
								long startingTime = netOpList.getFSM().getStartingTs();
								shs.modifyAttribute(netOpList.getFSM().getStartingTs(), (int) netOpList.getFSM().getSyntheticeventName(), pidNodeLevel0);
								shs.removeAttribute(eventTs, pidNodeLevel0);
								//System.out.println(eventMapper.get((long)netOpList.getFSM().getSyntheticeventName()).getOperationName()+" - " +resourceName +" - "+ netOpList.getFSM().getStartingTs()+" --> " + eventTs+" - : level0");
								
								/*try {
									level0Out.write(currentProcessName + " (" + currentProcessID.toString() + "): " + eventMapper.get((long)netOpList.getFSM().getSyntheticeventName()).getOperationName()+" - " + resourceName + netOpList.getFSM().getThroughput()+ " ("+ String.valueOf(netOpList.getFSM().getStartingTs())+" - " + eventTs.toString()+")");
									level0Out.newLine();
									
									sortedDurations.add(eventTs - netOpList.getFSM().getStartingTs());
									
									if (filterArray.contains(currentProcessID)&& !filterSyscallsArray.contains((long)currentInfo.getSyscallId())){
										fLevel0Out.write(currentProcessName + " (" + currentProcessID.toString() + "): " + eventMapper.get((long)netOpList.getFSM().getSyntheticeventName()).getOperationName()+" - " + resourceName + netOpList.getFSM().getThroughput()+ " ("+ String.valueOf(netOpList.getFSM().getStartingTs())+" - " + eventTs.toString()+")");
										fLevel0Out.newLine();
									}
									
									
								} catch (IOException e) {
									// TODO Auto-generated catch block
									e.printStackTrace();
								}
*/
								if (snodeList.containsKey(pidNodeLevel0))
									snodeTime = snodeList.get(pidNodeLevel0);
									else
										snodeTime = new HashMap<Long, Snode>();
								
									//if (snodeTime.containsKey(currentInfo.getStartTime()))
									//	snode  = snodeTime.get(currentInfo.getStartTime());
									if (snodeTime.containsKey(startingTime))
										snode  = snodeTime.get(startingTime);
									else
										snode = new Snode(currentProcessID, processNameId, currentInfo.getSyscallId(), resourceNameInt);
									
									ArrayList<SnodeLink> children = PidFdNetFsm.get(currentProcessID).get((long)fd).getMembers();
									snode.setChildren(children);
									PidFdNetFsm.get(currentProcessID).get((long)fd).clearMembers();
									
									
									snodeTime.put(startingTime, snode);
									snodeList.put(pidNodeLevel0, snodeTime);
								
								
								
								//System.out.println("net: pid: " + currentProcessID + ", start= " + netOpList.getFSM().getStartingTs()+",end= " + eventTs + ", event no= " + netOpList.getFSM().getSyntheticeventName() + ", fd= " + fd);
								//shs.incrementAttribute(eventTs, shs.getQuarkAbsolutePath(true, "Level0", "Threads", currentProcessID.toString(), "Statistics"));
								//shs.incrementAttribute(eventTs, shs.getQuarkAbsolutePath(true, "Level0", "Threads", currentProcessID.toString(), "Statistics", String.valueOf(netOpList.getFSM().getSyntheticeventName())));
								shs.removeAttribute(eventTs, shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", currentInfo.getField(Field.FD).toString(), "socket"));
								//shs.removeAttribute(eventTs, shs.getQuarkAbsolutePath(true, "Threads", currentProcessID.toString(), "FDs", currentInfo.getField(Field.FD).toString(), "sock"));
								netOpList.getFSM().resetStat();
							}
							else
								shs.removeAttribute(eventTs, shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", String.valueOf(fd)));
							//shs.removeAttribute(eventTs, shs.getQuarkAbsolutePath(true, "Threads", currentProcessID.toString(), "FDs", currentInfo.getField(Field.FD).toString(), "fd"));		
						}
						if ((eventOperationName == "Socket Create") && (syscallRet >= 0)) {
							shs.modifyAttribute(currentInfo.getStartTime(), NETWORKFD , shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", String.valueOf(fd), "type"));
							Object sock = currentInfo.getField(Field.SOCK);
							if (sock != null) {
								shs.modifyAttribute(currentInfo.getStartTime(), fd, shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "Sock", sock.toString(),"fd"));
								shs.modifyAttribute(currentInfo.getStartTime(), currentInfo.getField(Field.SOCK).toString(), shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", currentInfo.getField(Field.FD).toString(), "sock"));
							}
							else
								System.out.println("Socket Create without sock!");
	
							shs.modifyAttribute(currentInfo.getStartTime(), fd, shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", currentInfo.getField(Field.FD).toString(), "fd"));
							int socketQuark = shs.getQuarkAbsolutePath(true, "Resources","Network","protocol " + currentInfo.getField(Field.PROTOCOL).toString());
							netaddingNeeded = true;
							shs.modifyAttribute(currentInfo.getStartTime(), socketQuark , shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", currentInfo.getField(Field.FD).toString(), "socket"));
							PidFdNetFsm.get(currentProcessID).get((long)fd).getFSM().create(currentInfo.getStartTime(), (long) fd, Long.valueOf(currentInfo.getField(Field.PROTOCOL).toString()), (long)Long.valueOf(currentInfo.getField(Field.FAMILY).toString()), (long)Long.valueOf(currentInfo.getField(Field.TYPE).toString()));
						}
						if ((eventOperationName == "Create Pair Socket") && (syscallRet >= 0)){
								
								shs.modifyAttribute(currentInfo.getStartTime(), NETWORKFD , shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", String.valueOf(fd), "type"));
								shs.modifyAttribute(currentInfo.getStartTime(), NETWORKFD , shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", currentInfo.getField(Field.WRITE_FD).toString(), "type"));
								Object sock = currentInfo.getField(Field.SOCK);
								if (sock != null) {
									shs.modifyAttribute(currentInfo.getStartTime(), fd, shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "Sock", sock.toString(),"fd"));
									shs.modifyAttribute(currentInfo.getStartTime(), currentInfo.getField(Field.SOCK).toString(), shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", currentInfo.getField(Field.FD).toString(), "sock"));
								}
								else
									System.out.println("Socket Create without sock!");
								netaddingNeeded = true;
								shs.modifyAttribute(currentInfo.getStartTime(), fd, shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", currentInfo.getField(Field.FD).toString(), "fd"));
								int socketQuark = shs.getQuarkAbsolutePath(true, "Resources","Network", currentInfo.getField(Field.PROTOCOL).toString());
								shs.modifyAttribute(currentInfo.getStartTime(), socketQuark, shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", currentInfo.getField(Field.FD).toString(), "socket"));
								
								Object writeFdObj  = currentInfo.getField(Field.WRITE_FD);
								shs.modifyAttribute(currentInfo.getStartTime(), Integer.valueOf(writeFdObj.toString()), shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", currentInfo.getField(Field.WRITE_FD).toString(), "fd"));
								socketQuark = shs.getQuarkAbsolutePath(true, "Resources","Network", "protocol " + currentInfo.getField(Field.PROTOCOL).toString());
								shs.modifyAttribute(currentInfo.getStartTime(), socketQuark, shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", currentInfo.getField(Field.WRITE_FD).toString(), "socket"));
								
								
								HashMap<Long, NetworkOperationList> ls = PidFdNetFsm.get(currentProcessID);
		
								PidFdNetFsm.get(currentProcessID).get((long)fd).getFSM().create(currentInfo.getStartTime(), (long) fd, Long.valueOf(currentInfo.getField(Field.PROTOCOL).toString()), Long.valueOf(currentInfo.getField(Field.FAMILY).toString()), Long.valueOf(currentInfo.getField(Field.TYPE).toString()));
								PidFdNetFsm.get(currentProcessID).get((long)Long.valueOf(writeFdObj.toString())).getFSM().create(currentInfo.getStartTime(), (long) Long.valueOf(writeFdObj.toString()),Long.valueOf(currentInfo.getField(Field.PROTOCOL).toString()), Long.valueOf(currentInfo.getField(Field.FAMILY).toString()), Long.valueOf(currentInfo.getField(Field.TYPE).toString()));
								
						}
					//if ((eventOperationName == "Socket Connect") && (syscallRet >= 0)) {
					//FIXME: sometimes socket_connect returns numbers like -100 or ...
						if ((eventOperationName == "Socket Connect")) {
							long protocol = 0; 
							long port = 0;
							//System.out.println("Current Info: "+ currentInfo);
							if (currentInfo.containField(Field.DST_PORT)) {
								port = (Long) currentInfo.getField(Field.DST_PORT);
								if (currentInfo.containField(Field.PROTOCOL)){
									protocol = (Long) currentInfo.getField(Field.PROTOCOL);
									//FIXME: it has to be changed to client HTTP connection, server HTTP connection and ... .
									if (protocol == IPPROTO_TCP) {
										levelOperationNo = 1010l;
										if (port == 80)
											levelOperationNo = 1007l;
										if (port == 21)
											levelOperationNo = 1008l;
									}
									else if (protocol == IPPROTO_UDP) {
											if (port == 53)
												levelOperationNo = 1009l;
									}
								}
								String socket = currentInfo.getField(Field.SRC_ADDR) + ":" + currentInfo.getField(Field.SRC_PORT) + " --> " + currentInfo.getField(Field.DST_ADDR) + ":" + currentInfo.getField(Field.DST_PORT);
								
								if (shs.getCurrentStateValueInt(shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", currentInfo.getField(Field.FD).toString(), "socket")) < 0){
									int  socketQuark = shs.getQuarkAbsolutePath(true, "Resources","Network", socket);
									shs.updateCurrentState(socketQuark, shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", currentInfo.getField(Field.FD).toString(), "socket"));
								}
									
							}
							shs.modifyAttribute(currentInfo.getStartTime(), fd, shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "FDs", currentInfo.getField(Field.FD).toString(), "fd"));
							//PidFdNetFsm.get(currentProcessID).get((long)fd).getFSM().connect();
							//System.out.println(currentInfo);
							if ((syscallRet >= 0) || (syscallRet <= -10)){  //FIXME: sometimes socket_connect returns numbers like -100 or ...
								if (currentInfo.containField(Field.SRC_ADDR))
									PidFdNetFsm.get(currentProcessID).get((long)fd).getFSM().connect(Long.valueOf(currentInfo.getField(Field.SRC_ADDR).toString()), Long.valueOf(currentInfo.getField(Field.SRC_PORT).toString()), Long.valueOf( currentInfo.getField(Field.DST_ADDR).toString()), Long.valueOf(currentInfo.getField(Field.DST_PORT).toString()) );
								else
									PidFdNetFsm.get(currentProcessID).get((long)fd).getFSM().connect();
								
							}
							netaddingNeeded = true;
						}
						if ((eventOperationName == "Recieve Data") && (syscallRet >= 0)){
							if (fd != -1){ // this is a network read
								PidFdNetFsm.get(currentProcessID).get((long)fd).getFSM().send(syscallRet);
							}
							else {
								Object sock = currentInfo.getField(Field.SOCK);
								if (sock != null) {
									System.out.println("--------------------------->>><<<< SHould not reached!");
									fd = shs.getCurrentStateValueInt(shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "Sock", sock.toString(),"fd"));
									if (fd >= 0)
										PidFdNetFsm.get(currentProcessID).get((long)fd).getFSM().rcv(syscallRet);
									else
										System.out.println("Receiving Data with FD  null!");
								}
								else
									System.out.println("Receiving Data with both FD and SOCK equal null!");
							}
							netaddingNeeded = true;
						}
						if ((eventOperationName == "Send Data") && (syscallRet >= 0)){
							netaddingNeeded = true;
							if (fd != -1){ // it is a network read
								PidFdNetFsm.get(currentProcessID).get((long)fd).getFSM().send(syscallRet);
							}
							else {
								Object sock = currentInfo.getField(Field.SOCK);
								if (sock != null) {
									System.out.println("--------------------------->>><<<< SHould not reached!");
									fd = shs.getCurrentStateValueInt(shs.getQuarkAbsolutePath(true, "OpenFDs", currentProcessID.toString(), "Sock", sock.toString(),"fd"));
									if (fd >= 0)
										PidFdNetFsm.get(currentProcessID).get((long)fd).getFSM().send(syscallRet);
									else
										System.out.println("Sending Data with FD null!");
								}
								else
									System.out.println("Sending Data with both FD and SOCK equal null!");
							}
						}
						
						if (resourceName.isEmpty()) {
							int curQuark = shs.getQuarkAbsolutePath(false, "OpenFDs", currentProcessID.toString(), "FDs", obj.toString(), "type");
							if (curQuark >= 0) {
								fdType = shs.getCurrentStateValueInt(curQuark);
								if (fdType == NETWORKFD) {
									if (currentInfo.containField(Field.SRC_ADDR)){
										resourceName = currentInfo.getField(Field.SRC_ADDR) + ":" + currentInfo.getField(Field.SRC_PORT) + " --> " + currentInfo.getField(Field.DST_ADDR) + ":" + currentInfo.getField(Field.DST_PORT);
										resourceNameInt = shs.getQuarkAbsolutePath(true, "Resources","Network", resourceName);
									}
									else {
										resourceNameInt = shs.getCurrentStateValueInt(shs.getQuarkAbsolutePath(false, "OpenFDs", currentProcessID.toString(), "FDs", obj.toString(), "socket"));
										if (resourceNameInt < 0)
											resourceName = "unknown-1";
										else {
											resourceName = shs.getAttributeName(resourceNameInt);
											//resourceName = resourceName.substring(resourceName.lastIndexOf("/" +1));
										}
										//resourceName = shs.getCurrentStateValueStr(shs.getQuarkAbsolutePath(false, "OpenFDs", currentProcessID.toString(), "FDs", obj.toString(), "socket"));
									}
								}
								else if (fdType == FILEFD) {
									if (currentInfo.containField(Field.FILENAME)) {
										resourceName = currentInfo.getField(Field.FILENAME).toString();
										resourceName = resourceName.replace("/", "\\");
										if (resourceName.isEmpty())
											System.out.println("IS EMPTYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYY 3");
										resourceNameInt = shs.getQuarkAbsolutePath(true, "Resources","File", resourceName);
									}
									else {
										resourceNameInt = shs.getCurrentStateValueInt(shs.getQuarkAbsolutePath(false, "OpenFDs", currentProcessID.toString(), "FDs", obj.toString(), "filename"));
										if (resourceNameInt < 0)
											resourceName = "unknown-1";
										else {
											resourceName = shs.getAttributeName(resourceNameInt);
											//resourceName = resourceName.substring(resourceName.indexOf(("Resources/File" +1));
										}
									}
								}
								else if (fdType == PIPEFD) {
									resourceName = "pipe";	
									resourceNameInt = shs.getQuarkAbsolutePath(true, "Resources","Pipe", resourceName);
								}
									
								if (resourceName == null)
									resourceName = "unknown";
							}
							else {
								if (syscallRet < 0)
									return;//FIXME: we should handle unsuccessful operations
								else
									;//System.out.println(eventTs + ": !!!!!!!!!!!!!!!!!!!!! Should not be reached here!!!!, pid:"+currentProcessID+", "+ eventMapper.get((long)currentInfo.getSyscallId()));
							}
							
						}
						
						if (currentProcessName.length() > 75)
							System.out.println( "!!!!!!!!!!!!!!!! " + resourceName.length()+ " : !!!!!!!!!!!!!!!!");
						
						//pidNodeLevel1 = shs.getQuarkRelativePath(true,  level1Quark,  currentProcessID.toString(), "Ops", eventOperationType ,"FDs", currentInfo.getField(Field.FD).toString(), resourceName);
						//pidNodeLevel2 = shs.getQuarkRelativePath(true,  level2Quark,  currentProcessID.toString(), "Ops", eventOperationType ,"FDs", currentInfo.getField(Field.FD).toString(), resourceName);
						
						//pidNodeLevel1 = shs.getQuarkRelativePath(true,  level1Quark,  currentProcessName, currentProcessID.toString());
						//pidNodeLevel2 = shs.getQuarkRelativePath(true,  level2Quark,  currentProcessName, currentProcessID.toString());
						
						pidNodeLevel1 = shs.getQuarkAbsolutePath(true, "Processes", currentProcessName, currentProcessID.toString(),"$L1");
						pidNodeLevel2 = shs.getQuarkAbsolutePath(true, "Processes", currentProcessName, currentProcessID.toString(),"$L2");
						
					}
					else {
						
						if (eventOperationName == "Create a Child Process")
						{
							pidNodeLevel0 = shs.getQuarkAbsolutePath(true, "Processes", currentProcessName, currentProcessID.toString(),"$L0");
							long startingTime = currentInfo.getStartTime();
							shs.modifyAttribute(startingTime, 2014 /*fork a process*/, pidNodeLevel0);
							shs.removeAttribute(eventTs, pidNodeLevel0);
							
							if (snodeList.containsKey(pidNodeLevel0))
								snodeTime = snodeList.get(pidNodeLevel0);
								else
									snodeTime = new HashMap<Long, Snode>();
								if (snodeTime.containsKey(startingTime))
									snode  = snodeTime.get(startingTime);
								else
									snode = new Snode(currentProcessID, processNameId, currentInfo.getSyscallId(), currentInfo.getField(Field.CHILD_PID).toString());
								snodeTime.put(startingTime, snode);
								snodeList.put(pidNodeLevel0, snodeTime);
						}
						
						if (eventOperationName == "Create a Child Process" ||eventOperationName == "Get Current Process ID" || eventOperationName == "Create a Child Process and Block Parrent"||eventOperationName == "Exit Process"||eventOperationName == "Wait for Process to Change State"||eventOperationName == "Kill Process" ||eventOperationName == "Wait for Signal") 
							resourceNameInt = shs.getQuarkAbsolutePath(true, "Processes", currentProcessName, syscallRet.toString());
						
						if (eventOperationName == "Execute Program"){
							if (currentInfo.getField(Field.FILENAME) != null) {
								resourceName = currentInfo.getField(Field.FILENAME).toString();
								resourceName = resourceName.replace("/", "\\");
								if (!resourceName.isEmpty())
									resourceNameInt = shs.getQuarkAbsolutePath(true, "Processes", resourceName);
								
								if (parent.containsKey(currentProcessID)){
									long parentPid = parent.get(currentProcessID);
									pidNodeLevel0 = shs.getQuarkAbsolutePath(true, "Processes", currentProcessName, currentProcessID.toString(),"$L0");
									long startingTime = currentInfo.getStartTime();
									shs.modifyAttribute(startingTime, 2013 /*forked by*/, pidNodeLevel0);
									shs.removeAttribute(eventTs, pidNodeLevel0);
									
									if (snodeList.containsKey(pidNodeLevel0))
										snodeTime = snodeList.get(pidNodeLevel0);
										else
											snodeTime = new HashMap<Long, Snode>();
										if (snodeTime.containsKey(startingTime))
											snode  = snodeTime.get(startingTime);
										else
											snode = new Snode(currentProcessID, processNameId, currentInfo.getSyscallId(), String.valueOf(parentPid));
										snodeTime.put(startingTime, snode);
										snodeList.put(pidNodeLevel0, snodeTime);
								}
							}
							//resourceNameInt = shs.getQuarkAbsolutePath(true, "Processes", currentProcessName, syscallRet.toString());
						}
						
						
						pidNodeLevel1 = shs.getQuarkAbsolutePath(true, "Processes", currentProcessName, currentProcessID.toString(),"$L1");
						pidNodeLevel2 = shs.getQuarkAbsolutePath(true, "Processes", currentProcessName, currentProcessID.toString(),"$L2");
						
						
						
						
						
						
						//FIXME (Important): we should write these synthetic event to the staet mashine as well. 
						//?pidNodeLevel0 = shs.getQuarkAbsolutePath(true, "L0",  currentProcessID.toString(), "Ops", "Process Ops", "FDs",  obj.toString(), resourceName);
						//?shs.modifyAttribute(netOpList.getFSM().getStartingTs(), (int) netOpList.getFSM().getSyntheticeventName(), pidNodeLevel0);
						//?shs.removeAttribute(eventTs, pidNodeLevel0);
						
						/*try {
							
							level0Out.write(currentProcessName + " (" + currentProcessID.toString() + "): " + eventMapper.get((long)currentInfo.getSyscallId()).getOperationName()+" - " + currentInfo.toString() + ", Ret= "+ syscallRet);
							level0Out.newLine();
							
							//2sortedDurations.add(eventTs - fileOpList.getFSM().getStartingTs());
							sortedDurations.add(eventTs - currentInfo.getStartTime());
							
							
							if (filterArray.contains(currentProcessID)&& !filterSyscallsArray.contains((long)currentInfo.getSyscallId())){
								fLevel0Out.write(currentProcessName + " (" + currentProcessID.toString() + "): " + eventMapper.get((long)currentInfo.getSyscallId()).getOperationName()+" - " + currentInfo.toString() + ", Ret= "+ syscallRet);
								fLevel0Out.newLine();
							}
							
						} catch (IOException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
						*/
						
						
					}
					//pidNode = shs.getQuarkAbsolutePath(true, "Threads", currentProcessID.toString(), "Ops", eventOperationType ,"Level2");
					
				
					//FIXME: for fd_state and sched_schedule and ... we need to check the pid name. for instance most of the time the current_procss id for fd_state is 0. so should be care of that.
	
					
					/*Update Event List for Level 2 (: Lowest Level)*/	
					
					
					shs.modifyAttribute(currentInfo.getStartTime(), currentInfo.getSyscallId(), pidNodeLevel2);
					shs.removeAttribute(eventTs, pidNodeLevel2);
					
					if (snodeList.containsKey(pidNodeLevel2))
						snodeTime = snodeList.get(pidNodeLevel2);
					else
						snodeTime = new HashMap<Long, Snode>();
					
					if (snodeTime.containsKey(currentInfo.getStartTime()))
						snode  = snodeTime.get(currentInfo.getStartTime());
					else {
						if (eventOperationName == "Create a Child Process" || eventOperationName == "Create a Child Process and Block Parrent") 
							snode = new Snode(currentProcessID, processNameId, currentInfo.getSyscallId(), currentInfo.getField(Field.CHILD_PID).toString(), currentInfo.getStartTime(), eventTs);
						else
							snode = new Snode(currentProcessID, processNameId, currentInfo.getSyscallId(), resourceNameInt, currentInfo.getStartTime(), eventTs);//snode = new Snode(currentProcessID, currentInfo.getSyscallId(), shs.getQuarkAbsolutePath(true,"Resources", resourceName), currentInfo.getStartTime(), eventTs);
					}
					snode.addParent(pidNodeLevel1, currentInfo.getStartTime());
					snodeTime.put(currentInfo.getStartTime(), snode);
					snodeList.put(pidNodeLevel2, snodeTime);
					String resourceName2="";
					if (!resourceName.isEmpty())
						resourceName2 = ", Resource Name= " + resourceName;
					/*try {
						//level2Out.write(currentProcessName + ": " +eventMapper.get((long)currentInfo.getSyscallId()).getOperationName()+" - " + currentInfo.toString() + resourceName2 + ", Ret= "+ syscallRet);// + " ("+ currentInfo.getStartTime()+" - " + eventTs+")");
						
						level2Out.write(currentProcessName + ": " +eventMapper.get((long)currentInfo.getSyscallId()).getOperationName()+" - " + currentInfo.toString() +  ", Ret= "+ syscallRet);// + " ("+ currentInfo.getStartTime()+" - " + eventTs+")");
						level2Out.newLine();
						
						//sortedDurations.add(eventTs - currentInfo.getStartTime());
						//System.out.println(eventTs - currentInfo.getStartTime() + "::" + currentInfo.toString());
						
						
						if (filterArray.contains(currentProcessID)&& !filterSyscallsArray.contains((long)currentInfo.getSyscallId())){
							fLevel2Out.write(currentProcessName + ": " +eventMapper.get((long)currentInfo.getSyscallId()).getOperationName()+" - " + currentInfo.toString() +  ", Ret= "+ syscallRet);// + " ("+ currentInfo.getStartTime()+" - " + eventTs+")");
							fLevel2Out.newLine();
						}
						
						
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}*/
					//int ssize = resourceName.length();
					//if (ssize > 80)
					//	System.out.println("------------------ > SIZE OF RESOURCENAME IS:  " + resourceName.length());
					
					if (addingNeeded)
						PidFdFsm.get(currentProcessID).get((long)fd).addAMember(pidNodeLevel1,currentInfo.getStartTime());
					if (netaddingNeeded)
						PidFdNetFsm.get(currentProcessID).get((long)fd).addAMember(pidNodeLevel1,currentInfo.getStartTime());
					
					/*Update Event List for Level 1*/
					shs.modifyAttribute(currentInfo.getStartTime(), (int) levelOperationNo, pidNodeLevel1);
					//System.out.println("pid:" + currentProcessID + ",quark:" + pidNodeLevel1 + ", " + levelOperationNo);
					shs.removeAttribute(eventTs, pidNodeLevel1);
					if (snodeList.containsKey(pidNodeLevel1))
						snodeTime = snodeList.get(pidNodeLevel1);
					else
						snodeTime = new HashMap<Long, Snode>();
					
					if (snodeTime.containsKey(currentInfo.getStartTime()))
						snode  = snodeTime.get(currentInfo.getStartTime());
					else {
						if (eventOperationName == "Create a Child Process" || eventOperationName == "Create a Child Process and Block Parrent") 
							snode = new Snode(currentProcessID, processNameId, currentInfo.getSyscallId(), currentInfo.getField(Field.CHILD_PID).toString(), pidNodeLevel2,currentInfo.getStartTime());
						else
							snode = new Snode(currentProcessID, processNameId, currentInfo.getSyscallId(), resourceNameInt, pidNodeLevel2, currentInfo.getStartTime());//snode = new Snode(currentProcessID, currentInfo.getSyscallId(), shs.getQuarkAbsolutePath(true,"Resources", resourceName), pidNodeLevel2, currentInfo.getStartTime());
					}
					snodeTime.put(currentInfo.getStartTime(), snode);
					snodeList.put(pidNodeLevel1, snodeTime);
					/*try {
						
						level1Out.write(currentProcessName + ": " + eventMapper.get((long)levelOperationNo).getOperationName()+" - " +  currentInfo.toString() + ", Resource:"+resourceName + ", Ret= "+ syscallRet);// +" ("+ currentInfo.getStartTime()+" - " + eventTs+")");			
						level1Out.newLine();
						
						if (filterArray.contains(currentProcessID)&& !filterSyscallsArray.contains((long)currentInfo.getSyscallId())){
							fLevel1Out.write(currentProcessName + ": " + eventMapper.get((long)levelOperationNo).getOperationName()+" - " +  currentInfo.toString() + ", Resource:"+resourceName + ", Ret= "+ syscallRet);// +" ("+ currentInfo.getStartTime()+" - " + eventTs+")");			
							fLevel1Out.newLine();
						}
						
						
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					*/
					
					countl ++;
					
					
					if ((eventOperationName == "Exit Process") || (eventOperationName == "Kill Process")){
						if (filterArray.contains(currentProcessID))
							filterArray.remove(currentProcessID);
					}
					
					
						
				}
			}
			else
				;//System.out.println(eventTs+":syscall_exit without syscall_entry");	
		
		
		
			
		
	}
	
	public void handle_fs_lseek(TraceReader reader, JniEvent event) {
		Long currentProcessID = 0l;
		String currentProcessName = "";
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc != null){
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}
		String eventName = event.getMarkersMap().get(event.getEventMarkerId()).getName();
		Long fd = (Long) event.parseFieldByName("fd");
		Long offset = (Long)event.parseFieldByName("offset");
		Long origin = (Long)event.parseFieldByName("origin");
		Long eventTs = event.getEventTime().getTime();
		
		if (currentTask.containsKey(currentProcessID)){
			//Read the filename from the current open files. then update the currentTask
			//currentTask.get(currentProcessID).setField(Field.FILENAME, filename);
			currentTask.get(currentProcessID).setField(Field.FD, fd);
			currentTask.get(currentProcessID).setField(Field.OFFSET, offset);
			currentTask.get(currentProcessID).setField(Field.ORIGIN, origin);		
		}
		else
			System.out.println(eventTs+":File lseek without syscall_entry");
		if (fd >= 0) {
			if (PidFdFsm.containsKey(currentProcessID))
				fileOperations = PidFdFsm.get(currentProcessID);
			else
				fileOperations = new HashMap<Long, FileOperationList>();
			
			if (fileOperations.containsKey(fd))
				fileOpList = fileOperations.get(fd);
			else
				fileOpList = new FileOperationList();

			fileOperations.put(fd, fileOpList);
			PidFdFsm.put(currentProcessID, fileOperations);
		}
	}
	public void handle_fs_llseek(TraceReader reader, JniEvent event) {
		Long currentProcessID = 0l;
		String currentProcessName = "";
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc != null){
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}
		String eventName = event.getMarkersMap().get(event.getEventMarkerId()).getName();
		Long fd = (Long) event.parseFieldByName("fd");
		Long offset = (Long)event.parseFieldByName("offset");
		Long origin = (Long)event.parseFieldByName("origin");
		Long eventTs = event.getEventTime().getTime();
		if (currentTask.containsKey(currentProcessID)){
			//Read the filename from the current open files. then update the currentTask
			//currentTask.get(currentProcessID).setField(Field.FILENAME, filename);
			currentTask.get(currentProcessID).setField(Field.FD, fd);
			currentTask.get(currentProcessID).setField(Field.OFFSET, offset);
			currentTask.get(currentProcessID).setField(Field.ORIGIN, origin);		
		}
		else
			System.out.println(eventTs+":File llseek without syscall_entry");
		if (fd >= 0) {
			if (PidFdFsm.containsKey(currentProcessID))
				fileOperations = PidFdFsm.get(currentProcessID);
			else
				fileOperations = new HashMap<Long, FileOperationList>();
			
			if (fileOperations.containsKey(fd))
				fileOpList = fileOperations.get(fd);
			else
				fileOpList = new FileOperationList();

			fileOperations.put(fd, fileOpList);
			PidFdFsm.put(currentProcessID, fileOperations);
		}
	}
	
	public void handle_fs_pipe(TraceReader reader, JniEvent event) {
		Long currentProcessID = 0l;
		String currentProcessName = "";
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc != null){
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}
		String eventName = event.getMarkersMap().get(event.getEventMarkerId()).getName();
		Long eventTs = event.getEventTime().getTime();
		Long readFd = (Long) event.parseFieldByName("readfd");
		Long writeFd = (Long) event.parseFieldByName("writefd");
		

		if (currentTask.containsKey(currentProcessID)) {
			currentTask.get(currentProcessID).setField(Field.WRITE_FD, writeFd);
			currentTask.get(currentProcessID).setField(Field.FD, readFd);
			currentTask.get(currentProcessID).setField(Field.FILENAME, "pipe");
		}
		else
			;//System.out.println(eventTs+":File open without syscall_entry");
		if (readFd >= 0) {
			if (PidFdFsm.containsKey(currentProcessID))
				fileOperations = PidFdFsm.get(currentProcessID);
			else
				fileOperations = new HashMap<Long, FileOperationList>();
			
			if (fileOperations.containsKey(readFd))
				fileOpList = fileOperations.get(readFd);
			else
				fileOpList = new FileOperationList();
			
			fileOpList.getFSM().open(eventTs, "pipe");
			fileOperations.put(readFd, fileOpList);
			PidFdFsm.put(currentProcessID, fileOperations);
		}
		if (writeFd >= 0) {
			if (PidFdFsm.containsKey(currentProcessID))
				fileOperations = PidFdFsm.get(currentProcessID);
			else
				fileOperations = new HashMap<Long, FileOperationList>();
			
			if (fileOperations.containsKey(writeFd))
				fileOpList = fileOperations.get(writeFd);
			else
				fileOpList = new FileOperationList();
			
			//if (eventTs >= 1890234854065l)
			//	System.out.println("ts: " + eventTs + ", pid: "+ currentProcessID + ", fd: "+readFd+", pipe ");
			fileOpList.getFSM().open(eventTs + 1, "pipe");
			fileOperations.put(writeFd, fileOpList);
			PidFdFsm.put(currentProcessID, fileOperations);
		}
		
	}
	
	public void handle_fs_select(TraceReader reader, JniEvent event) {
		String eventName = event.getMarkersMap().get(event.getEventMarkerId()).getName();
	}
	
	public void handle_fd_state_file_descriptor(TraceReader reader, JniEvent event) {
		Long eventTs = event.getEventTime().getTime();
		String eventName = event.getMarkersMap().get(event.getEventMarkerId()).getName();
		int type = 0; //0: unknown, 1: file. 2: network. 3: pipe
		Long currentProcessID = 0l;
		ArrayList<Long> pids = null;
		String currentProcessName = "";
		Long fd = (Long) event.parseFieldByName("fd");
		Long cPid = (Long)event.parseFieldByName("pid");
		String filename = (String) event.parseFieldByName("filename");
		filename = filename.replace("/", "\\");
		pids = tgidPids.get(cPid);
		if (pids == null) {
			pids = new ArrayList<Long>(1);
			pids.add(cPid);	
		}
		
		for (Long pid : pids) {
			int pidNode = -1;
			int resourceQuark = -1;
			if (filename.contains("socket:[")){
				type = 2; // Network
				pidNode = shs.getQuarkAbsolutePath(true, "OpenFDs", pid.toString(), "FDs", fd.toString(), "socket");
				resourceQuark = shs.getQuarkAbsolutePath(true, "Resources", "Network", filename);
				
				
				if (PidFdNetFsm.containsKey(pid))
					netOperations = PidFdNetFsm.get(pid);
				else
					netOperations = new HashMap<Long, NetworkOperationList>();
				netOperations.put(fd, new NetworkOperationList(eventTs));
				PidFdNetFsm.put(pid, netOperations);
			}
			else if (filename.contains("pipe:[")){
				type = 3; // Pipe
				//pidNode = shs.getQuarkAbsolutePath(true, "Threads", pid.toString(), "FDs", fd.toString(), "pipe");
				pidNode = shs.getQuarkAbsolutePath(true, "OpenFDs", pid.toString(), "FDs", fd.toString(), "pipe");
				resourceQuark = shs.getQuarkAbsolutePath(true, "Resources", "Pipe", filename);
			}	
			else {
				type = 1; // File
				pidNode = shs.getQuarkAbsolutePath(true, "OpenFDs", pid.toString(), "FDs", fd.toString(), "filename");
				resourceQuark = shs.getQuarkAbsolutePath(true, "Resources", "File", filename);
				
				if (PidFdFsm.containsKey(pid))
					fileOperations = PidFdFsm.get(pid);
				else
					fileOperations = new HashMap<Long, FileOperationList>();
				fileOperations.put(fd, new FileOperationList());
				PidFdFsm.put(pid, fileOperations);
			}
				
			if (filename.length() >= 75) {
				filename = filename.substring(filename.length() - 75);
			}

			shs.modifyAttribute(eventTs, resourceQuark, pidNode);
			
			pidNode = shs.getQuarkAbsolutePath(true, "OpenFDs", pid.toString(), "FDs", fd.toString(), "fd");
			shs.modifyAttribute(eventTs, fd.intValue(), pidNode);
			
			int pidType = shs.getQuarkAbsolutePath(true, "OpenFDs", pid.toString(), "FDs", fd.toString(), "type");
			shs.modifyAttribute(eventTs, type, pidType);
		}
		
	}
	public void handle_fs_pollfd(TraceReader reader, JniEvent event) {
		Long currentProcessID = 0l;
		String currentProcessName = "";
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc != null){
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}
		String eventName = event.getMarkersMap().get(event.getEventMarkerId()).getName();
		Long fd = (Long) event.parseFieldByName("fd");
		Long eventTs = event.getEventTime().getTime();
		
		if (currentTask.containsKey(currentProcessID)){
			currentTask.get(currentProcessID).setField(Field.FD, fd);
		}
		else
			System.out.println(eventTs+":pullfd without syscall_entry");
	}
	
	public void  handle_net_socket_bind(TraceReader reader, JniEvent event) {
		Long currentProcessID = 0l;
		String currentProcessName = "";
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc != null){
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}

		Long fd = (Long) event.parseFieldByName("fd");
	}
	
	public void  handle_net_socket_connect(TraceReader reader, JniEvent event) {
		Long currentProcessID = 0l;
		String currentProcessName = "";
		Long eventTs = event.getEventTime().getTime();
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc != null){
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}
		Long fd = (Long) event.parseFieldByName("fd");
		Long ret = (Long) event.parseFieldByName("ret");
		Object sock = event.parseFieldByName("sock");
		//if (ret < 0)
		//	return;
		if (currentTask.containsKey(currentProcessID)) {
			currentTask.get(currentProcessID).setField(Field.FD, fd);
			currentTask.get(currentProcessID).setField(Field.RET, ret);
			currentTask.get(currentProcessID).setField(Field.SOCK, sock);
			eventTs = currentTask.get(currentProcessID).getStartTime();
		}
		if (fd >= 0) {
			if (PidFdNetFsm.containsKey(currentProcessID))
				netOperations = PidFdNetFsm.get(currentProcessID);
			else
				netOperations = new HashMap<Long, NetworkOperationList>();
			
			if (netOperations.containsKey(fd))
				netOpList = netOperations.get(fd);
			else
				netOpList = new NetworkOperationList(eventTs);
			//netOpList.getFSM().connect();
			netOperations.put(fd, netOpList);
			PidFdNetFsm.put(currentProcessID, netOperations);
		}
		
		detection.Analysis("net.socket_connect",currentProcessID, eventTs, null, currentProcessName, null);

	}
	
	public void  handle_net_socket_connect_inet(TraceReader reader, JniEvent event) {
		Long currentProcessID = 0l;
		String currentProcessName = "";
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc != null){
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}
		Long src = (Long) event.parseFieldByName("saddr");
		Long dst = (Long) event.parseFieldByName("daddr");
		Long srcPort   = (Long) event.parseFieldByName("source");
		Long dstPort = (Long) event.parseFieldByName("dest");
		long fd = -1l;
		if (currentTask.containsKey(currentProcessID)) {
				currentTask.get(currentProcessID).setField(Field.SRC_ADDR, src);
				currentTask.get(currentProcessID).setField(Field.DST_ADDR, dst);
				currentTask.get(currentProcessID).setField(Field.SRC_PORT, srcPort);
				currentTask.get(currentProcessID).setField(Field.DST_PORT, dstPort);
		}
	}
	public void  handle_net_socket_listen(TraceReader reader, JniEvent event) {
		Long currentProcessID = 0l;
		String currentProcessName = "";
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc != null){
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}

		Long fd = (Long) event.parseFieldByName("fd");
		Long backlog = (Long) event.parseFieldByName("backlog");
		Long ret = (Long) event.parseFieldByName("ret");
		
		
		
		
	}
	public void  handle_net_socket_accept(TraceReader reader, JniEvent event) {
		Long currentProcessID = 0l;
		String currentProcessName = "";
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc != null){
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}
		Long fd = (Long) event.parseFieldByName("fd");
		String upeer_sockaddr = event.parseFieldByName("upeer_sockaddr").toString();
		String upeer_addrlen = event.parseFieldByName("upeer_addrlen").toString();
		Long gs = (Long) event.parseFieldByName("flags");
		Long ret = (Long) event.parseFieldByName("ret");
		
		
		
		
	}
	public void  handle_net_dev_xmit(TraceReader reader, JniEvent event) {
		Long currentProcessID = 0l;
		String currentProcessName = "";
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc != null){
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}

		String skb = event.parseFieldByName("skb").toString();
		Long protocol = (Long) event.parseFieldByName("protocol");
		Long fd = 1L;
		
		NetworkOperationList netOpList;
		String operation = "dev_xmit";
		String operand="skb: "+skb+", protocol: "+protocol.toString();

	}
	public void  handle_net_socket_recvmsg(TraceReader reader, JniEvent event) {
		Long currentProcessID = 0l;
		String currentProcessName = "";
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc != null){
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}

		//String skb = event.parseFieldByName("skb").toString();
		Object sock = event.parseFieldByName("sock");
		Long fd = 1L;
		
		NetworkOperationList netOpList;
		String operation = "dev_xmit";
		//String operand="skb: "+skb+", protocol: "+protocol.toString();
		//System.out.println("syscallID: " +eventMapper.get((long)((SyscallInfo) currentTask.get(currentProcessID)).getSyscallId()).getOperationName());

		if (currentTask.containsKey(currentProcessID)) {
			currentTask.get(currentProcessID).setField(Field.SOCK, sock);
		}
		
	}
	public void  handle_net_socket_sendmsg(TraceReader reader, JniEvent event) {
		Long currentProcessID = 0l;
		String currentProcessName = "";
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc != null){
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}

		//String skb = event.parseFieldByName("skb").toString();
		Object sock = event.parseFieldByName("sock");
		Long fd = 1L;
		
		NetworkOperationList netOpList;
		String operation = "dev_xmit";
		//String operand="skb: "+skb+", protocol: "+protocol.toString();
		
		//System.out.println("syscallID: " +eventMapper.get((long)((SyscallInfo) currentTask.get(currentProcessID)).getSyscallId()).getOperationName());

		if (currentTask.containsKey(currentProcessID)) {
			currentTask.get(currentProcessID).setField(Field.SOCK, sock);
		}
	}
	
	public void handle_net_dev_xmit_extended(TraceReader reader, JniEvent event) {
		String eventName = event.getMarkersMap().get(event.getEventMarkerId()).getName();
		Long currentProcessID;
		Long fd = 0l;
		String currentProcessName="";
		Long eventTs = event.getEventTime().getTime();
		Long cpu = event.getParentTracefile().getCpuNumber();
		
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc == null){
				currentProcessID = 0L;
				currentProcessName ="";
			}
			else{
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}
		else
			currentProcessID = 0L;
		Long network_protocol = (Long) event.parseFieldByName("network_protocol");
		Long transport_protocol = (Long) event.parseFieldByName("transport_protocol");
		Long saddr = (Long) event.parseFieldByName("saddr");
		Long daddr = (Long) event.parseFieldByName("daddr");
		Long tot_len = (Long) event.parseFieldByName("tot_len");
		Long ihl = (Long) event.parseFieldByName("ihl");
		Long source = (Long) event.parseFieldByName("source");
		Long dest = (Long) event.parseFieldByName("dest");
		Long seq = (Long) event.parseFieldByName("seq");
		Long ack_seq = (Long) event.parseFieldByName("ack_seq");
		Long doff = (Long) event.parseFieldByName("doff");
		Long ack = (Long) event.parseFieldByName("ack");
		Long rst = (Long) event.parseFieldByName("rst");
		Long syn = (Long) event.parseFieldByName("syn");
		Long fin = (Long) event.parseFieldByName("fin");
		
		SyscallInfo currentInfo = (SyscallInfo) currentTask.get(currentProcessID);
		
		if (currentInfo != null && eventMapper.containsKey((long)currentInfo.getSyscallId())) {
			if (eventMapper.get((long)currentInfo.getSyscallId()).getOperationName() == "Socket Connect")
				currentTask.get(currentProcessID).setField(Field.PROTOCOL, transport_protocol);
		}
		
		/*pidNode = shs.getQuarkAbsolutePath(false, "Connections", saddr.toString(), source.toString(), daddr.toString(), dest.toString() , "pid");
		int fdNode = shs.getQuarkAbsolutePath(false, "Connections", saddr.toString(), source.toString(), daddr.toString(), dest.toString() , "fd");
		if (pidNode < 0 || fdNode < 0) {
			System.out.println("Unknown Connection. this can be happened even after colsing the connection");
			return;
		}
		currentProcessID = (long) shs.getCurrentStateValueInt(pidNode);
		fd = (long) shs.getCurrentStateValueInt(fdNode);
		if (fd >= 0) {
			if (PidFdNetFsm.containsKey(currentProcessID))
				netOperations = PidFdNetFsm.get(currentProcessID);
			else
				netOperations = new HashMap<Long, NetworkOperationList>();
			
			if (netOperations.containsKey(fd))
				netOpList = netOperations.get(fd);
			else
				netOpList = new NetworkOperationList();
			netOpList.getFSM().send(transport_protocol, tot_len);
			netOperations.put(fd, netOpList);
			PidFdNetFsm.put(currentProcessID, netOperations);
		}
		else //FIXME: should not reach to this code
			System.out.println("FD is ZEROOOOOOOOOOO");	*/
	}
	public void  handle_net_dev_receive(TraceReader reader, JniEvent event) {
		Long currentProcessID = 0l;
		String currentProcessName = "";
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc != null){
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}
		
		String skb = event.parseFieldByName("skb").toString();
		Long protocol = (Long) event.parseFieldByName("protocol");
		Long fd = 1L;
		
		NetworkOperationList netOpList;
		String operation = "dev_receive";
		String operand="skb: "+skb+", protocol: "+protocol.toString();

	}
	public void  handle_net_tcpv4_rcv(TraceReader reader, JniEvent event) {
		Long currentProcessID = 0l;
		String currentProcessName = "";
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc != null){
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}

		String skb = event.parseFieldByName("skb").toString();
		//Long protocol = (Long) event.parseFieldByName("protocol");
		Long fd = 1L;
		
		NetworkOperationList netOpList;
		String operation = "tcpv4_rcv";
		String operand="skb: "+skb;
		
	
	}
	public void  handle_net_udpv4_rcv(TraceReader reader, JniEvent event) {
		Long currentProcessID = 0l;
		String currentProcessName = "";
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc != null){
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}
		
		String skb = event.parseFieldByName("skb").toString();
		//Long protocol = (Long) event.parseFieldByName("protocol");
		Long fd = 1L;
		
		NetworkOperationList netOpList;
		String operation = "udpv4_rcv";
		String operand="skb: "+skb;
	}
	
	public void handle_net_tcpv4_rcv_extended(TraceReader reader, JniEvent event) {
		String eventName = event.getMarkersMap().get(event.getEventMarkerId()).getName();
		Long currentProcessID;
		Long fd = -1l;
		String currentProcessName="";
		Long eventTs = event.getEventTime().getTime();
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc == null){
				currentProcessID = 0L;
				currentProcessName ="";
			}
			else{
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}
		else
			currentProcessID = 0L;
		Long saddr = (Long) event.parseFieldByName("saddr");
		Long daddr = (Long) event.parseFieldByName("daddr");
		Long tot_len = (Long) event.parseFieldByName("tot_len");
		Long ihl = (Long) event.parseFieldByName("ihl");
		Long source = (Long) event.parseFieldByName("source");
		Long dest = (Long) event.parseFieldByName("dest");
		Long seq = (Long) event.parseFieldByName("seq");
		Long ack_seq = (Long) event.parseFieldByName("ack_seq");
		Long doff = (Long) event.parseFieldByName("doff");
		Long ack = (Long) event.parseFieldByName("ack");
		Long rst = (Long) event.parseFieldByName("rst");
		Long syn = (Long) event.parseFieldByName("syn");
		Long fin = (Long) event.parseFieldByName("fin");
		
		
		/*pidNode = shs.getQuarkAbsolutePath(false, "Connections", daddr.toString(), dest.toString(), saddr.toString(), source.toString() , "pid");
		int fdNode = shs.getQuarkAbsolutePath(false, "Connections", daddr.toString(), dest.toString(), saddr.toString(), source.toString() , "fd");
		if (pidNode < 0 || fdNode < 0){
			System.out.println("Unknown Connection, this can be happened even after receiving the connection");
			return;
		}
		currentProcessID = (long) shs.getCurrentStateValueInt(pidNode);
		fd = (long) shs.getCurrentStateValueInt(fdNode);
		if (fd >= 0) {
			if (PidFdNetFsm.containsKey(currentProcessID))
				netOperations = PidFdNetFsm.get(currentProcessID);
			else
				netOperations = new HashMap<Long, NetworkOperationList>();
			
			if (netOperations.containsKey(fd))
				netOpList = netOperations.get(fd);
			else
				netOpList = new NetworkOperationList();
			netOpList.getFSM().rcv(IPPROTO_TCP, tot_len);
			netOperations.put(fd, netOpList);
			PidFdNetFsm.put(currentProcessID, netOperations);
		}
		else //FIXME: should not reach to this code
			System.out.println("FD is ZEROOOOOOOOOOO");
		*/
	}
	public void handle_net_udpv4_rcv_extended(TraceReader reader, JniEvent event) {
		String eventName = event.getMarkersMap().get(event.getEventMarkerId()).getName();
		Long currentProcessID;
		Long fd = -1l;
		String currentProcessName="";
		Long eventTs = event.getEventTime().getTime();
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc == null){
				currentProcessID = 0L;
				currentProcessName ="";
			}
			else{
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}
		else
			currentProcessID = 0L;
		Long saddr = (Long) event.parseFieldByName("saddr");
		Long daddr = (Long) event.parseFieldByName("daddr");
		Long unicast = (Long) event.parseFieldByName("unicast");
		Long ulen = (Long) event.parseFieldByName("ulen");
		Long source = (Long) event.parseFieldByName("source");
		Long dest = (Long) event.parseFieldByName("dest");
	
		/*pidNode = shs.getQuarkAbsolutePath(false, "Connections", daddr.toString(), dest.toString(), saddr.toString(), source.toString() , "pid");
		int fdNode = shs.getQuarkAbsolutePath(false, "Connections", daddr.toString(), dest.toString(), saddr.toString(), source.toString() , "fd");
		if (pidNode < 0 || fdNode < 0){
			System.out.println("Unknown Connection. this can be happened even after receiving the connection");
			return;
		}
		currentProcessID = (long) shs.getCurrentStateValueInt(pidNode);
		fd = (long) shs.getCurrentStateValueInt(fdNode);
		if (fd >= 0) {
			if (PidFdNetFsm.containsKey(currentProcessID))
				netOperations = PidFdNetFsm.get(currentProcessID);
			else
				netOperations = new HashMap<Long, NetworkOperationList>();
			
			if (netOperations.containsKey(fd))
				netOpList = netOperations.get(fd);
			else
				netOpList = new NetworkOperationList();
			netOpList.getFSM().rcv(IPPROTO_UDP, ulen);
			netOperations.put(fd, netOpList);
			PidFdNetFsm.put(currentProcessID, netOperations);
		}
		else //FIXME: should not reach to this code
			System.out.println("FD is ZEROOOOOOOOOOO");
		*/
		
	}
	
	public void handle_kernel_process_fork(TraceReader reader, JniEvent event) throws ParseException {
		Long currentProcessID;
		Long currentProcessTGID;
		Long eventTs = event.getEventTime().getTime();
		String currentProcessName = "";
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc == null){
				currentProcessID = Long.valueOf(0);
			}
			else{
				currentProcessID = proc.getPid();
				currentProcessTGID = proc.getTgid();
				currentProcessName = proc.getCmd();
			}
		}
		else
			currentProcessID = Long.valueOf(0);
		Long parent_pid = (Long) event.parseFieldByName("parent_pid");
		Long child_pid = (Long) event.parseFieldByName("child_pid");
		Long child_tgid = (Long) event.parseFieldByName("child_tgid");
		
		//if (child_pid == 18323)
		//	System.out.println("ncat");	
		
		detection.Analysis("kernel.process_fork",currentProcessID, eventTs, "", currentProcessName,child_pid);

		
		if (filterArray.contains(parent_pid))
			filterArray.add(child_pid);
		
		parent.put(child_pid, parent_pid);
		
		if (currentTask.containsKey(currentProcessID)) {
			currentTask.get(currentProcessID).setField(Field.CHILD_PID, child_pid);
			currentTask.get(currentProcessID).setField(Field.PARENT_PID, parent_pid);
		}
		FileOperationList fileOpList;
		String filename="Process Operation";
		String filenameValue = "";
		String operand = "parent pid:" + parent_pid + ", child pid:" + child_pid + ", child tgid:" + child_tgid;
		String operation= "Process Fork (" + operand + ")";
				
		KernelProcess proc = new KernelProcess();
		proc.setPid(child_pid);

		/* Here We copy all open fds of the parent to the child process*/
		int quark = shs.getQuarkAbsolutePath(true, "OpenFDs", parent_pid.toString(), "FDs");
		ArrayList<Integer> quarkArray = shs.getSubAttributes(quark);
		for (int i = 0; i < quarkArray.size(); i++) {
			int fdQuark = shs.getQuarkRelativePath(true, quarkArray.get(i), "fd");
			int fdValue = shs.getCurrentStateValueInt(fdQuark);
			if (fdValue == -1) {
				continue;
			}
			//System.out.println("forked fd= " + fdValue);
			int fdType = shs.getCurrentStateValueInt(shs.getQuarkRelativePath(true, quarkArray.get(i), "type"));
			if (fdType == -1 ) {
				System.out.println("SHOULDN'T REACH HERE! unknown fd, fd= " + fdValue);
				continue;
			}
			shs.modifyAttribute(eventTs, fdValue, shs.getQuarkAbsolutePath(true, "OpenFDs", child_pid.toString(), "FDs", String.valueOf(fdValue), "fd"));
			shs.modifyAttribute(eventTs, fdType, shs.getQuarkAbsolutePath(true, "OpenFDs", child_pid.toString(), "FDs", String.valueOf(fdValue), "type"));
			if (fdType == FILEFD) {
				 int filenameIntValue = shs.getCurrentStateValueInt(shs.getQuarkRelativePath(true, quarkArray.get(i), "filename"));
				 if (filenameIntValue >= 0) {
					 shs.modifyAttribute(eventTs, filenameIntValue, shs.getQuarkAbsolutePath(true, "OpenFDs", child_pid.toString(), "FDs", String.valueOf(fdValue), "filename"));
				 }
				 if (PidFdFsm.containsKey(child_pid))
					fileOperations = PidFdFsm.get(child_pid);
				else
					fileOperations = new HashMap<Long, FileOperationList>();
				fileOperations.put((long) fdValue, new FileOperationList());
				PidFdFsm.put(child_pid, fileOperations);
				 
			} else if (fdType == NETWORKFD) {
				 int filenameIntValue = shs.getCurrentStateValueInt(shs.getQuarkRelativePath(true, quarkArray.get(i), "socket"));
				 if (filenameIntValue >= 0) {
					 shs.modifyAttribute(eventTs, filenameIntValue, shs.getQuarkAbsolutePath(true, "OpenFDs", child_pid.toString(), "FDs", String.valueOf(fdValue), "socket"));
				 }
				if (PidFdNetFsm.containsKey(child_pid))
					netOperations = PidFdNetFsm.get(child_pid);
				else
					netOperations = new HashMap<Long, NetworkOperationList>();
				netOperations.put((long) fdValue, new NetworkOperationList(eventTs));
				PidFdNetFsm.put(child_pid, netOperations);
			} else { /* This is a PIPE fd */
				int filenameIntValue = shs.getCurrentStateValueInt(shs.getQuarkRelativePath(true, quarkArray.get(i), "pipe"));
				 if (filenameIntValue >= 0) {
					 shs.modifyAttribute(eventTs, filenameIntValue, shs.getQuarkAbsolutePath(true, "OpenFDs", child_pid.toString(), "FDs", String.valueOf(fdValue), "pipe"));
				 }
			}

			//if (filenameIntValue < 0){
			//	System.out.print("SHOULDN'T REACH HERE! unknown fd name");
			//}
		}
		/*if (shs == null)
			return;
		pidNode = shs.getQuarkAbsolutePath(true, "Threads", currentProcessName,"ChildrenCount");
		if (pidNode < 0) return;
		shs.incrementAttribute(eventTs, pidNode);

		if (SHMAlerter.getStatus()){
			currStateValueInt = shs.getCurrentStateValueInt(pidNode);
			if (currStateValueInt == PRE_DEFINED_FORK_MAX_ALLOWED_VALUE1) SHMAlerter.sendMessage("1;"+"10"+";132.207.72.24;3128;132.207.72.25;80;"+now("yyyy-MM-dd")+";"+now("HH:mm:ss")+";");
			if (currStateValueInt == PRE_DEFINED_FORK_MAX_ALLOWED_VALUE2) SHMAlerter.sendMessage("1;"+"30"+";132.207.72.24;3128;132.207.72.25;80;"+now("yyyy-MM-dd")+";"+now("HH:mm:ss")+";");
			if (currStateValueInt == PRE_DEFINED_FORK_MAX_ALLOWED_VALUE3) SHMAlerter.sendMessage("1;"+"50"+";132.207.72.24;3128;132.207.72.25;80;"+now("yyyy-MMdd")+";"+now("HH:mm:ss")+";");
			if (currStateValueInt == PRE_DEFINED_FORK_MAX_ALLOWED_VALUE4) SHMAlerter.sendMessage("1;"+"75"+";132.207.72.24;3128;132.207.72.25;80;"+now("yyyy-MM-dd")+";"+now("HH:mm:ss")+";");
			if (currStateValueInt == PRE_DEFINED_FORK_MAX_ALLOWED_VALUE5) SHMAlerter.sendMessage("1;"+"100"+";132.207.72.24;3128;132.207.72.25;80;"+now("yyyy-MM-dd")+";"+now("HH:mm:ss")+";");
		}*/
		
	}
	public void handle_kernel_process_exit(TraceReader reader, JniEvent event) {
		Long currentProcessID = 0l;
		String currentProcessName = "";
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc != null){
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}
		
		Long pid = (Long) event.parseFieldByName("pid");

		if (currentTask.containsKey(currentProcessID))
			currentTask.get(currentProcessID).setField(Field.PID, pid);
		
		
	}
	
	public void handle_kernel_process_wait(TraceReader reader, JniEvent event) {
		Long currentProcessID = 0l;
		String currentProcessName = "";
		Long cpu = event.getParentTracefile().getCpuNumber();
		TraceEventHandlerProcess processHandler = (TraceEventHandlerProcess) reader.getHandler(TraceEventHandlerProcess.class);
		if (processHandler != null) {
			KernelProcess proc = processHandler.getCurrentProcess(cpu);
			if (proc != null){
				currentProcessID = proc.getPid();
				currentProcessName = proc.getCmd();
			}
		}
		
		
		
		Long pid = (Long) event.parseFieldByName("pid");

		if (currentTask.containsKey(currentProcessID))
			currentTask.get(currentProcessID).setField(Field.PID, pid);
		
	}
	
	
	public static String now(String format) {
		    Calendar cal = Calendar.getInstance();
		    SimpleDateFormat sdf = new SimpleDateFormat(format);
		    return sdf.format(cal.getTime());
	}
	
	@Override
	public void handleComplete(TraceReader reader) {

		try {
			level1Out.close();
			level2Out.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		snodeList.size();
		
		
		
		
		
		
		
		
		
		/*
		Collections.sort(sortedDurations);
		for( int  i= 0; i < sortedDurations.size(); i++ )
        {
			try {
				//System.out.println(sortedDurations.get(i));
				sortedArrayOut.write(sortedDurations.get(i).toString());
				sortedArrayOut.newLine();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			
        }
		*/
		
		
		int i = 0;
		
		
		
		
		
		
		
		
		/*for (Integer entry: snodeList.keySet()){
			if (entry != 22027)
				continue;
			snodeTime = snodeList.get(entry);
			for (Long snodeEntry: snodeTime.keySet()){
				System.out.println(i+": "  +snodeTime.get(snodeEntry)+", snodeEntry: "+snodeEntry + shs.getAttributeName(snodeTime.get(snodeEntry).getOperand1Id())+" ");
				if (snodeTime.get(snodeEntry).getParent() != null)
					System.out.println("Parent: " + snodeTime.get(snodeEntry).getParent().toString());
				if (snodeTime.get(snodeEntry).getChildren() != null)
					System.out.println("Children: " + snodeTime.get(snodeEntry).getChildren().toString());
				if (snodeTime.get(snodeEntry).getstartTimeofChildren() != null)
					System.out.println("Children from " + snodeTime.get(snodeEntry).getstartTimeofChildren() + " to "+ snodeTime.get(snodeEntry).getendTimeofChildren());
				i ++;
			}
		}*/
		
		//FIXME: here we should handle open and running FSMs
		
		/*Iterator i = PidFdFsm.entrySet().iterator();

		while (i.hasNext()) {
			
			
		}
		
		for (Treemap.Entry<Long, HashMap<Long, FileOperationList>> entry : PidFdFsm.entrySet()) {
			 	currentProcessID = (long) entry.getKey(); 
		               + " and value is " + entry.getValue());
		    }

		if (PidFdFsm.containsKey(currentProcessID))
			fileOperations = PidFdFsm.get(currentProcessID);
		else
			fileOperations = new HashMap<Long, FileOperationList>();
		
		if (fileOperations.containsKey((long)fd))
			fileOpList = fileOperations.get((long)fd);
		else
				fileOpList = new FileOperationList();

		fileOpList.getFSM().close();
		fileOpList.getFSM().afterClose();
		fileOperations.put((long)fd, fileOpList);
		PidFdFsm.put(currentProcessID, fileOperations);
		System.out.println("ts: "+fileOpList.getFSM().getStartingTs()+", filename: "+fileOpList.getFSM().getFilename());
		int operationQuark = shs.getQuarkAbsolutePath(true, "Level0", "Threads", currentProcessID.toString(), "Ops", "File", "FDs", obj.toString());
		shs.modifyAttribute(fileOpList.getFSM().getStartingTs(), fileOpList.getFSM().getSyntheticeventName(), operationQuark);
		shs.removeAttribute(end, operationQuark);
		System.out.println("file: pid: " + currentProcessID + ", start= " + fileOpList.getFSM().getStartingTs()+",end= " + end + ", event no= " + fileOpList.getFSM().getSyntheticeventName() + ", fd= " + fd);				
		shs.incrementAttribute(eventTs, shs.getQuarkAbsolutePath(true, "Level0", "Threads", currentProcessID.toString(), "Statistics"));
		shs.incrementAttribute(eventTs, shs.getQuarkAbsolutePath(true, "Level0", "Threads", currentProcessID.toString(), "Statistics", String.valueOf(fileOpList.getFSM().getSyntheticeventName())));
		*/
		
		
		
		
		
		
		
		
		/*pidNode = shs.getQuarkAbsolutePath(false, "Threads","15139","EventName");
		shs.modifyAttribute(2230887846300271l,10,pidNode);
		shs.removeAttribute(end,pidNode);
		pidNode = shs.getQuarkAbsolutePath(false, "Threads","15139","OperationType");
		shs.modifyAttribute(2230887846300271l,11,pidNode);
		shs.removeAttribute(end,pidNode);*/
		
		/*shs.closeTree();
		ArrayList<Integer> quarkArray;
		ArrayList<Integer> subQuarkArray;
		pidNode = shs.getQuarkAbsolutePath(false, "Threads");
		int childrenCount = shs.getSubAttributesCount(pidNode);
		if (childrenCount > 0){
			quarkArray = shs.getSubAttributes (pidNode);
			for(int i=0; i<quarkArray.size(); i++){
				int ccount =shs.getSubAttributesCount(quarkArray.get(i));
				//quarkArray = shs.getSubAttributes(pidNode);
				subQuarkArray = shs.getSubAttributes(quarkArray.get(i));
				//if (ccount > 0){
					for (int icc=0; icc<ccount; icc++){
						int dd = subQuarkArray.get(icc);
						int svInt = shs.getSingleStateValueInt(start, dd);
						//if (!svInt.isNull())
						System.out.println(svInt);
						 //Get the following state changes 
						long ts = shs.getNextStateChange(start, dd);
						while ( ts != -1 && ts <= end ) {
							ts++;
							svInt = shs.getSingleStateValueInt(ts, dd);
							//sv = shs.getSingleStateValue(ts, dd);
							//if (!sv.isNull())
								System.out.println(ts+": "+svInt);
							ts = shs.getNextStateChange(ts, dd);
						}
					}
				//}
			}
		}*/
		
		System.out.println("total interval count= "+countl);
		shs.closeTree(end);
		
		/*try {
			this.shs.debugPrint(new PrintWriter("/home/naser/workspace/ltt-abstractor-new/before_attrTree"));
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}*/
		//shs.debugPrint (new PrintWriter(System.out, true));
		//System.out.println("after closing the tree");
		//hp.debugPrint(new PrintWriter(System.out, true));
		//System.out.println(start);
		//System.out.println(end);*/
	}
	
	public  HashMap<Integer, TreeMap <String, ArrayList<TreeSet<Integer>>>>  getFilenameQuark(){
		return fileNetSymLinkQuarks;
	}
	
	public TreeMap<Long,HashMap<String,FileOperationList>> getFileOperationList(){
		return PidFilenameFileoperation;
	}

	public HashMap<Long, Set<SyntheticEvent>> getSyntheticEventList(){
		return syntheticevent;
	}
	
	public TreeMap<Long, EventtoStateMapper>  getEventMapper(){
		return eventMapper;
	}
	
	public HashMap<Integer, HashMap<Long, Snode>> getSnodeList(){
		return this.snodeList;
	}
	
	public String[][] getStateList(){
		return detection.getStateList();
	}
}
