package org.eclipse.linuxtools.lttng.SYSPRO.ui;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.GroupMarker;
import org.eclipse.jface.action.ICoolBarManager;
import org.eclipse.jface.action.IMenuManager;
import org.eclipse.jface.action.IToolBarManager;
import org.eclipse.jface.action.MenuManager;
import org.eclipse.jface.action.Separator;
import org.eclipse.jface.action.ToolBarContributionItem;
import org.eclipse.jface.action.ToolBarManager;
import org.eclipse.swt.SWT;
import org.eclipse.ui.IWorkbenchActionConstants;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.actions.ActionFactory;
import org.eclipse.ui.actions.ActionFactory.IWorkbenchAction;
import org.eclipse.ui.application.ActionBarAdvisor;
import org.eclipse.ui.application.IActionBarConfigurer;

/**
 * An action bar advisor is responsible for creating, adding, and disposing of the
 * actions added to a workbench window. Each window will be populated with
 * new actions.
 */
public class ApplicationActionBarAdvisor extends ActionBarAdvisor {

    private IWorkbenchAction exitAction;
	private IWorkbenchAction open;

    private IWorkbenchAction addContactAction;

    // Actions - important to allocate these only in makeActions, and then use them
    // in the fill methods.  This ensures that the actions aren't recreated
    // when fillActionBars is called with FILL_PROXY.
//    private IWorkbenchAction exitAction;
//    private IWorkbenchAction aboutAction;
//    private IWorkbenchAction newWindowAction;
//    private OpenViewAction openViewAction;
//    private Action CIAPopupAction;
//    private Action ResourcePopupAction;
//    private Action ResourceValuePopupAction;
//    private Action VulnerabilityPopupAction;
//    private Action VulnerabilityEffectPopupAction;
//    private Action OnlineRiskIndexPopupAction;
    

    public ApplicationActionBarAdvisor(IActionBarConfigurer configurer) {
        super(configurer);
    }
    
    protected void makeActions(final IWorkbenchWindow window) {
        // Creates the actions and registers them.
        // Registering is needed to ensure that key bindings work.
        // The corresponding commands keybindings are defined in the plugin.xml file.
        // Registering also provides automatic disposal of the actions when
        // the window is closed.
    	
    	exitAction = ActionFactory.QUIT.create(window);
         register(exitAction);
         
       /* open = new OpenFileAction(window);
     	register(open);*/
     	
         /*
         addContactAction = new AddContactAction(window);
         AddContactAction.
         register(addContactAction);
         */
//        IWorkbenchAction exitAction = ActionFactory.QUIT.create(window);
//        register(exitAction);
//        
//        IWorkbenchAction aboutAction = ActionFactory.ABOUT.create(window);
//        register(aboutAction);
//        
//        IWorkbenchAction newWindowAction = ActionFactory.OPEN_NEW_WINDOW.create(window);
//        register(newWindowAction);
//        
//        OpenViewAction openViewAction = new OpenViewAction(window, "Open Another Message View", View.ID);
//        register(openViewAction);
        
    	        
//        ResourcePopupAction = new ResourcePopupAction("Resource", window);
//        register(ResourcePopupAction);
//        
//        ResourceValuePopupAction = new ResourceValuePopupAction("Resource Value", window);
//        register(ResourceValuePopupAction);
//        
//        VulnerabilityPopupAction = new VulnerabilityPopupAction("Vulnerability", window);
//        register(VulnerabilityPopupAction);
//        
//        VulnerabilityEffectPopupAction = new VulnerabilityEffectPopupAction("Vulnerability Effect", window);
//        register(VulnerabilityEffectPopupAction);
//        
//        OnlineRiskIndexPopupAction = new OnlineRiskIndexPopupAction("Online Risk Index", window);
//        register(OnlineRiskIndexPopupAction);
        
    }
    
    protected void fillMenuBar(IMenuManager menuBar) {
        MenuManager FileMenu = new MenuManager("&File", IWorkbenchActionConstants.M_FILE);
        //MenuManager helpMenu = new MenuManager("&Help", IWorkbenchActionConstants.M_HELP);
        
        menuBar.add(FileMenu);
        // Add a group marker indicating where action set menus will appear.
        menuBar.add(new GroupMarker(IWorkbenchActionConstants.MB_ADDITIONS));
       // menuBar.add(helpMenu);
        
        // Risk Assessment

        FileMenu.add(exitAction);

      

//        RiskAssessmentMenu.add(ResourcePopupAction);
//        RiskAssessmentMenu.add(ResourceValuePopupAction);
//        RiskAssessmentMenu.add(new Separator());
//        RiskAssessmentMenu.add(VulnerabilityPopupAction);
//        RiskAssessmentMenu.add(VulnerabilityEffectPopupAction);
//        RiskAssessmentMenu.add(new Separator());
//        RiskAssessmentMenu.add(OnlineRiskIndexPopupAction);

        
        // Help
        //helpMenu.add(aboutAction);
    }
    
    protected void fillCoolBar(ICoolBarManager coolBar) {
        IToolBarManager toolbar = new ToolBarManager(SWT.FLAT | SWT.RIGHT);
        coolBar.add(new ToolBarContributionItem(toolbar, "main"));   
        //toolbar.add(openViewAction);
        //toolbar.add(CIAPopupAction);
//        toolbar.add(ResourcePopupAction);
//        toolbar.add(ResourceValuePopupAction);
//        toolbar.add(VulnerabilityPopupAction);
//        toolbar.add(VulnerabilityEffectPopupAction);

        
    }
    
}
