package org.eclipse.linuxtools.lttng.SYSPRO.ui;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.resource.JFaceResources;
import org.eclipse.linuxtools.lttng.SYSPRO.Connection.Provider;
import org.eclipse.linuxtools.lttng.SYSPRO.Connection.Requester;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Link;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.part.ViewPart;

public class View extends ViewPart {

	public static final String ID = "org.eclipse.ui.tutorials.rcp.part3.view";
	
	public void createPartControl(Composite parent) {
		Composite top = new Composite(parent, SWT.NONE);
		GridLayout layout = new GridLayout();
		layout.marginHeight = 0;
		layout.marginWidth = 0;
		top.setLayout(layout);
		// top banner
		Composite banner = new Composite(top, SWT.NONE);
		banner.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_FILL, GridData.VERTICAL_ALIGN_BEGINNING, true, false));
		layout = new GridLayout();
		layout.marginHeight = 5;
		layout.marginWidth = 10;
		layout.numColumns = 2;
		banner.setLayout(layout);
		
		// setup bold font
		Font boldFont = JFaceResources.getFontRegistry().getBold(JFaceResources.DEFAULT_FONT);    
		
		Label l = new Label(banner, SWT.WRAP);
		l.setText("SYS-HEALTH-PRO");
		l.setFont(boldFont);
		l = new Label(banner, SWT.WRAP);
		l.setText("SYStem HEALTH monitoring and PROactive response activation project");
		
		l = new Label(banner, SWT.WRAP);
		l.setText("Version:");
		l.setFont(boldFont);
    
		final Link link = new Link(banner, SWT.NONE);
		link.setText("1.0");
		link.addSelectionListener(new SelectionAdapter() {    
			public void widgetSelected(SelectionEvent e) {
				MessageDialog.openInformation(getSite().getShell(), "Not Implemented", "Imagine the address book or a new message being created now.");
			}    
		});
    
		l = new Label(banner, SWT.WRAP);
		l.setText("Relased Date:");
		l.setFont(boldFont);
		l = new Label(banner, SWT.WRAP);
		l.setText("2011");
		// message contents
		Text text = new Text(top, SWT.MULTI | SWT.WRAP);
		text.setText("SYStem HEALTH monitoring and PROactive response activation project (SYS-HEALTH-PRO) continuously monitors the health of a multi-core distributed system so that :\n"+
						"- malicious or unauthorized activities can be detected handled properly\n"+
						"- appropriate strategies run to trigger proactive responses, prevent the problem growth and return system to the healthy mode\n");
		text.setLayoutData(new GridData(GridData.FILL_BOTH));
		
	}

	public void setFocus() {
	}
}
